=== modified file '.travis.yml'
--- .travis.yml	2019-01-28 23:51:14 +0000
+++ .travis.yml	2019-05-28 23:22:25 +0000
@@ -23,7 +23,7 @@
 install:
   - sudo apt install python-all-dev python3-all-dev subunit
   - travis_retry pip install -U setuptools
-  - travis_retry pip install -U pip coverage codecov flake8 testtools paramiko fastimport configobj cython testscenarios six docutils python-subunit dulwich $TEST_REQUIRE sphinx sphinx_epytext launchpadlib
+  - travis_retry pip install -U pip coverage codecov flake8 testtools paramiko fastimport configobj cython testscenarios six docutils python-subunit $TEST_REQUIRE sphinx sphinx_epytext launchpadlib patiencediff git+https://github.com/dulwich/dulwich
 
 after_success:
   - codecov

=== added file 'appveyor.yml'
--- appveyor.yml	1970-01-01 00:00:00 +0000
+++ appveyor.yml	2019-06-03 23:48:08 +0000
@@ -0,0 +1,92 @@
+environment:
+
+  matrix:
+
+    - PYTHON: "C:\\Python27"
+      PYTHON_VERSION: "2.7.x"
+      PYTHON_ARCH: "32"
+
+    - PYTHON: "C:\\Python27-x64"
+      PYTHON_VERSION: "2.7.x"
+      PYTHON_ARCH: "64"
+
+    - PYTHON: "C:\\Python34"
+      PYTHON_VERSION: "3.4.x"
+      PYTHON_ARCH: "32"
+
+    - PYTHON: "C:\\Python34-x64"
+      PYTHON_VERSION: "3.4.x"
+      PYTHON_ARCH: "64"
+      DISTUTILS_USE_SDK: "1"
+
+    - PYTHON: "C:\\Python35"
+      PYTHON_VERSION: "3.5.x"
+      PYTHON_ARCH: "32"
+
+    - PYTHON: "C:\\Python35-x64"
+      PYTHON_VERSION: "3.5.x"
+      PYTHON_ARCH: "64"
+
+    - PYTHON: "C:\\Python36"
+      PYTHON_VERSION: "3.6.x"
+      PYTHON_ARCH: "32"
+
+    - PYTHON: "C:\\Python36-x64"
+      PYTHON_VERSION: "3.6.x"
+      PYTHON_ARCH: "64"
+
+install:
+  # If there is a newer build queued for the same PR, cancel this one.
+  # The AppVeyor 'rollout builds' option is supposed to serve the same
+  # purpose but it is problematic because it tends to cancel builds pushed
+  # directly to master instead of just PR builds (or the converse).
+  # credits: JuliaLang developers.
+  - ps: if ($env:APPVEYOR_PULL_REQUEST_NUMBER -and $env:APPVEYOR_BUILD_NUMBER -ne ((Invoke-RestMethod `
+        https://ci.appveyor.com/api/projects/$env:APPVEYOR_ACCOUNT_NAME/$env:APPVEYOR_PROJECT_SLUG/history?recordsNumber=50).builds | `
+        Where-Object pullRequestId -eq $env:APPVEYOR_PULL_REQUEST_NUMBER)[0].buildNumber) { `
+          throw "There are newer queued builds for this pull request, failing early." }
+  - ECHO "Filesystem root:"
+  - ps: "ls \"C:/\""
+
+  - ECHO "Installed SDKs:"
+  - ps: "ls \"C:/Program Files/Microsoft SDKs/Windows\""
+
+  # Install Python (from the official .msi of http://python.org) and pip when
+  # not already installed.
+  - ps: if (-not(Test-Path($env:PYTHON))) { & appveyor\install.ps1 }
+
+  # Prepend newly installed Python to the PATH of this build (this cannot be
+  # done from inside the powershell script as it would require to restart
+  # the parent CMD process).
+  - "SET PATH=%PYTHON%;%PYTHON%\\Scripts;%PATH%"
+
+  # Check that we have the expected version and architecture for Python
+  - "build.cmd %PYTHON%\\python.exe --version"
+  - "build.cmd %PYTHON%\\python.exe -c \"import struct; print(struct.calcsize('P') * 8)\""
+
+  # Install setuptools/wheel so that we can e.g. use bdist_wheel
+  - "pip install setuptools wheel"
+  # Install cython so we can build C extensions
+  - "pip install cython"
+
+  - "build.cmd %PYTHON%\\python.exe setup.py develop"
+
+  - "pip install launchpadlib pygithub patiencediff"
+
+build_script:
+  # Build the compiled extension
+  - "build.cmd %PYTHON%\\python.exe setup.py build"
+
+test_script:
+  - "build.cmd %PYTHON%\\python.exe setup.py test"
+  - "build.cmd %PYTHON%\\pythonw.exe setup.py test"
+
+after_test:
+  - "build.cmd %PYTHON%\\python.exe setup.py bdist_wheel"
+  # http://stackoverflow.com/questions/43255455/unicode-character-causing-error-with-bdist-wininst-on-python-3-but-not-python-2
+  # - "python setup.py bdist_wininst"
+  - "build.cmd %PYTHON%\\python.exe setup.py bdist_msi"
+  - ps: "ls dist"
+
+artifacts:
+  - path: dist\*

=== modified file 'breezy/_annotator_py.py'
--- breezy/_annotator_py.py	2018-11-11 03:33:20 +0000
+++ breezy/_annotator_py.py	2019-03-02 21:46:18 +0000
@@ -20,10 +20,12 @@
 
 from .lazy_import import lazy_import
 lazy_import(globals(), """
+
+import patiencediff
+
 from breezy import (
     annotate, # Must be lazy to avoid circular importing
     graph as _mod_graph,
-    patiencediff,
     )
 """)
 from . import (

=== removed file 'breezy/_patiencediff_c.c'
--- breezy/_patiencediff_c.c	2019-01-27 18:53:46 +0000
+++ breezy/_patiencediff_c.c	1970-01-01 00:00:00 +0000
@@ -1,1204 +0,0 @@
-/*
- Copyright (C) 2007, 2010 Canonical Ltd
-
- This program is free software; you can redistribute it and/or modify
- it under the terms of the GNU General Public License as published by
- the Free Software Foundation; either version 2 of the License, or
- (at your option) any later version.
-
- This program is distributed in the hope that it will be useful,
- but WITHOUT ANY WARRANTY; without even the implied warranty of
- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- GNU General Public License for more details.
-
- You should have received a copy of the GNU General Public License
- along with this program; if not, write to the Free Software
- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
- Function equate_lines based on bdiff.c from Mercurial.
-   Copyright (C) 2005, 2006 Matt Mackall <mpm@selenic.com>
-
- Functions unique_lcs/recurse_matches based on _patiencediff_py.py.
-   Copyright (C) 2005 Bram Cohen, Copyright (C) 2005, 2006 Canonical Ltd
-*/
-
-
-#include <stdlib.h>
-#include <string.h>
-#include <Python.h>
-
-#include "python-compat.h"
-
-
-#if defined(__GNUC__)
-#   define inline __inline__
-#elif defined(_MSC_VER)
-#   define inline __inline
-#else
-#   define inline
-#endif
-
-
-#define MIN(a, b) (((a) > (b)) ? (b) : (a))
-#define MAX(a, b) (((a) > (b)) ? (a) : (b))
-
-
-#define SENTINEL -1
-
-
-enum {
-    OP_EQUAL = 0,
-    OP_INSERT,
-    OP_DELETE,
-    OP_REPLACE
-};
-
-
-/* values from this array need to correspont to the order of the enum above */
-static char *opcode_names[] = {
-    "equal",
-    "insert",
-    "delete",
-    "replace",
-};
-
-
-struct line {
-    long hash;         /* hash code of the string/object */
-    Py_ssize_t next;   /* next line from the same equivalence class */
-    Py_ssize_t equiv;  /* equivalence class */
-    PyObject *data;
-};
-
-
-struct bucket {
-    Py_ssize_t a_head;  /* first item in `a` from this equivalence class */
-    Py_ssize_t a_count;
-    Py_ssize_t b_head;  /* first item in `b` from this equivalence class */
-    Py_ssize_t b_count;
-    Py_ssize_t a_pos;
-    Py_ssize_t b_pos;
-};
-
-
-struct hashtable {
-    Py_ssize_t last_a_pos;
-    Py_ssize_t last_b_pos;
-    Py_ssize_t size;
-    struct bucket *table;
-};
-
-struct matching_line {
-    Py_ssize_t a;     /* index of the line in `a` */
-    Py_ssize_t b;     /* index of the line in `b` */
-};
-
-
-struct matching_block {
-    Py_ssize_t a;     /* index of the first line in `a` */
-    Py_ssize_t b;     /* index of the first line in `b` */
-    Py_ssize_t len;   /* length of the block */
-};
-
-
-struct matching_blocks {
-    struct matching_block *matches;
-    Py_ssize_t count;
-};
-
-
-struct opcode {
-    int tag;
-    Py_ssize_t i1;
-    Py_ssize_t i2;
-    Py_ssize_t j1;
-    Py_ssize_t j2;
-};
-
-
-typedef struct {
-    PyObject_HEAD
-    Py_ssize_t asize;
-    Py_ssize_t bsize;
-    struct line *a;
-    struct line *b;
-    struct hashtable hashtable;
-    Py_ssize_t *backpointers;
-} PatienceSequenceMatcher;
-
-
-static inline Py_ssize_t
-bisect_left(Py_ssize_t *list, Py_ssize_t item, Py_ssize_t lo, Py_ssize_t hi)
-{
-    while (lo < hi) {
-        Py_ssize_t mid = lo / 2 + hi / 2 + (lo % 2 + hi % 2) / 2;
-        if (list[mid] < item)
-            lo = mid + 1;
-        else
-            hi = mid;
-    }
-    return lo;
-}
-
-
-static inline int
-compare_lines(struct line *a, struct line *b)
-{
-    return ((a->hash != b->hash)
-            || PyObject_RichCompareBool(a->data, b->data, Py_EQ) == 0);
-}
-
-
-static inline int
-find_equivalence_class(struct bucket *hashtable, Py_ssize_t hsize,
-                       struct line *lines, struct line *ref_lines,
-                       Py_ssize_t i)
-{
-    Py_ssize_t j;
-    for (j = lines[i].hash & hsize; hashtable[j].b_head != SENTINEL; j = (j + 1) & hsize) {
-        if (!compare_lines(lines + i, ref_lines + hashtable[j].b_head)) {
-            break;
-        }
-    }
-    return j;
-}
-
-
-static int
-equate_lines(struct hashtable *result,
-             struct line *lines_a, struct line *lines_b,
-             Py_ssize_t asize, Py_ssize_t bsize)
-{
-    Py_ssize_t i, j, hsize;
-    struct bucket *hashtable;
-
-    /* check for overflow, we need the table to be at least bsize+1 */
-    if (bsize == PY_SSIZE_T_MAX) {
-        PyErr_SetNone(PyExc_OverflowError);
-        return 0;
-    }
-
-    /* build a hash table of the next highest power of 2 */
-    hsize = 1;
-    while (hsize < bsize + 1)
-        hsize *= 2;
-
-    /* can't be 0 */
-    hashtable = (struct bucket *)malloc(sizeof(struct bucket) * hsize);
-    if (hashtable == NULL) {
-        PyErr_NoMemory();
-        return 0;
-    }
-
-    /* initialise the hashtable */
-    for (i = 0; i < hsize; i++) {
-        hashtable[i].a_count = 0;
-        hashtable[i].b_count = 0;
-        hashtable[i].a_head = SENTINEL;
-        hashtable[i].b_head = SENTINEL;
-    }
-    hsize--;
-
-    /* add lines from lines_b to the hash table chains. iterating
-       backwards so the matching lines are sorted to the linked list
-       by the line number (because we are adding new lines to the
-       head of the list) */
-    for (i = bsize - 1; i >= 0; i--) {
-        /* find the first hashtable entry, which is either empty or contains
-           the same line as lines_b[i] */
-        j = find_equivalence_class(hashtable, hsize, lines_b, lines_b, i);
-
-        /* set the equivalence class */
-        lines_b[i].equiv = j;
-
-        /* add to the head of the equivalence class */
-        lines_b[i].next = hashtable[j].b_head;
-        hashtable[j].b_head = i;
-        hashtable[j].b_count++;
-    }
-
-    /* match items from lines_a to their equivalence class in lines_b.
-       again, iterating backwards for the right order of the linked lists */
-    for (i = asize - 1; i >= 0; i--) {
-        /* find the first hash entry, which is either empty or contains
-           the same line as lines_a[i] */
-        j = find_equivalence_class(hashtable, hsize, lines_a, lines_b, i);
-
-        /* set the equivalence class, even if we are not interested in this
-           line, because the values are not pre-filled */
-        lines_a[i].equiv = j;
-
-        /* we are not interested in lines which are not also in lines_b */
-        if (hashtable[j].b_head == SENTINEL)
-            continue;
-
-        /* add to the head of the equivalence class */
-        lines_a[i].next = hashtable[j].a_head;
-        hashtable[j].a_head = i;
-        hashtable[j].a_count++;
-    }
-
-    result->last_a_pos = -1;
-    result->last_b_pos = -1;
-    result->size = hsize + 1;
-    result->table = hashtable;
-
-    return 1;
-}
-
-
-
-/* Finds longest common subsequence of unique lines in a[alo:ahi] and
-   b[blo:bhi].
-   Parameter backpointers must have allocated memory for at least
-   4 * (bhi - blo) ints. */
-Py_ssize_t
-unique_lcs(struct matching_line *answer,
-           struct hashtable *hashtable, Py_ssize_t *backpointers,
-           struct line *lines_a, struct line *lines_b,
-           Py_ssize_t alo, Py_ssize_t blo, Py_ssize_t ahi, Py_ssize_t bhi)
-{
-    Py_ssize_t i, k, equiv, apos, bpos, norm_apos, norm_bpos, bsize, stacksize;
-    Py_ssize_t *stacks, *lasts, *btoa;
-    struct bucket *h;
-
-    k = 0;
-    stacksize = 0;
-    bsize = bhi - blo;
-    h = hashtable->table;
-
-    /* "unpack" the allocated memory */
-    stacks = backpointers + bsize;
-    lasts = stacks + bsize;
-    btoa = lasts + bsize;
-
-    /* initialise the backpointers */
-    for (i = 0; i < bsize; i++)
-        backpointers[i] = SENTINEL;
-
-    if (hashtable->last_a_pos == -1 || hashtable->last_a_pos > alo)
-        for (i = 0; i < hashtable->size; i++)
-            h[i].a_pos = h[i].a_head;
-    hashtable->last_a_pos = alo;
-
-    if (hashtable->last_b_pos == -1 || hashtable->last_b_pos > blo)
-        for (i = 0; i < hashtable->size; i++)
-            h[i].b_pos = h[i].b_head;
-    hashtable->last_b_pos = blo;
-
-    for (bpos = blo; bpos < bhi; bpos++) {
-        equiv = lines_b[bpos].equiv;
-
-        /* no lines in a or b  */
-        if (h[equiv].a_count == 0 || h[equiv].b_count == 0)
-            continue;
-
-        /* find an unique line in lines_a that matches lines_b[bpos]
-           if we find more than one line within the range alo:ahi,
-           jump to the next line from lines_b immediately */
-        apos = SENTINEL;
-        /* loop through all lines in the linked list */
-        for (i = h[equiv].a_pos; i != SENTINEL; i = lines_a[i].next) {
-            /* the index is lower than alo, continue to the next line */
-            if (i < alo) {
-                h[equiv].a_pos = i;
-                continue;
-            }
-            /* the index is higher than ahi, stop searching */
-            if (i >= ahi)
-                break;
-            /* if the line is within our range, check if it's a duplicate */
-            if (apos != SENTINEL)
-                goto nextb;
-            /* save index to the line */
-            apos = i;
-        }
-        /* this line has no equivalent in lines_a[alo:ahi] */
-        if (apos == SENTINEL)
-            goto nextb;
-
-        /* check for duplicates of this line in lines_b[blo:bhi] */
-        /* loop through all lines in the linked list */
-        for (i = h[equiv].b_pos; i != SENTINEL; i = lines_b[i].next) {
-            /* the index is lower than blo, continue to the next line */
-            if (i < blo) {
-                h[equiv].b_pos = i;
-                continue;
-            }
-            /* the index is higher than bhi, stop searching */
-            if (i >= bhi)
-                break;
-            /* if this isn't the line with started with and it's within
-               our range, it's a duplicate */
-            if (i != bpos)
-                goto nextb;
-        }
-
-        /* use normalised indexes ([0,ahi-alo) instead of [alo,ahi))
-           for the patience sorting algorithm */
-        norm_bpos = bpos - blo;
-        norm_apos = apos - alo;
-        btoa[norm_bpos] = norm_apos;
-
-        /*
-        Ok, how does this work...
-
-        We have a list of matching lines from two lists, a and b. These
-        matches are stored in variable `btoa`. As we are iterating over this
-        table by bpos, the lines from b already form an increasing sequence.
-        We need to "sort" also the lines from a using the patience sorting
-        algorithm, ignoring the lines which would need to be swapped.
-
-          http://en.wikipedia.org/wiki/Patience_sorting
-
-        For each pair of lines, we need to place the line from a on either
-        an existing pile that has higher value on the top or create a new
-        pile. Variable `stacks` represents the tops of these piles and in
-        variable `lasts` we store the lines from b, that correspond to the
-        lines from a in `stacks`.
-
-        Whenever we place a new line on top of a pile, we store a
-        backpointer to the line (b) from top of the previous pile. This means
-        that after the loop, variable `backpointers` will contain an index
-        to the previous matching lines that forms an increasing sequence
-        (over both indexes a and b) with the current matching lines. If
-        either index a or b of the previous matching lines would be higher
-        than indexes of the current one or if the indexes of the current
-        one are 0, it will contain SENTINEL.
-
-        To construct the LCS, we will just need to follow these backpointers
-        from the top of the last pile and stop when we reach SENTINEL.
-        */
-
-        /* as an optimization, check if the next line comes at the end,
-           because it usually does */
-        if (stacksize && stacks[stacksize - 1] < norm_apos)
-            k = stacksize;
-        /* as an optimization, check if the next line comes right after
-           the previous line, because usually it does */
-        else if (stacksize && (stacks[k] < norm_apos) &&
-                 (k == stacksize - 1 || stacks[k + 1] > norm_apos))
-            k += 1;
-        else
-            k = bisect_left(stacks, norm_apos, 0, stacksize);
-
-        if (k > 0)
-            backpointers[norm_bpos] = lasts[k - 1];
-
-        if (k < stacksize) {
-            stacks[k] = norm_apos;
-            lasts[k] = norm_bpos;
-        }
-        else {
-            stacks[stacksize] = norm_apos;
-            lasts[stacksize] = norm_bpos;
-            stacksize += 1;
-        }
-
-
-nextb:
-        ;
-    }
-
-    if (stacksize == 0)
-        return 0;
-
-    /* backtrace the structures to find the LCS */
-    i = 0;
-    k = lasts[stacksize - 1];
-    while (k != SENTINEL) {
-        answer[i].a = btoa[k];
-        answer[i].b = k;
-        k = backpointers[k];
-        i++;
-    }
-
-    return i;
-}
-
-/* Adds a new line to the list of matching blocks, either extending the
-   current block or adding a new one. */
-static inline void
-add_matching_line(struct matching_blocks *answer, Py_ssize_t a, Py_ssize_t b)
-{
-    Py_ssize_t last_index = answer->count - 1;
-    if ((last_index >= 0) &&
-        (a == answer->matches[last_index].a +
-              answer->matches[last_index].len) &&
-        (b == answer->matches[last_index].b +
-              answer->matches[last_index].len)) {
-        /* enlarge the last block */
-        answer->matches[last_index].len++;
-    }
-    else {
-        /* create a new block */
-        last_index++;
-        answer->matches[last_index].a = a;
-        answer->matches[last_index].b = b;
-        answer->matches[last_index].len = 1;
-        answer->count++;
-    }
-}
-
-
-static int
-recurse_matches(struct matching_blocks *answer, struct hashtable *hashtable,
-                Py_ssize_t *backpointers, struct line *a, struct line *b,
-                Py_ssize_t alo, Py_ssize_t blo, Py_ssize_t ahi, Py_ssize_t bhi,
-                int maxrecursion)
-{
-    int res;
-    Py_ssize_t new, last_a_pos, last_b_pos, lcs_size, nahi, nbhi, i, apos, bpos;
-    struct matching_line *lcs;
-
-    if (maxrecursion < 0)
-        return 1;
-
-    if (alo == ahi || blo == bhi)
-        return 1;
-
-    new = 0;
-    last_a_pos = alo - 1;
-    last_b_pos = blo - 1;
-
-    lcs = (struct matching_line *)malloc(sizeof(struct matching_line) * (bhi - blo));
-    if (lcs == NULL)
-        return 0;
-
-    lcs_size = unique_lcs(lcs, hashtable, backpointers, a, b, alo, blo, ahi, bhi);
-
-    /* recurse between lines which are unique in each file and match */
-    for (i = lcs_size - 1; i >= 0; i--) {
-        apos = alo + lcs[i].a;
-        bpos = blo + lcs[i].b;
-        if (last_a_pos + 1 != apos || last_b_pos + 1 != bpos) {
-            res = recurse_matches(answer, hashtable,
-                                  backpointers, a, b,
-                                  last_a_pos + 1, last_b_pos + 1,
-                                  apos, bpos, maxrecursion - 1);
-            if (!res)
-                goto error;
-        }
-        last_a_pos = apos;
-        last_b_pos = bpos;
-        add_matching_line(answer, apos, bpos);
-        new = 1;
-    }
-
-    free(lcs);
-    lcs = NULL;
-
-    /* find matches between the last match and the end */
-    if (new > 0) {
-        res = recurse_matches(answer, hashtable,
-                              backpointers, a, b,
-                              last_a_pos + 1, last_b_pos + 1,
-                              ahi, bhi, maxrecursion - 1);
-        if (!res)
-            goto error;
-    }
-
-
-    /* find matching lines at the very beginning */
-    else if (a[alo].equiv == b[blo].equiv) {
-        while (alo < ahi && blo < bhi && a[alo].equiv == b[blo].equiv)
-            add_matching_line(answer, alo++, blo++);
-        res = recurse_matches(answer, hashtable,
-                              backpointers, a, b,
-                              alo, blo, ahi, bhi, maxrecursion - 1);
-        if (!res)
-            goto error;
-    }
-
-    /* find matching lines at the very end */
-    else if (a[ahi - 1].equiv == b[bhi - 1].equiv) {
-        nahi = ahi - 1;
-        nbhi = bhi - 1;
-        while (nahi > alo && nbhi > blo && a[nahi - 1].equiv == b[nbhi - 1].equiv) {
-            nahi--;
-            nbhi--;
-        }
-        res = recurse_matches(answer, hashtable,
-                              backpointers, a, b,
-                              last_a_pos + 1, last_b_pos + 1,
-                              nahi, nbhi, maxrecursion - 1);
-        if (!res)
-            goto error;
-        for (i = 0; i < ahi - nahi; i++)
-            add_matching_line(answer, nahi + i, nbhi + i);
-    }
-
-    return 1;
-
-error:
-    free(lcs);
-    return 0;
-}
-
-
-static void
-delete_lines(struct line *lines, Py_ssize_t size)
-{
-    struct line *line = lines;
-    while (size-- > 0) {
-        Py_XDECREF(line->data);
-        line++;
-    }
-    free(lines);
-}
-
-
-static Py_ssize_t
-load_lines(PyObject *orig, struct line **lines)
-{
-    Py_ssize_t size, i;
-    struct line *line;
-    PyObject *seq, *item;
-
-    seq = PySequence_Fast(orig, "sequence expected");
-    if (seq == NULL) {
-        return -1;
-    }
-
-    size = PySequence_Fast_GET_SIZE(seq);
-    if (size == 0) {
-        Py_DECREF(seq);
-        return 0;
-    }
-
-    /* Allocate a memory block for line data, initialized to 0 */
-    line = *lines = (struct line *)calloc(size, sizeof(struct line));
-    if (line == NULL) {
-        PyErr_NoMemory();
-        Py_DECREF(seq);
-        return -1;
-    }
-
-    for (i = 0; i < size; i++) {
-        item = PySequence_Fast_GET_ITEM(seq, i);
-        Py_INCREF(item);
-        line->data = item;
-        line->hash = PyObject_Hash(item);
-        if (line->hash == (-1)) {
-            /* Propogate the hash exception */
-            size = -1;
-            goto cleanup;
-        }
-        line->next = SENTINEL;
-        line++;
-    }
-
-    cleanup:
-    Py_DECREF(seq);
-    if (size == -1) {
-        /* Error -- cleanup unused object references */
-        delete_lines(*lines, i);
-        *lines = NULL;
-    }
-    return size;
-}
-
-
-static PyObject *
-py_unique_lcs(PyObject *self, PyObject *args)
-{
-    PyObject *aseq, *bseq, *res, *item;
-    Py_ssize_t asize, bsize, i, nmatches, *backpointers = NULL;
-    struct line *a = NULL, *b = NULL;
-    struct matching_line *matches = NULL;
-    struct hashtable hashtable;
-
-    if (!PyArg_ParseTuple(args, "OO", &aseq, &bseq))
-        return NULL;
-
-    hashtable.table = NULL;
-
-    asize = load_lines(aseq, &a);
-    bsize = load_lines(bseq, &b);
-    if (asize == -1 || bsize == -1)
-        goto error;
-
-    if (!equate_lines(&hashtable, a, b, asize, bsize))
-        goto error;
-
-    if (bsize > 0) {
-        matches = (struct matching_line *)malloc(sizeof(struct matching_line) * bsize);
-        if (matches == NULL)
-            goto error;
-
-        backpointers = (Py_ssize_t *)malloc(sizeof(Py_ssize_t) * bsize * 4);
-        if (backpointers == NULL)
-            goto error;
-    }
-
-    nmatches = unique_lcs(matches, &hashtable, backpointers, a, b, 0, 0, asize, bsize);
-
-    res = PyList_New(nmatches);
-    for (i = 0; i < nmatches; i++) {
-        item = Py_BuildValue("nn", matches[nmatches - i - 1].a, matches[nmatches - i - 1].b);
-        if (item == NULL)
-            goto error;
-        if (PyList_SetItem(res, i, item) != 0)
-            goto error;
-    }
-
-    free(backpointers);
-    free(matches);
-    free(hashtable.table);
-    delete_lines(b, bsize);
-    delete_lines(a, asize);
-    return res;
-
-error:
-    free(backpointers);
-    free(matches);
-    free(hashtable.table);
-    delete_lines(b, bsize);
-    delete_lines(a, asize);
-    return NULL;
-}
-
-
-static PyObject *
-py_recurse_matches(PyObject *self, PyObject *args)
-{
-    PyObject *aseq, *bseq, *item, *answer;
-    int maxrecursion, res;
-    Py_ssize_t i, j, asize, bsize, alo, blo, ahi, bhi;
-    Py_ssize_t *backpointers = NULL;
-    struct line *a = NULL, *b = NULL;
-    struct hashtable hashtable;
-    struct matching_blocks matches;
-
-    if (!PyArg_ParseTuple(args, "OOnnnnOi", &aseq, &bseq, &alo, &blo,
-                          &ahi, &bhi, &answer, &maxrecursion))
-        return NULL;
-
-    hashtable.table = NULL;
-    matches.matches = NULL;
-
-    asize = load_lines(aseq, &a);
-    bsize = load_lines(bseq, &b);
-    if (asize == -1 || bsize == -1)
-        goto error;
-
-    if (!equate_lines(&hashtable, a, b, asize, bsize))
-        goto error;
-
-    matches.count = 0;
-
-    if (bsize > 0) {
-        matches.matches = (struct matching_block *)malloc(sizeof(struct matching_block) * bsize);
-        if (matches.matches == NULL)
-            goto error;
-
-        backpointers = (Py_ssize_t *)malloc(sizeof(Py_ssize_t) * bsize * 4);
-        if (backpointers == NULL)
-            goto error;
-    } else {
-        matches.matches = NULL;
-        backpointers = NULL;
-    }
-
-    res = recurse_matches(&matches, &hashtable, backpointers,
-                          a, b, alo, blo, ahi, bhi, maxrecursion);
-    if (!res)
-        goto error;
-
-    for (i = 0; i < matches.count; i++) {
-        for (j = 0; j < matches.matches[i].len; j++) {
-            item = Py_BuildValue("nn", matches.matches[i].a + j,
-                                 matches.matches[i].b + j);
-            if (item == NULL)
-                goto error;
-            if (PyList_Append(answer, item) != 0)
-                goto error;
-        }
-    }
-
-    free(backpointers);
-    free(matches.matches);
-    free(hashtable.table);
-    delete_lines(b, bsize);
-    delete_lines(a, asize);
-    Py_RETURN_NONE;
-
-error:
-    free(backpointers);
-    free(matches.matches);
-    free(hashtable.table);
-    delete_lines(b, bsize);
-    delete_lines(a, asize);
-    return NULL;
-}
-
-
-static PyObject *
-PatienceSequenceMatcher_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
-{
-    PyObject *junk, *a, *b;
-    PatienceSequenceMatcher *self;
-
-    self = (PatienceSequenceMatcher *)type->tp_alloc(type, 0);
-    if (self != NULL) {
-
-        if (!PyArg_ParseTuple(args, "OOO", &junk, &a, &b)) {
-            Py_DECREF(self);
-            return NULL;
-        }
-
-        self->asize = load_lines(a, &(self->a));
-        self->bsize = load_lines(b, &(self->b));
-
-        if (self->asize == -1 || self->bsize == -1) {
-            Py_DECREF(self);
-            return NULL;
-        }
-
-        if (!equate_lines(&self->hashtable, self->a, self->b, self->asize, self->bsize)) {
-            Py_DECREF(self);
-            return NULL;
-        }
-
-        if (self->bsize > 0) {
-            self->backpointers = (Py_ssize_t *)malloc(sizeof(Py_ssize_t) * self->bsize * 4);
-            if (self->backpointers == NULL) {
-                Py_DECREF(self);
-                PyErr_NoMemory();
-                return NULL;
-            }
-        } else {
-            self->backpointers = NULL;
-        }
-
-    }
-
-    return (PyObject *)self;
-}
-
-
-static void
-PatienceSequenceMatcher_dealloc(PatienceSequenceMatcher* self)
-{
-    free(self->backpointers);
-    free(self->hashtable.table);
-    delete_lines(self->b, self->bsize);
-    delete_lines(self->a, self->asize);
-    ((PyObject *)self)->ob_type->tp_free((PyObject *)self);
-}
-
-
-static char PatienceSequenceMatcher_get_matching_blocks_doc[] =
-    "Return list of triples describing matching subsequences.\n"
-    "\n"
-    "Each triple is of the form (i, j, n), and means that\n"
-    "a[i:i+n] == b[j:j+n].  The triples are monotonically increasing in\n"
-    "i and in j.\n"
-    "\n"
-    "The last triple is a dummy, (len(a), len(b), 0), and is the only\n"
-    "triple with n==0.\n"
-    "\n"
-    ">>> s = PatienceSequenceMatcher(None, \"abxcd\", \"abcd\")\n"
-    ">>> s.get_matching_blocks()\n"
-    "[(0, 0, 2), (3, 2, 2), (5, 4, 0)]\n";
-
-static PyObject *
-PatienceSequenceMatcher_get_matching_blocks(PatienceSequenceMatcher* self)
-{
-    PyObject *answer, *item;
-    int res;
-    Py_ssize_t i;
-    struct matching_blocks matches;
-
-    matches.count = 0;
-    if (self->bsize > 0) {
-        matches.matches = (struct matching_block *)
-            malloc(sizeof(struct matching_block) * self->bsize);
-        if (matches.matches == NULL)
-            return PyErr_NoMemory();
-    } else
-        matches.matches = NULL;
-
-    res = recurse_matches(&matches, &self->hashtable, self->backpointers,
-                          self->a, self->b, 0, 0,
-                          self->asize, self->bsize, 10);
-    if (!res) {
-        free(matches.matches);
-        return PyErr_NoMemory();
-    }
-
-    answer = PyList_New(matches.count + 1);
-    if (answer == NULL) {
-        free(matches.matches);
-        return NULL;
-    }
-
-    for (i = 0; i < matches.count; i++) {
-        item = Py_BuildValue("nnn", matches.matches[i].a,
-                             matches.matches[i].b, matches.matches[i].len);
-        if (item == NULL)
-            goto error;
-        if (PyList_SetItem(answer, i, item) != 0)
-            goto error;
-    }
-    item = Py_BuildValue("nnn", self->asize, self->bsize, 0);
-    if (item == NULL)
-        goto error;
-    if (PyList_SetItem(answer, i, item) != 0)
-        goto error;
-
-    free(matches.matches);
-    return answer;
-
-error:
-    free(matches.matches);
-    Py_DECREF(answer);
-    return NULL;
-}
-
-
-static char PatienceSequenceMatcher_get_opcodes_doc[] =
-    "Return list of 5-tuples describing how to turn a into b.\n"
-    "\n"
-    "Each tuple is of the form (tag, i1, i2, j1, j2).  The first tuple\n"
-    "has i1 == j1 == 0, and remaining tuples have i1 == the i2 from the\n"
-    "tuple preceding it, and likewise for j1 == the previous j2.\n"
-    "\n"
-    "The tags are strings, with these meanings:\n"
-    "\n"
-    "'replace':  a[i1:i2] should be replaced by b[j1:j2]\n"
-    "'delete':   a[i1:i2] should be deleted.\n"
-    "               Note that j1==j2 in this case.\n"
-    "'insert':   b[j1:j2] should be inserted at a[i1:i1].\n"
-    "               Note that i1==i2 in this case.\n"
-    "'equal':    a[i1:i2] == b[j1:j2]\n"
-    "\n"
-    ">>> a = \"qabxcd\"\n"
-    ">>> b = \"abycdf\"\n"
-    ">>> s = PatienceSequenceMatcher(None, a, b)\n"
-    ">>> for tag, i1, i2, j1, j2 in s.get_opcodes():\n"
-    "...    print (\"%7s a[%d:%d] (%s) b[%d:%d] (%s)\" %\n"
-    "...           (tag, i1, i2, a[i1:i2], j1, j2, b[j1:j2]))\n"
-    " delete a[0:1] (q) b[0:0] ()\n"
-    "  equal a[1:3] (ab) b[0:2] (ab)\n"
-    "replace a[3:4] (x) b[2:3] (y)\n"
-    "  equal a[4:6] (cd) b[3:5] (cd)\n"
-    " insert a[6:6] () b[5:6] (f)\n";
-
-static PyObject *
-PatienceSequenceMatcher_get_opcodes(PatienceSequenceMatcher* self)
-{
-    PyObject *answer, *item;
-    Py_ssize_t i, j, k, ai, bj;
-    int tag, res;
-    struct matching_blocks matches;
-
-    matches.count = 0;
-    matches.matches = (struct matching_block *)malloc(sizeof(struct matching_block) * (self->bsize + 1));
-    if (matches.matches == NULL)
-        return PyErr_NoMemory();
-
-    res = recurse_matches(&matches, &self->hashtable, self->backpointers,
-                          self->a, self->b, 0, 0,
-                          self->asize, self->bsize, 10);
-    if (!res) {
-        free(matches.matches);
-        return PyErr_NoMemory();
-    }
-
-    matches.matches[matches.count].a = self->asize;
-    matches.matches[matches.count].b = self->bsize;
-    matches.matches[matches.count].len = 0;
-    matches.count++;
-
-    answer = PyList_New(0);
-    if (answer == NULL) {
-        free(matches.matches);
-        return NULL;
-    }
-
-    i = j = 0;
-    for (k = 0; k < matches.count; k++) {
-        ai = matches.matches[k].a;
-        bj = matches.matches[k].b;
-
-        tag = -1;
-        if (i < ai && j < bj)
-            tag = OP_REPLACE;
-        else if (i < ai)
-            tag = OP_DELETE;
-        else if (j < bj)
-            tag = OP_INSERT;
-
-        if (tag != -1) {
-            item = Py_BuildValue("snnnn", opcode_names[tag], i, ai, j, bj);
-            if (item == NULL)
-                goto error;
-            if (PyList_Append(answer, item) != 0)
-                goto error;
-        }
-
-        i = ai + matches.matches[k].len;
-        j = bj + matches.matches[k].len;
-
-        if (matches.matches[k].len > 0) {
-            item = Py_BuildValue("snnnn", opcode_names[OP_EQUAL], ai, i, bj, j);
-            if (item == NULL)
-                goto error;
-            if (PyList_Append(answer, item) != 0)
-                goto error;
-        }
-    }
-
-    free(matches.matches);
-    return answer;
-
-error:
-    free(matches.matches);
-    Py_DECREF(answer);
-    return NULL;
-}
-
-
-static char PatienceSequenceMatcher_get_grouped_opcodes_doc[] =
-    "Isolate change clusters by eliminating ranges with no changes.\n"
-    "\n"
-    "Return a list of groups with up to n lines of context.\n"
-    "Each group is in the same format as returned by get_opcodes().\n"
-    "\n"
-    ">>> from pprint import pprint\n"
-    ">>> a = map(str, range(1,40))\n"
-    ">>> b = a[:]\n"
-    ">>> b[8:8] = ['i']     # Make an insertion\n"
-    ">>> b[20] += 'x'       # Make a replacement\n"
-    ">>> b[23:28] = []      # Make a deletion\n"
-    ">>> b[30] += 'y'       # Make another replacement\n"
-    ">>> pprint(PatienceSequenceMatcher(None,a,b).get_grouped_opcodes())\n"
-    "[[('equal', 5, 8, 5, 8), ('insert', 8, 8, 8, 9), ('equal', 8, 11, 9, 12)],\n"
-    " [('equal', 16, 19, 17, 20),\n"
-    "  ('replace', 19, 20, 20, 21),\n"
-    "  ('equal', 20, 22, 21, 23),\n"
-    "  ('delete', 22, 27, 23, 23),\n"
-    "  ('equal', 27, 30, 23, 26)],\n"
-    " [('equal', 31, 34, 27, 30),\n"
-    "  ('replace', 34, 35, 30, 31),\n"
-    "  ('equal', 35, 38, 31, 34)]]\n";
-
-static PyObject *
-PatienceSequenceMatcher_get_grouped_opcodes(PatienceSequenceMatcher* self,
-                                            PyObject *args)
-{
-    PyObject *answer, *group, *item;
-    Py_ssize_t i, j, k, ai, bj, size, ncodes, tag;
-    Py_ssize_t i1, i2, j1, j2;
-    int n = 3, nn, res;
-    struct matching_blocks matches;
-    struct opcode *codes;
-
-    if (!PyArg_ParseTuple(args, "|i", &n))
-        return NULL;
-
-    matches.count = 0;
-    matches.matches = (struct matching_block *)malloc(sizeof(struct matching_block) * (self->bsize + 1));
-    if (matches.matches == NULL)
-        return PyErr_NoMemory();
-
-    res = recurse_matches(&matches, &self->hashtable, self->backpointers,
-                          self->a, self->b, 0, 0,
-                          self->asize, self->bsize, 10);
-    if (!res) {
-        free(matches.matches);
-        return PyErr_NoMemory();
-    }
-
-    matches.matches[matches.count].a = self->asize;
-    matches.matches[matches.count].b = self->bsize;
-    matches.matches[matches.count].len = 0;
-    matches.count++;
-
-    ncodes = 0;
-    codes = (struct opcode *)malloc(sizeof(struct opcode) * matches.count * 2);
-    if (codes == NULL) {
-        free(matches.matches);
-        return PyErr_NoMemory();
-    }
-
-    i = j = 0;
-    for (k = 0; k < matches.count; k++) {
-        ai = matches.matches[k].a;
-        bj = matches.matches[k].b;
-
-        tag = -1;
-        if (i < ai && j < bj)
-            tag = OP_REPLACE;
-        else if (i < ai)
-            tag = OP_DELETE;
-        else if (j < bj)
-            tag = OP_INSERT;
-
-        if (tag != -1) {
-            codes[ncodes].tag = tag;
-            codes[ncodes].i1 = i;
-            codes[ncodes].i2 = ai;
-            codes[ncodes].j1 = j;
-            codes[ncodes].j2 = bj;
-            ncodes++;
-        }
-
-        i = ai + matches.matches[k].len;
-        j = bj + matches.matches[k].len;
-
-        if (matches.matches[k].len > 0) {
-            codes[ncodes].tag = OP_EQUAL;
-            codes[ncodes].i1 = ai;
-            codes[ncodes].i2 = i;
-            codes[ncodes].j1 = bj;
-            codes[ncodes].j2 = j;
-            ncodes++;
-        }
-    }
-
-    if (ncodes == 0) {
-        codes[ncodes].tag = OP_EQUAL;
-        codes[ncodes].i1 = 0;
-        codes[ncodes].i2 = 1;
-        codes[ncodes].j1 = 0;
-        codes[ncodes].j2 = 1;
-        ncodes++;
-    }
-
-    /* fixup leading and trailing groups if they show no changes. */
-    if (codes[0].tag == OP_EQUAL) {
-        codes[0].i1 = MAX(codes[0].i1, codes[0].i2 - n);
-        codes[0].j1 = MAX(codes[0].j1, codes[0].j2 - n);
-    }
-    if (codes[ncodes - 1].tag == OP_EQUAL) {
-        codes[ncodes - 1].i2 = MIN(codes[ncodes - 1].i2,
-                                   codes[ncodes - 1].i1 + n);
-        codes[ncodes - 1].j2 = MIN(codes[ncodes - 1].j2,
-                                   codes[ncodes - 1].j1 + n);
-    }
-
-    group = NULL;
-
-    answer = PyList_New(0);
-    if (answer == NULL)
-        goto error;
-
-    group = PyList_New(0);
-    if (group == NULL)
-        goto error;
-
-    nn = n + n;
-    tag = -1;
-    for (i = 0; i < ncodes; i++) {
-        tag = codes[i].tag;
-        i1 = codes[i].i1;
-        i2 = codes[i].i2;
-        j1 = codes[i].j1;
-        j2 = codes[i].j2;
-        /* end the current group and start a new one whenever
-           there is a large range with no changes. */
-        if (tag == OP_EQUAL && i2 - i1 > nn) {
-            item = Py_BuildValue("snnnn", opcode_names[tag],
-                                  i1, MIN(i2, i1 + n), j1, MIN(j2, j1 + n));
-            if (item == NULL)
-                goto error;
-            if (PyList_Append(group, item) != 0)
-                goto error;
-            if (PyList_Append(answer, group) != 0)
-                goto error;
-            group = PyList_New(0);
-            if (group == NULL)
-                goto error;
-            i1 = MAX(i1, i2 - n);
-            j1 = MAX(j1, j2 - n);
-        }
-        item = Py_BuildValue("snnnn", opcode_names[tag], i1, i2, j1 ,j2);
-        if (item == NULL)
-            goto error;
-        if (PyList_Append(group, item) != 0)
-            goto error;
-    }
-    size = PyList_Size(group);
-    if (size > 0 && !(size == 1 && tag == OP_EQUAL)) {
-        if (PyList_Append(answer, group) != 0)
-            goto error;
-    }
-    else
-        Py_DECREF(group);
-
-    free(codes);
-    free(matches.matches);
-    return answer;
-
-error:
-    free(codes);
-    free(matches.matches);
-    Py_DECREF(group);
-    Py_DECREF(answer);
-    return NULL;
-}
-
-
-static PyMethodDef PatienceSequenceMatcher_methods[] = {
-    {"get_matching_blocks",
-     (PyCFunction)PatienceSequenceMatcher_get_matching_blocks,
-     METH_NOARGS,
-     PatienceSequenceMatcher_get_matching_blocks_doc},
-    {"get_opcodes",
-     (PyCFunction)PatienceSequenceMatcher_get_opcodes,
-     METH_NOARGS,
-     PatienceSequenceMatcher_get_opcodes_doc},
-    {"get_grouped_opcodes",
-     (PyCFunction)PatienceSequenceMatcher_get_grouped_opcodes,
-     METH_VARARGS,
-     PatienceSequenceMatcher_get_grouped_opcodes_doc},
-    {NULL}
-};
-
-
-static char PatienceSequenceMatcher_doc[] =
-    "C implementation of PatienceSequenceMatcher";
-
-
-static PyTypeObject PatienceSequenceMatcherType = {
-    PyObject_HEAD_INIT(NULL)
-    .tp_name = "PatienceSequenceMatcher",
-    .tp_basicsize = sizeof(PatienceSequenceMatcher),
-    .tp_dealloc = (destructor)PatienceSequenceMatcher_dealloc,
-    .tp_flags = Py_TPFLAGS_DEFAULT,
-    .tp_doc = PatienceSequenceMatcher_doc,
-    .tp_methods = PatienceSequenceMatcher_methods,
-    .tp_new = PatienceSequenceMatcher_new,
-};
-
-
-static PyMethodDef cpatiencediff_methods[] = {
-    {"unique_lcs_c", py_unique_lcs, METH_VARARGS},
-    {"recurse_matches_c", py_recurse_matches, METH_VARARGS},
-    {NULL, NULL}
-};
-
-PYMOD_INIT_FUNC(_patiencediff_c)
-{
-    PyObject* m;
-
-    if (PyType_Ready(&PatienceSequenceMatcherType) < 0)
-        return PYMOD_ERROR;
-
-    PYMOD_CREATE(m, "_patiencediff_c",
-                 "C implementation of PatienceSequenceMatcher",
-                 cpatiencediff_methods);
-    if (m == NULL) {
-        return PYMOD_ERROR;
-    }
-    Py_INCREF(&PatienceSequenceMatcherType);
-    PyModule_AddObject(m, "PatienceSequenceMatcher_c",
-                       (PyObject *)&PatienceSequenceMatcherType);
-    return PYMOD_SUCCESS(m);
-}
-
-
-/* vim: sw=4 et 
- */

=== removed file 'breezy/_patiencediff_py.py'
--- breezy/_patiencediff_py.py	2018-11-16 13:05:23 +0000
+++ breezy/_patiencediff_py.py	1970-01-01 00:00:00 +0000
@@ -1,250 +0,0 @@
-#!/usr/bin/env python
-# Copyright (C) 2005 Bram Cohen, Copyright (C) 2005, 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-from __future__ import absolute_import
-
-from bisect import bisect
-import difflib
-
-from .trace import mutter
-
-
-def unique_lcs_py(a, b):
-    """Find the longest common subset for unique lines.
-
-    :param a: An indexable object (such as string or list of strings)
-    :param b: Another indexable object (such as string or list of strings)
-    :return: A list of tuples, one for each line which is matched.
-            [(line_in_a, line_in_b), ...]
-
-    This only matches lines which are unique on both sides.
-    This helps prevent common lines from over influencing match
-    results.
-    The longest common subset uses the Patience Sorting algorithm:
-    http://en.wikipedia.org/wiki/Patience_sorting
-    """
-    # set index[line in a] = position of line in a unless
-    # a is a duplicate, in which case it's set to None
-    index = {}
-    for i, line in enumerate(a):
-        if line in index:
-            index[line] = None
-        else:
-            index[line] = i
-    # make btoa[i] = position of line i in a, unless
-    # that line doesn't occur exactly once in both,
-    # in which case it's set to None
-    btoa = [None] * len(b)
-    index2 = {}
-    for pos, line in enumerate(b):
-        next = index.get(line)
-        if next is not None:
-            if line in index2:
-                # unset the previous mapping, which we now know to
-                # be invalid because the line isn't unique
-                btoa[index2[line]] = None
-                del index[line]
-            else:
-                index2[line] = pos
-                btoa[pos] = next
-    # this is the Patience sorting algorithm
-    # see http://en.wikipedia.org/wiki/Patience_sorting
-    backpointers = [None] * len(b)
-    stacks = []
-    lasts = []
-    k = 0
-    for bpos, apos in enumerate(btoa):
-        if apos is None:
-            continue
-        # as an optimization, check if the next line comes at the end,
-        # because it usually does
-        if stacks and stacks[-1] < apos:
-            k = len(stacks)
-        # as an optimization, check if the next line comes right after
-        # the previous line, because usually it does
-        elif stacks and stacks[k] < apos and (k == len(stacks) - 1 or
-                                              stacks[k + 1] > apos):
-            k += 1
-        else:
-            k = bisect(stacks, apos)
-        if k > 0:
-            backpointers[bpos] = lasts[k - 1]
-        if k < len(stacks):
-            stacks[k] = apos
-            lasts[k] = bpos
-        else:
-            stacks.append(apos)
-            lasts.append(bpos)
-    if len(lasts) == 0:
-        return []
-    result = []
-    k = lasts[-1]
-    while k is not None:
-        result.append((btoa[k], k))
-        k = backpointers[k]
-    result.reverse()
-    return result
-
-
-def recurse_matches_py(a, b, alo, blo, ahi, bhi, answer, maxrecursion):
-    """Find all of the matching text in the lines of a and b.
-
-    :param a: A sequence
-    :param b: Another sequence
-    :param alo: The start location of a to check, typically 0
-    :param ahi: The start location of b to check, typically 0
-    :param ahi: The maximum length of a to check, typically len(a)
-    :param bhi: The maximum length of b to check, typically len(b)
-    :param answer: The return array. Will be filled with tuples
-                   indicating [(line_in_a, line_in_b)]
-    :param maxrecursion: The maximum depth to recurse.
-                         Must be a positive integer.
-    :return: None, the return value is in the parameter answer, which
-             should be a list
-
-    """
-    if maxrecursion < 0:
-        mutter('max recursion depth reached')
-        # this will never happen normally, this check is to prevent DOS attacks
-        return
-    oldlength = len(answer)
-    if alo == ahi or blo == bhi:
-        return
-    last_a_pos = alo - 1
-    last_b_pos = blo - 1
-    for apos, bpos in unique_lcs_py(a[alo:ahi], b[blo:bhi]):
-        # recurse between lines which are unique in each file and match
-        apos += alo
-        bpos += blo
-        # Most of the time, you will have a sequence of similar entries
-        if last_a_pos + 1 != apos or last_b_pos + 1 != bpos:
-            recurse_matches_py(
-                a, b, last_a_pos + 1, last_b_pos + 1, apos, bpos, answer,
-                maxrecursion - 1)
-        last_a_pos = apos
-        last_b_pos = bpos
-        answer.append((apos, bpos))
-    if len(answer) > oldlength:
-        # find matches between the last match and the end
-        recurse_matches_py(a, b, last_a_pos + 1, last_b_pos + 1,
-                           ahi, bhi, answer, maxrecursion - 1)
-    elif a[alo] == b[blo]:
-        # find matching lines at the very beginning
-        while alo < ahi and blo < bhi and a[alo] == b[blo]:
-            answer.append((alo, blo))
-            alo += 1
-            blo += 1
-        recurse_matches_py(a, b, alo, blo,
-                           ahi, bhi, answer, maxrecursion - 1)
-    elif a[ahi - 1] == b[bhi - 1]:
-        # find matching lines at the very end
-        nahi = ahi - 1
-        nbhi = bhi - 1
-        while nahi > alo and nbhi > blo and a[nahi - 1] == b[nbhi - 1]:
-            nahi -= 1
-            nbhi -= 1
-        recurse_matches_py(a, b, last_a_pos + 1, last_b_pos + 1,
-                           nahi, nbhi, answer, maxrecursion - 1)
-        for i in range(ahi - nahi):
-            answer.append((nahi + i, nbhi + i))
-
-
-def _collapse_sequences(matches):
-    """Find sequences of lines.
-
-    Given a sequence of [(line_in_a, line_in_b),]
-    find regions where they both increment at the same time
-    """
-    answer = []
-    start_a = start_b = None
-    length = 0
-    for i_a, i_b in matches:
-        if (start_a is not None
-                and (i_a == start_a + length)
-                and (i_b == start_b + length)):
-            length += 1
-        else:
-            if start_a is not None:
-                answer.append((start_a, start_b, length))
-            start_a = i_a
-            start_b = i_b
-            length = 1
-
-    if length != 0:
-        answer.append((start_a, start_b, length))
-
-    return answer
-
-
-def _check_consistency(answer):
-    # For consistency sake, make sure all matches are only increasing
-    next_a = -1
-    next_b = -1
-    for (a, b, match_len) in answer:
-        if a < next_a:
-            raise ValueError('Non increasing matches for a')
-        if b < next_b:
-            raise ValueError('Non increasing matches for b')
-        next_a = a + match_len
-        next_b = b + match_len
-
-
-class PatienceSequenceMatcher_py(difflib.SequenceMatcher):
-    """Compare a pair of sequences using longest common subset."""
-
-    _do_check_consistency = True
-
-    def __init__(self, isjunk=None, a='', b=''):
-        if isjunk is not None:
-            raise NotImplementedError('Currently we do not support'
-                                      ' isjunk for sequence matching')
-        difflib.SequenceMatcher.__init__(self, isjunk, a, b)
-
-    def get_matching_blocks(self):
-        """Return list of triples describing matching subsequences.
-
-        Each triple is of the form (i, j, n), and means that
-        a[i:i+n] == b[j:j+n].  The triples are monotonically increasing in
-        i and in j.
-
-        The last triple is a dummy, (len(a), len(b), 0), and is the only
-        triple with n==0.
-
-        >>> s = PatienceSequenceMatcher(None, "abxcd", "abcd")
-        >>> s.get_matching_blocks()
-        [(0, 0, 2), (3, 2, 2), (5, 4, 0)]
-        """
-        # jam 20060525 This is the python 2.4.1 difflib get_matching_blocks
-        # implementation which uses __helper. 2.4.3 got rid of helper for
-        # doing it inline with a queue.
-        # We should consider doing the same for recurse_matches
-
-        if self.matching_blocks is not None:
-            return self.matching_blocks
-
-        matches = []
-        recurse_matches_py(self.a, self.b, 0, 0,
-                           len(self.a), len(self.b), matches, 10)
-        # Matches now has individual line pairs of
-        # line A matches line B, at the given offsets
-        self.matching_blocks = _collapse_sequences(matches)
-        self.matching_blocks.append((len(self.a), len(self.b), 0))
-        if PatienceSequenceMatcher_py._do_check_consistency:
-            if __debug__:
-                _check_consistency(self.matching_blocks)
-
-        return self.matching_blocks

=== modified file 'breezy/annotate.py'
--- breezy/annotate.py	2018-11-25 20:44:56 +0000
+++ breezy/annotate.py	2019-03-02 21:46:18 +0000
@@ -32,8 +32,10 @@
 
 from .lazy_import import lazy_import
 lazy_import(globals(), """
+
+import patiencediff
+
 from breezy import (
-    patiencediff,
     tsort,
     )
 """)

=== modified file 'breezy/branch.py'
--- breezy/branch.py	2019-02-15 04:22:43 +0000
+++ breezy/branch.py	2019-03-06 22:05:54 +0000
@@ -364,7 +364,10 @@
         provide a more efficient implementation.
         """
         if len(revno) == 1:
-            return self.get_rev_id(revno[0])
+            try:
+                return self.get_rev_id(revno[0])
+            except errors.RevisionNotPresent as e:
+                raise errors.GhostRevisionsHaveNoRevno(revno[0], e.revision_id)
         revision_id_to_revno = self.get_revision_id_to_revno_map()
         revision_ids = [revision_id for revision_id, this_revno
                         in viewitems(revision_id_to_revno)

=== modified file 'breezy/builtins.py'
--- breezy/builtins.py	2019-03-03 23:05:11 +0000
+++ breezy/builtins.py	2019-06-02 03:11:13 +0000
@@ -33,7 +33,6 @@
 from breezy import (
     branch as _mod_branch,
     bugtracker,
-    bundle,
     cache_utf8,
     controldir,
     directory_service,
@@ -46,6 +45,7 @@
     lazy_regex,
     log,
     merge as _mod_merge,
+    mergeable as _mod_mergeable,
     merge_directive,
     osutils,
     reconfigure,
@@ -1210,8 +1210,8 @@
         possible_transports = []
         if location is not None:
             try:
-                mergeable = bundle.read_mergeable_from_url(location,
-                                                           possible_transports=possible_transports)
+                mergeable = _mod_mergeable.read_mergeable_from_url(
+                    location, possible_transports=possible_transports)
             except errors.NotABundle:
                 mergeable = None
 
@@ -4438,8 +4438,8 @@
         self.add_cleanup(tree.lock_write().unlock)
         if location is not None:
             try:
-                mergeable = bundle.read_mergeable_from_url(location,
-                                                           possible_transports=possible_transports)
+                mergeable = _mod_mergeable.read_mergeable_from_url(
+                    location, possible_transports=possible_transports)
             except errors.NotABundle:
                 mergeable = None
             else:
@@ -5260,29 +5260,18 @@
         return self._run(b, revision_id_list, revision)
 
     def _run(self, b, revision_id_list, revision):
+        from .repository import WriteGroup
         gpg_strategy = gpg.GPGStrategy(b.get_config_stack())
         if revision_id_list is not None:
-            b.repository.start_write_group()
-            try:
+            with WriteGroup(b.repository):
                 for revision_id in revision_id_list:
                     revision_id = cache_utf8.encode(revision_id)
                     b.repository.sign_revision(revision_id, gpg_strategy)
-            except BaseException:
-                b.repository.abort_write_group()
-                raise
-            else:
-                b.repository.commit_write_group()
         elif revision is not None:
             if len(revision) == 1:
                 revno, rev_id = revision[0].in_history(b)
-                b.repository.start_write_group()
-                try:
+                with WriteGroup(b.repository):
                     b.repository.sign_revision(rev_id, gpg_strategy)
-                except BaseException:
-                    b.repository.abort_write_group()
-                    raise
-                else:
-                    b.repository.commit_write_group()
             elif len(revision) == 2:
                 # are they both on rh- if so we can walk between them
                 # might be nice to have a range helper for arbitrary
@@ -5294,16 +5283,10 @@
                 if from_revno is None or to_revno is None:
                     raise errors.BzrCommandError(
                         gettext('Cannot sign a range of non-revision-history revisions'))
-                b.repository.start_write_group()
-                try:
+                with WriteGroup(b.repository):
                     for revno in range(from_revno, to_revno + 1):
                         b.repository.sign_revision(b.get_rev_id(revno),
                                                    gpg_strategy)
-                except BaseException:
-                    b.repository.abort_write_group()
-                    raise
-                else:
-                    b.repository.commit_write_group()
             else:
                 raise errors.BzrCommandError(
                     gettext('Please supply either one revision, or a range.'))
@@ -7018,6 +7001,49 @@
             grep.versioned_grep(opts)
 
 
+class cmd_patch(Command):
+    """Apply a named patch to the current tree.
+
+    """
+
+    takes_args = ['filename?']
+    takes_options = [Option('strip', type=int, short_name='p',
+                            help=("Strip the smallest prefix containing num "
+                                  "leading slashes from filenames.")),
+                     Option('silent', help='Suppress chatter.')]
+
+    def run(self, filename=None, strip=None, silent=False):
+        from .patch import patch_tree
+        wt = WorkingTree.open_containing('.')[0]
+        if strip is None:
+            strip = 1
+        my_file = None
+        if filename is None:
+            my_file = getattr(sys.stdin, 'buffer', sys.stdin)
+        else:
+            my_file = open(filename, 'rb')
+        patches = [my_file.read()]
+        return patch_tree(wt, patches, strip, quiet=is_quiet(), out=self.outf)
+
+
+class cmd_resolve_location(Command):
+    __doc__ = """Expand a location to a full URL.
+
+    :Examples:
+        Look up a Launchpad URL.
+
+            brz resolve-location lp:brz
+    """
+    takes_args = ['location']
+    hidden = True
+
+    def run(self, location):
+        from .location import location_to_url
+        url = location_to_url(location)
+        display_url = urlutils.unescape_for_display(url, self.outf.encoding)
+        self.outf.write('%s\n' % display_url)
+
+
 def _register_lazy_builtins():
     # register lazy builtins from other modules; called at startup and should
     # be only called once.

=== modified file 'breezy/bundle/__init__.py'
--- breezy/bundle/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/bundle/__init__.py	2018-11-17 00:47:52 +0000
@@ -15,75 +15,3 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 from __future__ import absolute_import
-
-
-from ..lazy_import import lazy_import
-lazy_import(globals(), """
-from breezy import (
-    errors,
-    transport as _mod_transport,
-    urlutils,
-    )
-from breezy.bundle import serializer as _serializer
-from breezy.merge_directive import MergeDirective
-from breezy.i18n import gettext
-""")
-from ..sixish import (
-    BytesIO,
-    )
-from ..trace import note
-
-
-def read_mergeable_from_url(url, _do_directive=True, possible_transports=None):
-    """Read mergable object from a given URL.
-
-    :return: An object supporting get_target_revision.  Raises NotABundle if
-        the target is not a mergeable type.
-    """
-    child_transport = _mod_transport.get_transport(url,
-                                                   possible_transports=possible_transports)
-    transport = child_transport.clone('..')
-    filename = transport.relpath(child_transport.base)
-    mergeable, transport = read_mergeable_from_transport(transport, filename,
-                                                         _do_directive)
-    return mergeable
-
-
-def read_mergeable_from_transport(transport, filename, _do_directive=True):
-    def get_bundle(transport):
-        return BytesIO(transport.get_bytes(filename)), transport
-
-    def redirected_transport(transport, exception, redirection_notice):
-        note(redirection_notice)
-        url, filename = urlutils.split(exception.target,
-                                       exclude_trailing_slash=False)
-        if not filename:
-            raise errors.NotABundle(gettext('A directory cannot be a bundle'))
-        return _mod_transport.get_transport_from_url(url)
-
-    try:
-        bytef, transport = _mod_transport.do_catching_redirections(
-            get_bundle, transport, redirected_transport)
-    except errors.TooManyRedirections:
-        raise errors.NotABundle(transport.clone(filename).base)
-    except (errors.ConnectionReset, errors.ConnectionError) as e:
-        raise
-    except (errors.TransportError, errors.PathError) as e:
-        raise errors.NotABundle(str(e))
-    except (IOError,) as e:
-        # jam 20060707
-        # Abstraction leakage, SFTPTransport.get('directory')
-        # doesn't always fail at get() time. Sometimes it fails
-        # during read. And that raises a generic IOError with
-        # just the string 'Failure'
-        # StubSFTPServer does fail during get() (because of prefetch)
-        # so it has an opportunity to translate the error.
-        raise errors.NotABundle(str(e))
-
-    if _do_directive:
-        try:
-            return MergeDirective.from_lines(bytef), transport
-        except errors.NotAMergeDirective:
-            bytef.seek(0)
-
-    return _serializer.read_bundle(bytef), transport

=== modified file 'breezy/bundle/commands.py'
--- breezy/bundle/commands.py	2018-11-11 04:08:32 +0000
+++ breezy/bundle/commands.py	2018-11-17 00:47:52 +0000
@@ -53,7 +53,7 @@
 
     def run(self, location, verbose=False):
         from breezy.bundle.serializer import read_bundle
-        from breezy.bundle import read_mergeable_from_url
+        from breezy.mergeable import read_mergeable_from_url
         from breezy import osutils
         term_encoding = osutils.get_terminal_encoding()
         bundle_info = read_mergeable_from_url(location)

=== modified file 'breezy/bundle/serializer/v08.py'
--- breezy/bundle/serializer/v08.py	2018-11-29 23:42:41 +0000
+++ breezy/bundle/serializer/v08.py	2019-03-18 04:31:21 +0000
@@ -78,10 +78,7 @@
             if len(prop) == 1:
                 p_texts.append(prop[0])
             else:
-                try:
-                    p_texts.append('%s:%s' % prop)
-                except:
-                    raise repr(prop)
+                p_texts.append('%s:%s' % prop)
         text = ['=== ']
         text.append(' // '.join(p_texts))
         text_line = ''.join(text).encode('utf-8')

=== modified file 'breezy/bundle/serializer/v4.py'
--- breezy/bundle/serializer/v4.py	2018-11-11 04:08:32 +0000
+++ breezy/bundle/serializer/v4.py	2019-05-29 03:22:34 +0000
@@ -26,6 +26,7 @@
     lru_cache,
     multiparent,
     osutils,
+    repository as _mod_repository,
     revision as _mod_revision,
     trace,
     ui,
@@ -519,14 +520,8 @@
 
         Must be called with the Repository locked.
         """
-        self._repository.start_write_group()
-        try:
-            result = self._install_in_write_group()
-        except:
-            self._repository.abort_write_group()
-            raise
-        self._repository.commit_write_group()
-        return result
+        with _mod_repository.WriteGroup(self._repository):
+            return self._install_in_write_group()
 
     def _install_in_write_group(self):
         current_file = None

=== modified file 'breezy/bzr/_knit_load_data_py.py'
--- breezy/bzr/_knit_load_data_py.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/_knit_load_data_py.py	2019-03-18 04:31:21 +0000
@@ -64,7 +64,6 @@
             raise KnitCorrupt(kndx._filename, "line %r: %s" % (rec, e))
 
         version_id, options, pos, size = rec[:4]
-        version_id = version_id
         try:
             pos = int(pos)
         except ValueError as e:

=== modified file 'breezy/bzr/branch.py'
--- breezy/bzr/branch.py	2019-01-04 20:53:40 +0000
+++ breezy/bzr/branch.py	2019-02-15 18:57:38 +0000
@@ -649,7 +649,7 @@
         with self.lock_read():
             last_revno, last_revision_id = self.last_revision_info()
             if revno <= 0 or revno > last_revno:
-                raise errors.NoSuchRevision(self, revno)
+                raise errors.RevnoOutOfBounds(revno, (0, last_revno))
 
             if history is not None:
                 return history[revno - 1]

=== modified file 'breezy/bzr/bzrdir.py'
--- breezy/bzr/bzrdir.py	2018-11-18 19:48:57 +0000
+++ breezy/bzr/bzrdir.py	2019-06-02 21:07:08 +0000
@@ -662,23 +662,6 @@
     def control_transport(self):
         return self.transport
 
-    def is_control_filename(self, filename):
-        """True if filename is the name of a path which is reserved for bzrdir's.
-
-        :param filename: A filename within the root transport of this bzrdir.
-
-        This is true IF and ONLY IF the filename is part of the namespace
-        reserved for bzr control dirs. Currently this is the '.bzr' directory
-        in the root of the root_transport.
-        """
-        # this might be better on the BzrDirFormat class because it refers to
-        # all the possible bzrdir disk formats.
-        # This method is tested via the workingtree is_control_filename tests-
-        # it was extracted from WorkingTree.is_control_filename. If the
-        # method's contract is extended beyond the current trivial
-        # implementation, please add new tests for it to the appropriate place.
-        return filename == '.bzr' or filename.startswith('.bzr/')
-
     def _cloning_metadir(self):
         """Produce a metadir suitable for cloning with.
 
@@ -1469,6 +1452,24 @@
         BzrFormat.check_support_status(self, allow_unsupported=allow_unsupported,
                                        recommend_upgrade=recommend_upgrade, basedir=basedir)
 
+    @classmethod
+    def is_control_filename(klass, filename):
+        """True if filename is the name of a path which is reserved for bzrdir's.
+
+        :param filename: A filename within the root transport of this bzrdir.
+
+        This is true IF and ONLY IF the filename is part of the namespace
+        reserved for bzr control dirs. Currently this is the '.bzr' directory
+        in the root of the root_transport.
+        """
+        # this might be better on the BzrDirFormat class because it refers to
+        # all the possible bzrdir disk formats.
+        # This method is tested via the workingtree is_control_filename tests-
+        # it was extracted from WorkingTree.is_control_filename. If the
+        # method's contract is extended beyond the current trivial
+        # implementation, please add new tests for it to the appropriate place.
+        return filename == '.bzr' or filename.startswith('.bzr/')
+
 
 class BzrDirMetaFormat1(BzrDirFormat):
     """Bzr meta control format 1

=== modified file 'breezy/bzr/knit.py'
--- breezy/bzr/knit.py	2018-11-12 01:41:38 +0000
+++ breezy/bzr/knit.py	2019-05-28 21:46:09 +0000
@@ -58,12 +58,12 @@
 
 from ..lazy_import import lazy_import
 lazy_import(globals(), """
+import patiencediff
 import gzip
 
 from breezy import (
     debug,
     diff,
-    patiencediff,
     static_tuple,
     trace,
     tsort,
@@ -680,9 +680,6 @@
         lines = (tuple(line.split(b' ', 1)) for line in content)
         return AnnotatedKnitContent(lines)
 
-    def parse_line_delta_iter(self, lines):
-        return iter(self.parse_line_delta(lines))
-
     def parse_line_delta(self, lines, version_id, plain=False):
         """Convert a line based delta into internal representation.
 

=== modified file 'breezy/bzr/remote.py'
--- breezy/bzr/remote.py	2019-02-15 14:00:31 +0000
+++ breezy/bzr/remote.py	2019-06-01 02:04:54 +0000
@@ -18,6 +18,7 @@
 
 import bz2
 import os
+import re
 import sys
 import zlib
 
@@ -1379,6 +1380,20 @@
         except errors.UnknownSmartMethod:
             self._client._medium._remember_remote_is_before((1, 17))
             return self._get_rev_id_for_revno_vfs(revno, known_pair)
+        except errors.UnknownErrorFromSmartServer as e:
+            # Older versions of Bazaar/Breezy (<< 3.0.0) would raise a
+            # ValueError instead of returning revno-outofbounds
+            if len(e.error_tuple) < 3:
+                raise
+            if e.error_tuple[:2] != (b'error', b'ValueError'):
+                raise
+            m = re.match(
+                b"requested revno \(([0-9]+)\) is later than given "
+                b"known revno \(([0-9]+)\)", e.error_tuple[2])
+            if not m:
+                raise
+            raise errors.RevnoOutOfBounds(
+                int(m.group(1)), (0, int(m.group(2))))
         if response[0] == b'ok':
             return True, response[1]
         elif response[0] == b'history-incomplete':
@@ -3872,6 +3887,9 @@
             return _mod_revision.NULL_REVISION
         with self.lock_read():
             last_revision_info = self.last_revision_info()
+            if revno < 0:
+                raise errors.RevnoOutOfBounds(
+                    revno, (0, last_revision_info[0]))
             ok, result = self.repository.get_rev_id_for_revno(
                 revno, last_revision_info)
             if ok:
@@ -3883,7 +3901,7 @@
             parent_map = self.repository.get_parent_map([missing_parent])
             if missing_parent in parent_map:
                 missing_parent = parent_map[missing_parent]
-            raise errors.RevisionNotPresent(missing_parent, self.repository)
+            raise errors.NoSuchRevision(self, missing_parent)
 
     def _read_last_revision_info(self):
         response = self._call(
@@ -4032,6 +4050,14 @@
             except errors.UnknownSmartMethod:
                 self._ensure_real()
                 return self._real_branch.revision_id_to_dotted_revno(revision_id)
+            except errors.UnknownErrorFromSmartServer as e:
+                # Deal with older versions of bzr/brz that didn't explicitly
+                # wrap GhostRevisionsHaveNoRevno.
+                if e.error_tuple[1] == b'GhostRevisionsHaveNoRevno':
+                    (revid, ghost_revid) = re.findall(b"{([^}]+)}", e.error_tuple[2])
+                    raise errors.GhostRevisionsHaveNoRevno(
+                        revid, ghost_revid)
+                raise
             if response[0] == b'ok':
                 return tuple([int(x) for x in response[1:]])
             else:
@@ -4373,6 +4399,10 @@
 error_translators.register(b'nosuchrevision',
                            lambda err, find, get_path: NoSuchRevision(
                                find('repository'), err.error_args[0]))
+error_translators.register(
+    b'revno-outofbounds',
+    lambda err, find, get_path: errors.RevnoOutOfBounds(
+        err.error_args[0], (err.error_args[1], err.error_args[2])))
 
 
 def _translate_nobranch_error(err, find, get_path):

=== modified file 'breezy/bzr/smart/branch.py'
--- breezy/bzr/smart/branch.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/smart/branch.py	2019-03-06 21:27:22 +0000
@@ -236,6 +236,10 @@
             dotted_revno = branch.revision_id_to_dotted_revno(revid)
         except errors.NoSuchRevision:
             return FailedSmartServerResponse((b'NoSuchRevision', revid))
+        except errors.GhostRevisionsHaveNoRevno as e:
+            return FailedSmartServerResponse(
+                (b'GhostRevisionsHaveNoRevno', e.revision_id,
+                    e.ghost_revision_id))
         return SuccessfulSmartServerResponse(
             (b'ok', ) + tuple([b'%d' % x for x in dotted_revno]))
 

=== modified file 'breezy/bzr/smart/repository.py'
--- breezy/bzr/smart/repository.py	2018-11-16 18:33:17 +0000
+++ breezy/bzr/smart/repository.py	2019-02-15 18:57:38 +0000
@@ -53,7 +53,10 @@
     SmartServerRequest,
     SuccessfulSmartServerResponse,
     )
-from ...repository import _strip_NULL_ghosts, network_format_registry
+from ...repository import (
+    _strip_NULL_ghosts,
+    network_format_registry,
+    )
 from ... import revision as _mod_revision
 from ..versionedfile import (
     ChunkedContentFactory,
@@ -328,13 +331,16 @@
         try:
             found_flag, result = repository.get_rev_id_for_revno(
                 revno, known_pair)
-        except errors.RevisionNotPresent as err:
-            if err.revision_id != known_pair[1]:
+        except errors.NoSuchRevision as err:
+            if err.revision != known_pair[1]:
                 raise AssertionError(
                     'get_rev_id_for_revno raised RevisionNotPresent for '
-                    'non-initial revision: ' + err.revision_id)
-            return FailedSmartServerResponse(
-                (b'nosuchrevision', err.revision_id))
+                    'non-initial revision: ' + err.revision)
+            return FailedSmartServerResponse(
+                (b'nosuchrevision', err.revision))
+        except errors.RevnoOutOfBounds as e:
+            return FailedSmartServerResponse(
+                (b'revno-outofbounds', e.revno, e.minimum, e.maximum))
         if found_flag:
             return SuccessfulSmartServerResponse((b'ok', result))
         else:

=== modified file 'breezy/bzr/vf_repository.py'
--- breezy/bzr/vf_repository.py	2019-02-04 19:39:30 +0000
+++ breezy/bzr/vf_repository.py	2019-05-29 03:22:34 +0000
@@ -68,6 +68,7 @@
     InterRepository,
     Repository,
     RepositoryFormat,
+    WriteGroup,
     )
 from .repository import (
     MetaDirRepository,
@@ -2863,8 +2864,7 @@
     Accepts an iterable of revision, tree, signature tuples.  The signature
     may be None.
     """
-    repository.start_write_group()
-    try:
+    with WriteGroup(repository):
         inventory_cache = lru_cache.LRUCache(10)
         for n, (revision, revision_tree, signature) in enumerate(iterable):
             _install_revision(repository, revision, revision_tree, signature,
@@ -2872,11 +2872,6 @@
             if pb is not None:
                 pb.update(gettext('Transferring revisions'),
                           n + 1, num_revisions)
-    except:
-        repository.abort_write_group()
-        raise
-    else:
-        repository.commit_write_group()
 
 
 def _install_revision(repository, rev, revision_tree, signature,

=== modified file 'breezy/bzr/weave.py'
--- breezy/bzr/weave.py	2018-11-11 15:40:12 +0000
+++ breezy/bzr/weave.py	2019-03-02 21:46:18 +0000
@@ -68,6 +68,7 @@
 
 from copy import copy
 import os
+import patiencediff
 
 from ..lazy_import import lazy_import
 lazy_import(globals(), """
@@ -83,7 +84,6 @@
     UnavailableRepresentation,
     )
 from ..osutils import dirname, sha, sha_strings, split_lines
-from .. import patiencediff
 from ..revision import NULL_REVISION
 from ..sixish import (
     BytesIO,

=== modified file 'breezy/bzr/workingtree.py'
--- breezy/bzr/workingtree.py	2018-12-11 00:51:46 +0000
+++ breezy/bzr/workingtree.py	2019-06-02 21:29:09 +0000
@@ -126,6 +126,7 @@
 
         self._control_files = _control_files
         self._detect_case_handling()
+        self._setup_directory_is_tree_reference()
 
         if _inventory is None:
             # This will be acquired on lock_read() or lock_write()
@@ -160,7 +161,33 @@
         else:
             self.case_sensitive = False
 
-        self._setup_directory_is_tree_reference()
+    def _setup_directory_is_tree_reference(self):
+        if self._branch.repository._format.supports_tree_reference:
+            self._directory_is_tree_reference = \
+                self._directory_may_be_tree_reference
+        else:
+            self._directory_is_tree_reference = \
+                self._directory_is_never_tree_reference
+
+    def _directory_is_never_tree_reference(self, relpath):
+        return False
+
+    def _directory_may_be_tree_reference(self, relpath):
+        # as a special case, if a directory contains control files then
+        # it's a tree reference, except that the root of the tree is not
+        return relpath and osutils.isdir(self.abspath(relpath) + u"/.bzr")
+        # TODO: We could ask all the control formats whether they
+        # recognize this directory, but at the moment there's no cheap api
+        # to do that.  Since we probably can only nest bzr checkouts and
+        # they always use this name it's ok for now.  -- mbp 20060306
+        #
+        # FIXME: There is an unhandled case here of a subdirectory
+        # containing .bzr but not a branch; that will probably blow up
+        # when you try to commit it.  It might happen if there is a
+        # checkout in a subdirectory.  This can be avoided by not adding
+        # it.  mbp 20070306
+
+
 
     def _serialize(self, inventory, out_file):
         xml5.serializer_v5.write_inventory(

=== modified file 'breezy/commands.py'
--- breezy/commands.py	2018-11-12 01:41:38 +0000
+++ breezy/commands.py	2019-03-02 21:46:18 +0000
@@ -264,7 +264,7 @@
         names.update(cmd.aliases)
     # candidate: modified levenshtein distance against cmd_name.
     costs = {}
-    from . import patiencediff
+    import patiencediff
     for name in sorted(names):
         matcher = patiencediff.PatienceSequenceMatcher(None, cmd_name, name)
         distance = 0.0

=== modified file 'breezy/commit_signature_commands.py'
--- breezy/commit_signature_commands.py	2018-11-12 01:41:38 +0000
+++ breezy/commit_signature_commands.py	2019-05-29 03:22:34 +0000
@@ -22,6 +22,7 @@
     controldir,
     errors,
     gpg,
+    repository as _mod_repository,
     revision as _mod_revision,
     )
 from .commands import Command
@@ -66,8 +67,7 @@
         count = 0
         with repo.lock_write():
             graph = repo.get_graph()
-            repo.start_write_group()
-            try:
+            with _mod_repository.WriteGroup(repo):
                 for rev_id, parents in graph.iter_ancestry(
                         [branch.last_revision()]):
                     if _mod_revision.is_null(rev_id):
@@ -86,11 +86,6 @@
                     count += 1
                     if not dry_run:
                         repo.sign_revision(rev_id, gpg_strategy)
-            except BaseException:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
         self.outf.write(
             ngettext('Signed %d revision.\n', 'Signed %d revisions.\n',
                      count) % count)

=== modified file 'breezy/controldir.py'
--- breezy/controldir.py	2018-11-12 01:41:38 +0000
+++ breezy/controldir.py	2019-06-03 04:07:01 +0000
@@ -152,7 +152,7 @@
         this in the future - for instance to make bzr talk with svn working
         trees.
         """
-        raise NotImplementedError(self.is_control_filename)
+        return self._format.is_control_filename(filename)
 
     def needs_format_conversion(self, format=None):
         """Return true if this controldir needs convert_format run on it.
@@ -1246,6 +1246,22 @@
         """
         raise NotImplementedError(self.supports_transport)
 
+    @classmethod
+    def is_control_filename(klass, filename):
+        """True if filename is the name of a path which is reserved for
+        controldirs.
+
+        :param filename: A filename within the root transport of this
+            controldir.
+
+        This is true IF and ONLY IF the filename is part of the namespace reserved
+        for bzr control dirs. Currently this is the '.bzr' directory in the root
+        of the root_transport. it is expected that plugins will need to extend
+        this in the future - for instance to make bzr talk with svn working
+        trees.
+        """
+        raise NotImplementedError(self.is_control_filename)
+
 
 class Prober(object):
     """Abstract class that can be used to detect a particular kind of
@@ -1461,8 +1477,13 @@
 
 def is_control_filename(filename):
     """Check if filename is used for control directories."""
-    # TODO(jelmer): Allow registration by other VCSes
-    return filename == '.bzr'
+    # TODO(jelmer): Instead, have a function that returns all control
+    # filenames.
+    for key, format in format_registry.items():
+        if format().is_control_filename(filename):
+            return True
+    else:
+        return False
 
 
 class RepositoryAcquisitionPolicy(object):

=== modified file 'breezy/diff.py'
--- breezy/diff.py	2018-11-25 21:48:55 +0000
+++ breezy/diff.py	2019-05-28 23:22:20 +0000
@@ -25,6 +25,7 @@
 from .lazy_import import lazy_import
 lazy_import(globals(), """
 import errno
+import patiencediff
 import subprocess
 import tempfile
 
@@ -33,7 +34,6 @@
     controldir,
     errors,
     osutils,
-    patiencediff,
     textfile,
     timestamp,
     views,
@@ -93,12 +93,11 @@
 
     if sequence_matcher is None:
         sequence_matcher = patiencediff.PatienceSequenceMatcher
-    ud = patiencediff.unified_diff_bytes(oldlines, newlines,
-                                         fromfile=old_label.encode(
-                                             path_encoding, 'replace'),
-                                         tofile=new_label.encode(
-                                             path_encoding, 'replace'),
-                                         n=context_lines, sequencematcher=sequence_matcher)
+    ud = unified_diff_bytes(
+        oldlines, newlines,
+        fromfile=old_label.encode(path_encoding, 'replace'),
+        tofile=new_label.encode(path_encoding, 'replace'),
+        n=context_lines, sequencematcher=sequence_matcher)
 
     ud = list(ud)
     if len(ud) == 0:  # Identical contents, nothing to do
@@ -117,6 +116,75 @@
     to_file.write(b'\n')
 
 
+def unified_diff_bytes(a, b, fromfile=b'', tofile=b'', fromfiledate=b'',
+                       tofiledate=b'', n=3, lineterm=b'\n', sequencematcher=None):
+    r"""
+    Compare two sequences of lines; generate the delta as a unified diff.
+
+    Unified diffs are a compact way of showing line changes and a few
+    lines of context.  The number of context lines is set by 'n' which
+    defaults to three.
+
+    By default, the diff control lines (those with ---, +++, or @@) are
+    created with a trailing newline.  This is helpful so that inputs
+    created from file.readlines() result in diffs that are suitable for
+    file.writelines() since both the inputs and outputs have trailing
+    newlines.
+
+    For inputs that do not have trailing newlines, set the lineterm
+    argument to "" so that the output will be uniformly newline free.
+
+    The unidiff format normally has a header for filenames and modification
+    times.  Any or all of these may be specified using strings for
+    'fromfile', 'tofile', 'fromfiledate', and 'tofiledate'.  The modification
+    times are normally expressed in the format returned by time.ctime().
+
+    Example:
+
+    >>> for line in bytes_unified_diff(b'one two three four'.split(),
+    ...             b'zero one tree four'.split(), b'Original', b'Current',
+    ...             b'Sat Jan 26 23:30:50 1991', b'Fri Jun 06 10:20:52 2003',
+    ...             lineterm=b''):
+    ...     print line
+    --- Original Sat Jan 26 23:30:50 1991
+    +++ Current Fri Jun 06 10:20:52 2003
+    @@ -1,4 +1,4 @@
+    +zero
+     one
+    -two
+    -three
+    +tree
+     four
+    """
+    if sequencematcher is None:
+        sequencematcher = difflib.SequenceMatcher
+
+    if fromfiledate:
+        fromfiledate = b'\t' + bytes(fromfiledate)
+    if tofiledate:
+        tofiledate = b'\t' + bytes(tofiledate)
+
+    started = False
+    for group in sequencematcher(None, a, b).get_grouped_opcodes(n):
+        if not started:
+            yield b'--- %s%s%s' % (fromfile, fromfiledate, lineterm)
+            yield b'+++ %s%s%s' % (tofile, tofiledate, lineterm)
+            started = True
+        i1, i2, j1, j2 = group[0][1], group[-1][2], group[0][3], group[-1][4]
+        yield b"@@ -%d,%d +%d,%d @@%s" % (i1 + 1, i2 - i1, j1 + 1, j2 - j1, lineterm)
+        for tag, i1, i2, j1, j2 in group:
+            if tag == 'equal':
+                for line in a[i1:i2]:
+                    yield b' ' + line
+                continue
+            if tag == 'replace' or tag == 'delete':
+                for line in a[i1:i2]:
+                    yield b'-' + line
+            if tag == 'replace' or tag == 'insert':
+                for line in b[j1:j2]:
+                    yield b'+' + line
+
+
 def _spawn_external_diff(diffcmd, capture_errors=True):
     """Spawn the external diff process, and return the child handle.
 

=== modified file 'breezy/errors.py'
--- breezy/errors.py	2018-11-11 04:08:32 +0000
+++ breezy/errors.py	2019-02-15 18:57:38 +0000
@@ -2452,3 +2452,13 @@
 
     _fmt = ('Cannot store uncommitted changes because this branch already'
             ' stores uncommitted changes.')
+
+
+class RevnoOutOfBounds(InternalBzrError):
+
+    _fmt = ("The requested revision number %(revno)d is outside of the "
+            "expected boundaries (%(minimum)d <= %(maximum)d).")
+
+    def __init__(self, revno, bounds):
+        InternalBzrError.__init__(
+            self, revno=revno, minimum=bounds[0], maximum=bounds[1])

=== modified file 'breezy/git/branch.py'
--- breezy/git/branch.py	2019-03-04 05:10:44 +0000
+++ breezy/git/branch.py	2019-04-11 02:09:36 +0000
@@ -1254,7 +1254,10 @@
         if stop_revision is None:
             (stop_revno, stop_revision) = self.source.last_revision_info()
         elif stop_revno is None:
-            stop_revno = self.source.revision_id_to_revno(stop_revision)
+            try:
+                stop_revno = self.source.revision_id_to_revno(stop_revision)
+            except errors.NoSuchRevision:
+                stop_revno = None
         if not isinstance(stop_revision, bytes):
             raise TypeError(stop_revision)
         main_ref = self.target.ref

=== modified file 'breezy/git/commands.py'
--- breezy/git/commands.py	2019-02-10 23:12:06 +0000
+++ breezy/git/commands.py	2019-04-06 12:51:43 +0000
@@ -265,19 +265,12 @@
         :param f: Patch file to read.
         :param signoff: Add Signed-Off-By flag.
         """
-        from ..i18n import gettext
-        from ..errors import BzrCommandError
         from dulwich.patch import git_am_patch_split
-        import subprocess
+        from breezy.patch import patch_tree
         (c, diff, version) = git_am_patch_split(f)
         # FIXME: Cope with git-specific bits in patch
         # FIXME: Add new files to working tree
-        p = subprocess.Popen(["patch", "-p1"], stdin=subprocess.PIPE,
-                             cwd=wt.basedir)
-        p.communicate(diff)
-        exitcode = p.wait()
-        if exitcode != 0:
-            raise BzrCommandError(gettext("error running patch"))
+        patch_tree(wt, [diff], strip=1, out=self.outf)
         message = c.message.decode('utf-8')
         if signoff:
             signed_off_by = wt.branch.get_config().username()

=== modified file 'breezy/git/dir.py'
--- breezy/git/dir.py	2018-11-16 11:37:47 +0000
+++ breezy/git/dir.py	2019-06-02 21:21:39 +0000
@@ -273,11 +273,11 @@
         for ref in self.get_refs_container().keys():
             try:
                 branch_name = ref_to_branch_name(ref)
-            except ValueError:
-                continue
             except UnicodeDecodeError:
                 trace.warning("Ignoring branch %r with unicode error ref", ref)
                 continue
+            except ValueError:
+                continue
             ret[branch_name] = self.open_branch(ref=ref)
         return ret
 
@@ -401,6 +401,11 @@
             raise brz_errors.NotBranchError(path=transport.base)
         return external_url.startswith("file:")
 
+    def is_control_filename(self, filename):
+        return (filename == '.git'
+                or filename.startswith('.git/')
+                or filename.startswith('.git\\'))
+
 
 class BareLocalGitControlDirFormat(LocalGitControlDirFormat):
 
@@ -410,6 +415,9 @@
     def get_format_description(self):
         return "Local Git Repository (bare)"
 
+    def is_control_filename(self, filename):
+        return False
+
 
 class LocalGitDir(GitDir):
     """An adapter to the '.git' dir used by git."""
@@ -443,11 +451,6 @@
             self.transport = transport.clone('.git')
         self._mode_check_done = None
 
-    def is_control_filename(self, filename):
-        return (filename == '.git'
-                or filename.startswith('.git/')
-                or filename.startswith('.git\\'))
-
     def _get_symref(self, ref):
         ref_chain, unused_sha = self._git.refs.follow(ref)
         if len(ref_chain) == 1:

=== modified file 'breezy/git/object_store.py'
--- breezy/git/object_store.py	2019-02-16 21:29:56 +0000
+++ breezy/git/object_store.py	2019-04-14 03:19:31 +0000
@@ -332,7 +332,7 @@
         except KeyError:
             pass
         # FIXME: Should be the same as in parent
-        if ie.kind in ("file", "symlink"):
+        if ie.kind == "file":
             try:
                 return idmap.lookup_blob_id(ie.file_id, ie.revision)
             except KeyError:
@@ -342,6 +342,16 @@
                 if add_cache_entry is not None:
                     add_cache_entry(blob, (ie.file_id, ie.revision), path)
                 return blob.id
+        elif ie.kind == "symlink":
+            try:
+                return idmap.lookup_blob_id(ie.file_id, ie.revision)
+            except KeyError:
+                # no-change merge ?
+                target = tree.get_symlink_target(path)
+                blob = symlink_to_blob(target)
+                if add_cache_entry is not None:
+                    add_cache_entry(blob, (ie.file_id, ie.revision), path)
+                return blob.id
         elif ie.kind == "directory":
             # Not all cache backends store the tree information,
             # calculate again from scratch
@@ -361,22 +371,11 @@
         if tree.kind(path) != 'directory':
             continue
 
-        obj = Tree()
-        for value in tree.iter_child_entries(path):
-            if value.name in BANNED_FILENAMES:
-                trace.warning('not exporting %s with banned filename %s',
-                              value.kind, value.name)
-                continue
-            child_path = osutils.pathjoin(path, value.name)
-            try:
-                mode = unusual_modes[child_path]
-            except KeyError:
-                mode = entry_mode(value)
-            hexsha = ie_to_hexsha(child_path, value)
-            if hexsha is not None:
-                obj.add(value.name.encode("utf-8"), mode, hexsha)
+        obj = directory_to_tree(
+            path, tree.iter_child_entries(path), ie_to_hexsha, unusual_modes,
+            dummy_file_name, path == '')
 
-        if len(obj) > 0:
+        if obj is not None:
             file_id = tree.path2id(path)
             if add_cache_entry is not None:
                 add_cache_entry(obj, (file_id, tree.get_revision_id()), path)

=== modified file 'breezy/git/remote.py'
--- breezy/git/remote.py	2019-05-19 22:07:15 +0000
+++ breezy/git/remote.py	2019-06-02 05:13:10 +0000
@@ -89,6 +89,7 @@
     )
 from .repository import (
     GitRepository,
+    GitRepositoryFormat,
     )
 from .refs import (
     branch_name_to_ref,
@@ -749,6 +750,10 @@
     def get_branch_format(self):
         return RemoteGitBranchFormat()
 
+    @property
+    def repository_format(self):
+        return GitRepositoryFormat()
+
     def is_initializable(self):
         return False
 

=== modified file 'breezy/git/revspec.py'
--- breezy/git/revspec.py	2019-02-03 01:42:11 +0000
+++ breezy/git/revspec.py	2019-06-02 05:13:10 +0000
@@ -49,9 +49,14 @@
 
 
 class RevisionSpec_git(RevisionSpec):
-    """Selects a revision using a Subversion revision number."""
-
-    help_txt = """Selects a revision using a Git revision sha1.
+    """Selects a revision using a Git commit SHA1."""
+
+    help_txt = """Selects a revision using a Git commit SHA1.
+
+    Selects a revision using a Git commit SHA1, short or long.
+
+    This works for both native Git repositories and Git revisions
+    imported into Bazaar repositories.
     """
 
     prefix = 'git:'
@@ -107,7 +112,8 @@
     def _match_on(self, branch, revs):
         loc = self.spec.find(':')
         git_sha1 = self.spec[loc + 1:].encode("utf-8")
-        if len(git_sha1) > 40 or not valid_git_sha1(git_sha1):
+        if (len(git_sha1) > 40 or len(git_sha1) < 4 or
+                not valid_git_sha1(git_sha1)):
             raise InvalidRevisionSpec(self.user_spec, branch)
         from . import (
             lazy_check_versions,

=== modified file 'breezy/git/tests/test_blackbox.py'
--- breezy/git/tests/test_blackbox.py	2019-02-17 04:08:56 +0000
+++ breezy/git/tests/test_blackbox.py	2019-06-02 05:13:10 +0000
@@ -150,6 +150,22 @@
         self.assertEqual(b"", output)
         self.assertTrue(error.endswith(b"Created new branch.\n"))
 
+    def test_push_lossy_non_mainline(self):
+        self.run_bzr(['init', '--git', 'bla'])
+        self.run_bzr(['init', 'foo'])
+        self.run_bzr(['commit', '--unchanged', '-m', 'bla', 'foo'])
+        self.run_bzr(['branch', 'foo', 'foo1'])
+        self.run_bzr(['commit', '--unchanged', '-m', 'bla', 'foo1'])
+        self.run_bzr(['commit', '--unchanged', '-m', 'bla', 'foo'])
+        self.run_bzr(['merge', '-d', 'foo', 'foo1'])
+        self.run_bzr(['commit', '--unchanged', '-m', 'merge', 'foo'])
+        output, error = self.run_bzr(['push', '--lossy', '-r1.1.1', '-d', 'foo', 'bla'])
+        self.assertEqual("", output)
+        self.assertEqual(
+            'Pushing from a Bazaar to a Git repository. For better '
+            'performance, push into a Bazaar repository.\n'
+            'Pushed up to revision 2.\n', error)
+
     def test_log(self):
         # Smoke test for "bzr log" in a git repository.
         self.simple_commit()
@@ -197,9 +213,9 @@
         output, error = self.run_bzr(['diff', '--format=git'], retcode=1)
         self.assertEqual(error, '')
         self.assertEqual(output,
-                         'diff --git /dev/null b/a\n'
-                         'old mode 0\n'
-                         'new mode 100644\n'
+                         'diff --git a/a b/a\n'
+                         'old file mode 0\n'
+                         'new file mode 100644\n'
                          'index 0000000..c197bd8 100644\n'
                          '--- /dev/null\n'
                          '+++ b/a\n'

=== modified file 'breezy/git/tests/test_object_store.py'
--- breezy/git/tests/test_object_store.py	2019-02-16 21:29:56 +0000
+++ breezy/git/tests/test_object_store.py	2019-05-28 23:34:07 +0000
@@ -20,6 +20,7 @@
 
 import os
 import shutil
+import stat
 
 from dulwich.objects import (
     Blob,
@@ -44,6 +45,7 @@
     TestCase,
     TestCaseWithTransport,
     )
+from ...tests.features import SymlinkFeature
 
 from ..cache import (
     DictGitShaMap,
@@ -171,6 +173,7 @@
         self.assertEqual(b, self.store[b.id])
 
     def test_directory_converted_to_symlink(self):
+        self.requireFeature(SymlinkFeature)
         b = Blob()
         b.data = b'trgt'
         self.store.lock_read()
@@ -256,6 +259,60 @@
         entries = list(_tree_to_objects(revtree, [], self.idmap, {}))
         self.assertEqual(['foo', ''], [p[0] for p in entries])
 
+    def test_merge(self):
+        basis_tree = self.make_branch_and_tree('base')
+        self.build_tree(['base/foo/'])
+        basis_tree.add(['foo'])
+        basis_rev = basis_tree.commit('foo')
+        basis_revtree = basis_tree.branch.repository.revision_tree(basis_rev)
+
+        tree_a = self.make_branch_and_tree('a')
+        tree_a.pull(basis_tree.branch)
+
+        self.build_tree(['a/foo/file1'])
+        self.build_tree(['a/foo/subdir-a/'])
+        os.symlink('.', 'a/foo/subdir-a/symlink')
+        tree_a.add(['foo/subdir-a', 'foo/subdir-a/symlink'])
+
+        tree_a.add(['foo/file1'])
+        rev_a = tree_a.commit('commit a')
+        revtree_a = tree_a.branch.repository.revision_tree(rev_a)
+
+        with revtree_a.lock_read():
+            entries = list(_tree_to_objects(revtree_a, [basis_revtree],
+                           self.idmap, {}))
+            objects = {path: obj for (path, obj, key) in entries}
+            subdir_a = objects['foo/subdir-a']
+
+        tree_b = self.make_branch_and_tree('b')
+        tree_b.pull(basis_tree.branch)
+        self.build_tree(['b/foo/subdir/'])
+        os.symlink('.', 'b/foo/subdir/symlink')
+        tree_b.add(['foo/subdir', 'foo/subdir/symlink'])
+        rev_b = tree_b.commit('commit b')
+        revtree_b = tree_b.branch.repository.revision_tree(rev_b)
+        self.addCleanup(revtree_b.lock_read().unlock)
+
+        with revtree_b.lock_read():
+            list(_tree_to_objects(revtree_b, [basis_revtree], self.idmap, {}))
+
+        with tree_a.lock_write():
+            tree_a.merge_from_branch(tree_b.branch)
+        rev_merge = tree_a.commit('merge')
+
+        revtree_merge = tree_a.branch.basis_tree()
+        self.addCleanup(revtree_merge.lock_read().unlock)
+
+        entries = list(_tree_to_objects(
+            revtree_merge,
+            [tree_a.branch.repository.revision_tree(r)
+             for r in revtree_merge.get_parent_ids()],
+            self.idmap, {}))
+        objects = {path: obj for (path, obj, key) in entries}
+        self.assertEqual(set(['', 'foo', 'foo/subdir']), set(objects))
+        self.assertEqual(
+            (stat.S_IFDIR, subdir_a.id), objects['foo'][b'subdir-a'])
+
 
 class DirectoryToTreeTests(TestCase):
 

=== modified file 'breezy/git/tests/test_workingtree.py'
--- breezy/git/tests/test_workingtree.py	2019-02-04 17:10:54 +0000
+++ breezy/git/tests/test_workingtree.py	2019-06-02 05:13:10 +0000
@@ -268,8 +268,9 @@
             ], [b'a'], want_unversioned=True)
 
     def test_submodule(self):
-        self.build_tree(['a/'])
+        self.subtree = self.make_branch_and_tree('a', format="git")
         a = Blob.from_string(b'irrelevant\n')
+        self.build_tree_contents([('a/.git/HEAD', a.id)])
         with self.wt.lock_tree_write():
             (index, index_path) = self.wt._lookup_index(b'a')
             index[b'a'] = IndexEntry(0, 0, 0, 0, S_IFGITLINK, 0, 0, 0, a.id, 0)

=== modified file 'breezy/git/tree.py'
--- breezy/git/tree.py	2018-12-18 20:55:37 +0000
+++ breezy/git/tree.py	2019-06-02 05:13:10 +0000
@@ -1455,7 +1455,9 @@
                 # Entry was removed; keep it listed, but mark it as gone.
                 blobs[path] = (ZERO_SHA, 0)
             elif e.errno == errno.EISDIR:
-                # TODO(jelmer): Only do this if 'path' appears in .gitmodules?
+                # Backwards compatibility with Dulwich < 0.19.12;
+                # newer versions of Dulwich return either an entry for the
+                # submodule or None for directories.
                 if S_ISGITLINK(index_entry.mode):
                     blobs[path] = (index_entry.sha, index_entry.mode)
                 else:
@@ -1465,7 +1467,12 @@
             else:
                 raise
         else:
-            blobs[path] = (live_entry.sha, cleanup_mode(live_entry.mode))
+            if live_entry is None:
+                # Entry was turned into a directory
+                dirified.append((path, Tree().id, stat.S_IFDIR))
+                store.add_object(Tree())
+            else:
+                blobs[path] = (live_entry.sha, cleanup_mode(live_entry.mode))
     if want_unversioned:
         for e in target.extras():
             st = target._lstat(e)

=== modified file 'breezy/git/workingtree.py'
--- breezy/git/workingtree.py	2019-02-05 04:00:02 +0000
+++ breezy/git/workingtree.py	2019-06-02 21:32:43 +0000
@@ -568,8 +568,7 @@
                     except OSError as e:
                         if e.errno == errno.ENOENT:
                             raise errors.NoSuchFile(fullpath)
-                    if (kind == 'directory' and f != '' and
-                            os.path.exists(os.path.join(fullpath, '.git'))):
+                    if f != '' and self._directory_is_tree_reference(f):
                         kind = 'tree-reference'
                     kinds[pos] = kind
 

=== modified file 'breezy/log.py'
--- breezy/log.py	2018-11-17 16:43:29 +0000
+++ breezy/log.py	2019-02-26 09:04:28 +0000
@@ -200,13 +200,13 @@
     if isinstance(start_revision, int):
         try:
             start_revision = revisionspec.RevisionInfo(branch, start_revision)
-        except errors.NoSuchRevision:
+        except (errors.NoSuchRevision, errors.RevnoOutOfBounds):
             raise errors.InvalidRevisionNumber(start_revision)
 
     if isinstance(end_revision, int):
         try:
             end_revision = revisionspec.RevisionInfo(branch, end_revision)
-        except errors.NoSuchRevision:
+        except (errors.NoSuchRevision, errors.RevnoOutOfBounds):
             raise errors.InvalidRevisionNumber(end_revision)
 
     if end_revision is not None and end_revision.revno == 0:

=== modified file 'breezy/merge.py'
--- breezy/merge.py	2019-02-14 21:45:23 +0000
+++ breezy/merge.py	2019-06-03 05:21:20 +0000
@@ -18,6 +18,8 @@
 
 from .lazy_import import lazy_import
 lazy_import(globals(), """
+import patiencediff
+
 from breezy import (
     branch as _mod_branch,
     cleanup,
@@ -26,7 +28,6 @@
     graph as _mod_graph,
     merge3,
     osutils,
-    patiencediff,
     revision as _mod_revision,
     textfile,
     trace,
@@ -904,17 +905,14 @@
         else:
             interesting_files = None
         result = []
-        walker = _mod_tree.MultiWalker(self.other_tree, self._lca_trees)
+        from .multiwalker import MultiWalker
+        walker = MultiWalker(self.other_tree, self._lca_trees)
 
-        base_inventory = self.base_tree.root_inventory
-        this_inventory = self.this_tree.root_inventory
-        for path, file_id, other_ie, lca_values in walker.iter_all():
+        for other_path, file_id, other_ie, lca_values in walker.iter_all():
             # Is this modified at all from any of the other trees?
             if other_ie is None:
                 other_ie = _none_entry
                 other_path = None
-            else:
-                other_path = self.other_tree.id2path(file_id)
             if interesting_files is not None and other_path not in interesting_files:
                 continue
 
@@ -948,20 +946,20 @@
                     lca_paths.append(lca_path)
 
             try:
-                base_ie = base_inventory.get_entry(file_id)
+                base_path = self.base_tree.id2path(file_id)
             except errors.NoSuchId:
+                base_path = None
                 base_ie = _none_entry
-                base_path = None
             else:
-                base_path = self.base_tree.id2path(file_id)
+                base_ie = next(self.base_tree.iter_entries_by_dir(specific_files=[base_path]))[1]
 
             try:
-                this_ie = this_inventory.get_entry(file_id)
+                this_path = self.this_tree.id2path(file_id)
             except errors.NoSuchId:
                 this_ie = _none_entry
                 this_path = None
             else:
-                this_path = self.this_tree.id2path(file_id)
+                this_ie = next(self.this_tree.iter_entries_by_dir(specific_files=[this_path]))[1]
 
             lca_kinds = []
             lca_parent_ids = []
@@ -1865,13 +1863,13 @@
 
     def _entries_to_incorporate(self):
         """Yields pairs of (inventory_entry, new_parent)."""
-        other_inv = self.other_tree.root_inventory
-        subdir_id = other_inv.path2id(self._source_subpath)
+        subdir_id = self.other_tree.path2id(self._source_subpath)
         if subdir_id is None:
             # XXX: The error would be clearer if it gave the URL of the source
             # branch, but we don't have a reference to that here.
             raise PathNotInTree(self._source_subpath, "Source tree")
-        subdir = other_inv.get_entry(subdir_id)
+        subdir = next(self.other_tree.iter_entries_by_dir(
+            specific_files=[self._source_subpath]))[1]
         parent_in_target = osutils.dirname(self._target_subdir)
         target_id = self.this_tree.path2id(parent_in_target)
         if target_id is None:
@@ -1893,7 +1891,7 @@
         if subdir.kind != 'directory':
             # No children, so we are done.
             return
-        for path, entry in other_inv.iter_entries_by_dir(subdir_id):
+        for path, entry in self.other_tree.root_inventory.iter_entries_by_dir(subdir_id):
             parent_id = entry.parent_id
             if parent_id == subdir.file_id:
                 # The root's parent ID has changed, so make sure children of

=== modified file 'breezy/merge3.py'
--- breezy/merge3.py	2019-02-02 15:13:30 +0000
+++ breezy/merge3.py	2019-03-02 21:46:18 +0000
@@ -19,9 +19,11 @@
 # mbp: "you know that thing where cvs gives you conflict markers?"
 # s: "i hate that."
 
+import patiencediff
+
+
 from . import (
     errors,
-    patiencediff,
     textfile,
     )
 

=== added file 'breezy/mergeable.py'
--- breezy/mergeable.py	1970-01-01 00:00:00 +0000
+++ breezy/mergeable.py	2018-11-13 01:27:26 +0000
@@ -0,0 +1,107 @@
+# Copyright (C) 2005-2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+from __future__ import absolute_import
+
+from .lazy_import import lazy_import
+lazy_import(globals(), """
+from breezy import (
+    errors,
+    transport as _mod_transport,
+    urlutils,
+    )
+from breezy.bundle import serializer as _serializer
+from breezy.merge_directive import MergeDirective
+from breezy.i18n import gettext
+""")
+
+from .sixish import (
+    BytesIO,
+    )
+from .trace import note
+
+
+class Mergeable(object):
+    """A mergeable object."""
+
+    def install_revisions(self, repository):
+        """Install the data from this mergeable into the specified repository.
+
+        :param repository: Repository
+        """
+        raise NotImplementedError(self.install_revisions)
+
+    def get_merge_request(self, repository):
+        """Extract merge request data.
+
+        :return: tuple with (base_revision_id, target_revision_id, verified)
+        """
+        raise NotImplementedError(self.get_merge_request)
+
+
+def read_mergeable_from_url(url, _do_directive=True, possible_transports=None):
+    """Read mergable object from a given URL.
+
+    :return: An object supporting get_target_revision.  Raises NotABundle if
+        the target is not a mergeable type.
+    """
+    child_transport = _mod_transport.get_transport(
+        url, possible_transports=possible_transports)
+    transport = child_transport.clone('..')
+    filename = transport.relpath(child_transport.base)
+    mergeable, transport = read_mergeable_from_transport(transport, filename,
+                                                         _do_directive)
+    return mergeable
+
+
+def read_mergeable_from_transport(transport, filename, _do_directive=True):
+    def get_bundle(transport):
+        return BytesIO(transport.get_bytes(filename)), transport
+
+    def redirected_transport(transport, exception, redirection_notice):
+        note(redirection_notice)
+        url, filename = urlutils.split(exception.target,
+                                       exclude_trailing_slash=False)
+        if not filename:
+            raise errors.NotABundle(gettext('A directory cannot be a bundle'))
+        return _mod_transport.get_transport_from_url(url)
+
+    try:
+        bytef, transport = _mod_transport.do_catching_redirections(
+            get_bundle, transport, redirected_transport)
+    except errors.TooManyRedirections:
+        raise errors.NotABundle(transport.clone(filename).base)
+    except (errors.ConnectionReset, errors.ConnectionError) as e:
+        raise
+    except (errors.TransportError, errors.PathError) as e:
+        raise errors.NotABundle(str(e))
+    except (IOError,) as e:
+        # jam 20060707
+        # Abstraction leakage, SFTPTransport.get('directory')
+        # doesn't always fail at get() time. Sometimes it fails
+        # during read. And that raises a generic IOError with
+        # just the string 'Failure'
+        # StubSFTPServer does fail during get() (because of prefetch)
+        # so it has an opportunity to translate the error.
+        raise errors.NotABundle(str(e))
+
+    if _do_directive:
+        try:
+            return MergeDirective.from_lines(bytef), transport
+        except errors.NotAMergeDirective:
+            bytef.seek(0)
+
+    return _serializer.read_bundle(bytef), transport

=== modified file 'breezy/multiparent.py'
--- breezy/multiparent.py	2018-11-12 01:41:38 +0000
+++ breezy/multiparent.py	2019-03-02 21:46:18 +0000
@@ -24,11 +24,11 @@
 lazy_import(globals(), """
 import gzip
 import itertools
+import patiencediff
 
 from breezy import (
     bencode,
     errors,
-    patiencediff,
     ui,
     )
 """)

=== added file 'breezy/multiwalker.py'
--- breezy/multiwalker.py	1970-01-01 00:00:00 +0000
+++ breezy/multiwalker.py	2019-06-02 18:43:25 +0000
@@ -0,0 +1,266 @@
+# Copyright (C) 2005-2011 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Walk multiple trees simultaneously.
+"""
+
+from __future__ import absolute_import
+
+from . import (
+    errors,
+    osutils,
+    )
+
+from .sixish import (
+    text_type,
+    viewvalues,
+    )
+
+
+class MultiWalker(object):
+    """Walk multiple trees simultaneously, getting combined results."""
+
+    # Note: This could be written to not assume you can do out-of-order
+    #       lookups. Instead any nodes that don't match in all trees could be
+    #       marked as 'deferred', and then returned in the final cleanup loop.
+    #       For now, I think it is "nicer" to return things as close to the
+    #       "master_tree" order as we can.
+
+    def __init__(self, master_tree, other_trees):
+        """Create a new MultiWalker.
+
+        All trees being walked must implement "iter_entries_by_dir()", such
+        that they yield (path, object) tuples, where that object will have a
+        '.file_id' member, that can be used to check equality.
+
+        :param master_tree: All trees will be 'slaved' to the master_tree such
+            that nodes in master_tree will be used as 'first-pass' sync points.
+            Any nodes that aren't in master_tree will be merged in a second
+            pass.
+        :param other_trees: A list of other trees to walk simultaneously.
+        """
+        self._master_tree = master_tree
+        self._other_trees = other_trees
+
+        # Keep track of any nodes that were properly processed just out of
+        # order, that way we don't return them at the end, we don't have to
+        # track *all* processed file_ids, just the out-of-order ones
+        self._out_of_order_processed = set()
+
+    @staticmethod
+    def _step_one(iterator):
+        """Step an iter_entries_by_dir iterator.
+
+        :return: (has_more, path, ie)
+            If has_more is False, path and ie will be None.
+        """
+        try:
+            path, ie = next(iterator)
+        except StopIteration:
+            return False, None, None
+        else:
+            return True, path, ie
+
+    @staticmethod
+    def _lt_path_by_dirblock(path1, path2):
+        """Compare two paths based on what directory they are in.
+
+        This generates a sort order, such that all children of a directory are
+        sorted together, and grandchildren are in the same order as the
+        children appear. But all grandchildren come after all children.
+
+        :param path1: first path
+        :param path2: the second path
+        :return: negative number if ``path1`` comes first,
+            0 if paths are equal
+            and a positive number if ``path2`` sorts first
+        """
+        # Shortcut this special case
+        if path1 == path2:
+            return False
+        # This is stolen from _dirstate_helpers_py.py, only switching it to
+        # Unicode objects. Consider using encode_utf8() and then using the
+        # optimized versions, or maybe writing optimized unicode versions.
+        if not isinstance(path1, text_type):
+            raise TypeError("'path1' must be a unicode string, not %s: %r"
+                            % (type(path1), path1))
+        if not isinstance(path2, text_type):
+            raise TypeError("'path2' must be a unicode string, not %s: %r"
+                            % (type(path2), path2))
+        return (MultiWalker._path_to_key(path1) <
+                MultiWalker._path_to_key(path2))
+
+    @staticmethod
+    def _path_to_key(path):
+        dirname, basename = osutils.split(path)
+        return (dirname.split(u'/'), basename)
+
+    def _lookup_by_master_path(self, extra_entries, other_tree, master_path):
+        return self._lookup_by_file_id(
+            extra_entries, other_tree,
+            self._master_tree.path2id(master_path))
+
+    def _lookup_by_file_id(self, extra_entries, other_tree, file_id):
+        """Lookup an inventory entry by file_id.
+
+        This is called when an entry is missing in the normal order.
+        Generally this is because a file was either renamed, or it was
+        deleted/added. If the entry was found in the inventory and not in
+        extra_entries, it will be added to self._out_of_order_processed
+
+        :param extra_entries: A dictionary of {file_id: (path, ie)}.  This
+            should be filled with entries that were found before they were
+            used. If file_id is present, it will be removed from the
+            dictionary.
+        :param other_tree: The Tree to search, in case we didn't find the entry
+            yet.
+        :param file_id: The file_id to look for
+        :return: (path, ie) if found or (None, None) if not present.
+        """
+        if file_id in extra_entries:
+            return extra_entries.pop(file_id)
+        try:
+            cur_path = other_tree.id2path(file_id)
+        except errors.NoSuchId:
+            cur_path = None
+        if cur_path is None:
+            return (None, None)
+        else:
+            self._out_of_order_processed.add(file_id)
+            cur_ie = next(other_tree.iter_entries_by_dir(
+                specific_files=[cur_path]))[1]
+            return (cur_path, cur_ie)
+
+    def iter_all(self):
+        """Match up the values in the different trees."""
+        for result in self._walk_master_tree():
+            yield result
+        self._finish_others()
+        for result in self._walk_others():
+            yield result
+
+    def _walk_master_tree(self):
+        """First pass, walk all trees in lock-step.
+
+        When we are done, all nodes in the master_tree will have been
+        processed. _other_walkers, _other_entries, and _others_extra will be
+        set on 'self' for future processing.
+        """
+        # This iterator has the most "inlining" done, because it tends to touch
+        # every file in the tree, while the others only hit nodes that don't
+        # match.
+        master_iterator = self._master_tree.iter_entries_by_dir()
+
+        other_walkers = [other.iter_entries_by_dir()
+                         for other in self._other_trees]
+        other_entries = [self._step_one(walker) for walker in other_walkers]
+        # Track extra nodes in the other trees
+        others_extra = [{} for _ in range(len(self._other_trees))]
+
+        master_has_more = True
+        step_one = self._step_one
+        lookup_by_file_id = self._lookup_by_file_id
+        out_of_order_processed = self._out_of_order_processed
+
+        while master_has_more:
+            (master_has_more, path, master_ie) = step_one(master_iterator)
+            if not master_has_more:
+                break
+
+            other_values = []
+            other_values_append = other_values.append
+            next_other_entries = []
+            next_other_entries_append = next_other_entries.append
+            for idx, (other_has_more, other_path, other_ie) in enumerate(other_entries):
+                if not other_has_more:
+                    other_values_append(self._lookup_by_master_path(
+                        others_extra[idx], self._other_trees[idx], path))
+                    next_other_entries_append((False, None, None))
+                elif master_ie.file_id == other_ie.file_id:
+                    # This is the critical code path, as most of the entries
+                    # should match between most trees.
+                    other_values_append((other_path, other_ie))
+                    next_other_entries_append(step_one(other_walkers[idx]))
+                else:
+                    # This walker did not match, step it until it either
+                    # matches, or we know we are past the current walker.
+                    other_walker = other_walkers[idx]
+                    other_extra = others_extra[idx]
+                    while (other_has_more and
+                           self._lt_path_by_dirblock(other_path, path)):
+                        other_file_id = other_ie.file_id
+                        if other_file_id not in out_of_order_processed:
+                            other_extra[other_file_id] = (other_path, other_ie)
+                        other_has_more, other_path, other_ie = \
+                            step_one(other_walker)
+                    if other_has_more and other_ie.file_id == master_ie.file_id:
+                        # We ended up walking to this point, match and step
+                        # again
+                        other_values_append((other_path, other_ie))
+                        other_has_more, other_path, other_ie = \
+                            step_one(other_walker)
+                    else:
+                        # This record isn't in the normal order, see if it
+                        # exists at all.
+                        other_values_append(self._lookup_by_master_path(
+                            other_extra, self._other_trees[idx], path))
+                    next_other_entries_append((other_has_more, other_path,
+                                               other_ie))
+            other_entries = next_other_entries
+
+            # We've matched all the walkers, yield this datapoint
+            yield path, master_ie.file_id, master_ie, other_values
+        self._other_walkers = other_walkers
+        self._other_entries = other_entries
+        self._others_extra = others_extra
+
+    def _finish_others(self):
+        """Finish walking the other iterators, so we get all entries."""
+        for idx, info in enumerate(self._other_entries):
+            other_extra = self._others_extra[idx]
+            (other_has_more, other_path, other_ie) = info
+            while other_has_more:
+                other_file_id = other_ie.file_id
+                if other_file_id not in self._out_of_order_processed:
+                    other_extra[other_file_id] = (other_path, other_ie)
+                other_has_more, other_path, other_ie = \
+                    self._step_one(self._other_walkers[idx])
+        del self._other_entries
+
+    def _walk_others(self):
+        """Finish up by walking all the 'deferred' nodes."""
+        # TODO: One alternative would be to grab all possible unprocessed
+        #       file_ids, and then sort by path, and then yield them. That
+        #       might ensure better ordering, in case a caller strictly
+        #       requires parents before children.
+        for idx, other_extra in enumerate(self._others_extra):
+            others = sorted(viewvalues(other_extra),
+                            key=lambda x: self._path_to_key(x[0]))
+            for other_path, other_ie in others:
+                file_id = other_ie.file_id
+                # We don't need to check out_of_order_processed here, because
+                # the lookup_by_file_id will be removing anything processed
+                # from the extras cache
+                other_extra.pop(file_id)
+                other_values = [(None, None)] * idx
+                other_values.append((other_path, other_ie))
+                for alt_idx, alt_extra in enumerate(self._others_extra[idx + 1:]):
+                    alt_idx = alt_idx + idx + 1
+                    alt_extra = self._others_extra[alt_idx]
+                    alt_tree = self._other_trees[alt_idx]
+                    other_values.append(self._lookup_by_file_id(
+                        alt_extra, alt_tree, file_id))
+                yield other_path, file_id, None, other_values

=== modified file 'breezy/patch.py'
--- breezy/patch.py	2017-05-22 00:56:52 +0000
+++ breezy/patch.py	2019-05-11 09:50:14 +0000
@@ -1,4 +1,5 @@
 # Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005, 2008 Aaron Bentley, 2006 Michael Ellerman
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,16 +17,30 @@
 
 from __future__ import absolute_import
 
+"""Diff and patch functionality"""
+
 import errno
 import os
 from subprocess import Popen, PIPE
+import sys
 
-from .errors import NoDiff3
+from .errors import NoDiff3, BzrError
 from .textfile import check_text_path
 
-"""Diff and patch functionality"""
-
-__docformat__ = "restructuredtext"
+class PatchFailed(BzrError):
+
+    _fmt = """Patch application failed"""
+
+
+class PatchInvokeError(BzrError):
+
+    _fmt = """Error invoking patch: %(errstr)s%(stderr)s"""
+    internal_error = False
+
+    def __init__(self, e, stderr=''):
+        self.exception = e
+        self.errstr = os.strerror(e.errno)
+        self.stderr = '\n' + stderr
 
 
 _do_close_fds = True
@@ -96,9 +111,67 @@
             raise
     if status not in (0, 1):
         raise Exception(stderr)
-    f = open(out_file, 'wb')
-    try:
+    with open(out_file, 'wb') as f:
         f.write(output)
-    finally:
-        f.close()
     return status
+
+
+def patch_tree(tree, patches, strip=0, reverse=False, dry_run=False,
+               quiet=False, out=None):
+    """Apply a patch to a tree.
+
+    Args:
+      tree: A MutableTree object
+      patches: list of patches as bytes
+      strip: Strip X segments of paths
+      reverse: Apply reversal of patch
+      dry_run: Dry run
+    """
+    return run_patch(tree.basedir, patches, strip, reverse, dry_run,
+                     quiet, out=out)
+
+
+def run_patch(directory, patches, strip=0, reverse=False, dry_run=False,
+              quiet=False, _patch_cmd='patch', target_file=None, out=None):
+    args = [_patch_cmd, '-d', directory, '-s', '-p%d' % strip, '-f']
+    if quiet:
+        args.append('--quiet')
+
+    if sys.platform == "win32":
+        args.append('--binary')
+
+    if reverse:
+        args.append('-R')
+    if dry_run:
+        if sys.platform.startswith('freebsd'):
+            args.append('--check')
+        else:
+            args.append('--dry-run')
+        stderr = PIPE
+    else:
+        stderr = None
+    if target_file is not None:
+        args.append(target_file)
+
+    try:
+        process = Popen(args, stdin=PIPE, stdout=PIPE, stderr=stderr)
+    except OSError as e:
+        raise PatchInvokeError(e)
+    try:
+        for patch in patches:
+            process.stdin.write(bytes(patch))
+        process.stdin.close()
+
+    except IOError as e:
+        raise PatchInvokeError(e, process.stderr.read())
+
+    result = process.wait()
+    if not dry_run:
+        if out is not None:
+            out.write(process.stdout.read())
+        else:
+            process.stdout.read()
+    if result != 0:
+        raise PatchFailed()
+
+    return result

=== removed file 'breezy/patiencediff.py'
--- breezy/patiencediff.py	2018-11-12 01:41:38 +0000
+++ breezy/patiencediff.py	1970-01-01 00:00:00 +0000
@@ -1,239 +0,0 @@
-#!/usr/bin/env python
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-from __future__ import absolute_import
-
-from .lazy_import import lazy_import
-lazy_import(globals(), """
-import os
-import sys
-import time
-import difflib
-""")
-
-
-__all__ = ['PatienceSequenceMatcher', 'unified_diff', 'unified_diff_bytes',
-           'unified_diff_files']
-
-
-# This is a version of unified_diff which only adds a factory parameter
-# so that you can override the default SequenceMatcher
-# this has been submitted as a patch to python
-def unified_diff(a, b, fromfile='', tofile='', fromfiledate='',
-                 tofiledate='', n=3, lineterm='\n',
-                 sequencematcher=None):
-    r"""
-    Compare two sequences of lines; generate the delta as a unified diff.
-
-    Unified diffs are a compact way of showing line changes and a few
-    lines of context.  The number of context lines is set by 'n' which
-    defaults to three.
-
-    By default, the diff control lines (those with ---, +++, or @@) are
-    created with a trailing newline.  This is helpful so that inputs
-    created from file.readlines() result in diffs that are suitable for
-    file.writelines() since both the inputs and outputs have trailing
-    newlines.
-
-    For inputs that do not have trailing newlines, set the lineterm
-    argument to "" so that the output will be uniformly newline free.
-
-    The unidiff format normally has a header for filenames and modification
-    times.  Any or all of these may be specified using strings for
-    'fromfile', 'tofile', 'fromfiledate', and 'tofiledate'.  The modification
-    times are normally expressed in the format returned by time.ctime().
-
-    Example:
-
-    >>> for line in unified_diff('one two three four'.split(),
-    ...             'zero one tree four'.split(), 'Original', 'Current',
-    ...             'Sat Jan 26 23:30:50 1991', 'Fri Jun 06 10:20:52 2003',
-    ...             lineterm=''):
-    ...     print line
-    --- Original Sat Jan 26 23:30:50 1991
-    +++ Current Fri Jun 06 10:20:52 2003
-    @@ -1,4 +1,4 @@
-    +zero
-     one
-    -two
-    -three
-    +tree
-     four
-    """
-    if sequencematcher is None:
-        sequencematcher = difflib.SequenceMatcher
-
-    if fromfiledate:
-        fromfiledate = '\t' + str(fromfiledate)
-    if tofiledate:
-        tofiledate = '\t' + str(tofiledate)
-
-    started = False
-    for group in sequencematcher(None, a, b).get_grouped_opcodes(n):
-        if not started:
-            yield '--- %s%s%s' % (fromfile, fromfiledate, lineterm)
-            yield '+++ %s%s%s' % (tofile, tofiledate, lineterm)
-            started = True
-        i1, i2, j1, j2 = group[0][1], group[-1][2], group[0][3], group[-1][4]
-        yield "@@ -%d,%d +%d,%d @@%s" % (i1 + 1, i2 - i1, j1 + 1, j2 - j1, lineterm)
-        for tag, i1, i2, j1, j2 in group:
-            if tag == 'equal':
-                for line in a[i1:i2]:
-                    yield ' ' + line
-                continue
-            if tag == 'replace' or tag == 'delete':
-                for line in a[i1:i2]:
-                    yield '-' + line
-            if tag == 'replace' or tag == 'insert':
-                for line in b[j1:j2]:
-                    yield '+' + line
-
-
-def unified_diff_bytes(a, b, fromfile=b'', tofile=b'', fromfiledate=b'',
-                       tofiledate=b'', n=3, lineterm=b'\n', sequencematcher=None):
-    r"""
-    Compare two sequences of lines; generate the delta as a unified diff.
-
-    Unified diffs are a compact way of showing line changes and a few
-    lines of context.  The number of context lines is set by 'n' which
-    defaults to three.
-
-    By default, the diff control lines (those with ---, +++, or @@) are
-    created with a trailing newline.  This is helpful so that inputs
-    created from file.readlines() result in diffs that are suitable for
-    file.writelines() since both the inputs and outputs have trailing
-    newlines.
-
-    For inputs that do not have trailing newlines, set the lineterm
-    argument to "" so that the output will be uniformly newline free.
-
-    The unidiff format normally has a header for filenames and modification
-    times.  Any or all of these may be specified using strings for
-    'fromfile', 'tofile', 'fromfiledate', and 'tofiledate'.  The modification
-    times are normally expressed in the format returned by time.ctime().
-
-    Example:
-
-    >>> for line in bytes_unified_diff(b'one two three four'.split(),
-    ...             b'zero one tree four'.split(), b'Original', b'Current',
-    ...             b'Sat Jan 26 23:30:50 1991', b'Fri Jun 06 10:20:52 2003',
-    ...             lineterm=b''):
-    ...     print line
-    --- Original Sat Jan 26 23:30:50 1991
-    +++ Current Fri Jun 06 10:20:52 2003
-    @@ -1,4 +1,4 @@
-    +zero
-     one
-    -two
-    -three
-    +tree
-     four
-    """
-    if sequencematcher is None:
-        sequencematcher = difflib.SequenceMatcher
-
-    if fromfiledate:
-        fromfiledate = b'\t' + bytes(fromfiledate)
-    if tofiledate:
-        tofiledate = b'\t' + bytes(tofiledate)
-
-    started = False
-    for group in sequencematcher(None, a, b).get_grouped_opcodes(n):
-        if not started:
-            yield b'--- %s%s%s' % (fromfile, fromfiledate, lineterm)
-            yield b'+++ %s%s%s' % (tofile, tofiledate, lineterm)
-            started = True
-        i1, i2, j1, j2 = group[0][1], group[-1][2], group[0][3], group[-1][4]
-        yield b"@@ -%d,%d +%d,%d @@%s" % (i1 + 1, i2 - i1, j1 + 1, j2 - j1, lineterm)
-        for tag, i1, i2, j1, j2 in group:
-            if tag == 'equal':
-                for line in a[i1:i2]:
-                    yield b' ' + line
-                continue
-            if tag == 'replace' or tag == 'delete':
-                for line in a[i1:i2]:
-                    yield b'-' + line
-            if tag == 'replace' or tag == 'insert':
-                for line in b[j1:j2]:
-                    yield b'+' + line
-
-
-def unified_diff_files(a, b, sequencematcher=None):
-    """Generate the diff for two files.
-    """
-    # Should this actually be an error?
-    if a == b:
-        return []
-    if a == '-':
-        file_a = sys.stdin
-        time_a = time.time()
-    else:
-        file_a = open(a, 'rb')
-        time_a = os.stat(a).st_mtime
-
-    if b == '-':
-        file_b = sys.stdin
-        time_b = time.time()
-    else:
-        file_b = open(b, 'rb')
-        time_b = os.stat(b).st_mtime
-
-    # TODO: Include fromfiledate and tofiledate
-    return unified_diff_bytes(file_a.readlines(), file_b.readlines(),
-                              fromfile=a, tofile=b,
-                              sequencematcher=sequencematcher)
-
-
-try:
-    from ._patiencediff_c import (
-        unique_lcs_c as unique_lcs,
-        recurse_matches_c as recurse_matches,
-        PatienceSequenceMatcher_c as PatienceSequenceMatcher
-        )
-except ImportError:
-    from ._patiencediff_py import (
-        unique_lcs_py as unique_lcs,
-        recurse_matches_py as recurse_matches,
-        PatienceSequenceMatcher_py as PatienceSequenceMatcher
-        )  # noqa: F401
-
-
-def main(args):
-    import optparse
-    p = optparse.OptionParser(usage='%prog [options] file_a file_b'
-                                    '\nFiles can be "-" to read from stdin')
-    p.add_option('--patience', dest='matcher', action='store_const', const='patience',
-                 default='patience', help='Use the patience difference algorithm')
-    p.add_option('--difflib', dest='matcher', action='store_const', const='difflib',
-                 default='patience', help='Use python\'s difflib algorithm')
-
-    algorithms = {'patience': PatienceSequenceMatcher,
-                  'difflib': difflib.SequenceMatcher}
-
-    (opts, args) = p.parse_args(args)
-    matcher = algorithms[opts.matcher]
-
-    if len(args) != 2:
-        print('You must supply 2 filenames to diff')
-        return -1
-
-    for line in unified_diff_files(args[0], args[1], sequencematcher=matcher):
-        sys.stdout.write(line)
-
-
-if __name__ == '__main__':
-    sys.exit(main(sys.argv[1:]))

=== modified file 'breezy/plugins/commitfromnews/committemplate.py'
--- breezy/plugins/commitfromnews/committemplate.py	2018-11-16 18:33:17 +0000
+++ breezy/plugins/commitfromnews/committemplate.py	2019-03-02 21:46:18 +0000
@@ -18,7 +18,9 @@
 
 from __future__ import absolute_import
 
-from ... import bugtracker, osutils, patiencediff
+import patiencediff
+
+from ... import bugtracker, osutils
 import re
 
 _BUG_MATCH = re.compile(r'lp:(\d+)')

=== modified file 'breezy/plugins/fastimport/helpers.py'
--- breezy/plugins/fastimport/helpers.py	2018-11-17 16:53:10 +0000
+++ breezy/plugins/fastimport/helpers.py	2019-03-18 04:31:21 +0000
@@ -102,8 +102,8 @@
         try:
             os.mkdir(location)
         except IOError as ex:
-            errors.BzrCommandError("Unable to create %s: %s" %
-                                   (location, ex))
+            raise errors.BzrCommandError(
+                "Unable to create %s: %s" % (location, ex))
 
     # Create a repository for the nominated format.
     trace.note("Creating destination repository ...")

=== modified file 'breezy/plugins/launchpad/lp_api.py'
--- breezy/plugins/launchpad/lp_api.py	2019-02-14 18:55:19 +0000
+++ breezy/plugins/launchpad/lp_api.py	2019-05-29 09:48:08 +0000
@@ -78,7 +78,7 @@
     'staging': 'staging.launchpad.net',
     'qastaging': 'qastaging.launchpad.net',
     'demo': 'demo.launchpad.net',
-    'dev': 'launchpad.dev',
+    'dev': 'launchpad.test',
     }
 
 LAUNCHPAD_BAZAAR_DOMAINS = [

=== modified file 'breezy/plugins/launchpad/lp_directory.py'
--- breezy/plugins/launchpad/lp_directory.py	2019-02-09 02:59:15 +0000
+++ breezy/plugins/launchpad/lp_directory.py	2019-05-29 09:48:08 +0000
@@ -63,7 +63,7 @@
     """
     return (scheme in ('bzr+ssh', 'sftp')
             and (netloc.endswith('launchpad.net') or
-                 netloc.endswith('launchpad.dev')))
+                 netloc.endswith('launchpad.test')))
 
 
 def _expand_user(path, url, lp_login):

=== modified file 'breezy/plugins/launchpad/test_lp_directory.py'
--- breezy/plugins/launchpad/test_lp_directory.py	2019-02-09 02:59:15 +0000
+++ breezy/plugins/launchpad/test_lp_directory.py	2019-05-29 09:48:08 +0000
@@ -213,7 +213,7 @@
                            'lp:///apt')
         self.assertResolve('bzr+ssh://bazaar.launchpad.net/+branch/apt',
                            'lp://production/apt')
-        self.assertResolve('bzr+ssh://bazaar.launchpad.dev/+branch/apt',
+        self.assertResolve('bzr+ssh://bazaar.launchpad.test/+branch/apt',
                            'lp://dev/apt')
         self.assertResolve('bzr+ssh://bazaar.staging.launchpad.net/+branch/apt',
                            'lp://staging/apt')

=== modified file 'breezy/plugins/launchpad/test_lp_service.py'
--- breezy/plugins/launchpad/test_lp_service.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/launchpad/test_lp_service.py	2019-05-29 09:48:08 +0000
@@ -62,7 +62,7 @@
 
     def test_dev_service(self):
         service = LaunchpadService(lp_instance='dev')
-        self.assertEqual('https://xmlrpc.launchpad.dev/bazaar/',
+        self.assertEqual('https://xmlrpc.launchpad.test/bazaar/',
                          service.service_url)
 
     def test_demo_service(self):
@@ -178,7 +178,7 @@
         web_url = service.get_web_url_from_branch_url(
             'bzr+ssh://bazaar.launchpad.net/~foo/bar/baz')
         self.assertEqual(
-            'https://code.launchpad.dev/~foo/bar/baz', web_url)
+            'https://code.launchpad.test/~foo/bar/baz', web_url)
 
     def test_demo_url(self):
         service = LaunchpadService(lp_instance='demo')

=== modified file 'breezy/plugins/propose/cmds.py'
--- breezy/plugins/propose/cmds.py	2019-05-20 03:50:06 +0000
+++ breezy/plugins/propose/cmds.py	2019-06-03 23:48:08 +0000
@@ -143,6 +143,9 @@
         Option('name', help='Name of the new remote branch.', type=str),
         Option('description', help='Description of the change.', type=str),
         Option('prerequisite', help='Prerequisite branch.', type=str),
+        Option(
+            'commit-message',
+            help='Set commit message for merge, if supported', type=str),
         ListOption('labels', short_name='l', type=text_type,
                    help='Labels to apply.'),
         Option('no-allow-lossy',
@@ -154,7 +157,7 @@
 
     def run(self, submit_branch=None, directory='.', hoster=None,
             reviewers=None, name=None, no_allow_lossy=False, description=None,
-            labels=None, prerequisite=None):
+            labels=None, prerequisite=None, commit_message=None):
         tree, branch, relpath = (
             controldir.ControlDir.open_containing_tree_or_branch(directory))
         if submit_branch is None:
@@ -191,7 +194,8 @@
         try:
             proposal = proposal_builder.create_proposal(
                 description=description, reviewers=reviewers,
-                prerequisite_branch=prerequisite_branch, labels=labels)
+                prerequisite_branch=prerequisite_branch, labels=labels,
+                commit_message=commit_message)
         except _mod_propose.MergeProposalExists as e:
             raise errors.BzrCommandError(gettext(
                 'There is already a branch merge proposal: %s') % e.url)

=== modified file 'breezy/plugins/propose/github.py'
--- breezy/plugins/propose/github.py	2019-05-20 03:57:29 +0000
+++ breezy/plugins/propose/github.py	2019-06-03 23:48:08 +0000
@@ -27,6 +27,7 @@
     MergeProposalBuilder,
     MergeProposalExists,
     PrerequisiteBranchUnsupported,
+    CommitMessageUnsupported,
     UnsupportedHoster,
     )
 
@@ -122,6 +123,9 @@
     def get_description(self):
         return self._pr.body
 
+    def get_commit_message(self):
+        return None
+
     def set_description(self, description):
         self._pr.edit(body=description, title=determine_title(description))
 
@@ -173,6 +177,7 @@
     name = 'github'
 
     supports_merge_proposal_labels = True
+    supports_merge_proposal_commit_message = False
 
     def __repr__(self):
         return "GitHub()"
@@ -346,10 +351,11 @@
         return None
 
     def create_proposal(self, description, reviewers=None, labels=None,
-                        prerequisite_branch=None):
+                        prerequisite_branch=None, commit_message=None):
         """Perform the submission."""
         if prerequisite_branch is not None:
             raise PrerequisiteBranchUnsupported(self)
+        # Note that commit_message is ignored, since github doesn't support it.
         import github
         # TODO(jelmer): Probe for right repo name
         if self.target_repo_name.endswith('.git'):

=== modified file 'breezy/plugins/propose/gitlabs.py'
--- breezy/plugins/propose/gitlabs.py	2019-05-20 03:50:06 +0000
+++ breezy/plugins/propose/gitlabs.py	2019-06-03 23:48:08 +0000
@@ -149,6 +149,9 @@
         self._mr['description'] = description
         self.gl._update_merge_requests(self._mr)
 
+    def get_commit_message(self):
+        return None
+
     def _branch_url_from_project(self, project_id, branch_name):
         project = self.gl._get_project(project_id)
         return gitlab_url_to_bzr_url(project['http_url_to_repo'], branch_name)
@@ -180,6 +183,7 @@
     """GitLab hoster implementation."""
 
     supports_merge_proposal_labels = True
+    supports_merge_proposal_commit_message = False
 
     def __repr__(self):
         return "<GitLab(%r)>" % self.base_url
@@ -402,10 +406,12 @@
         return None
 
     def create_proposal(self, description, reviewers=None, labels=None,
-                        prerequisite_branch=None):
+                        prerequisite_branch=None, commit_message=None):
         """Perform the submission."""
+        # https://docs.gitlab.com/ee/api/merge_requests.html#create-mr
         if prerequisite_branch is not None:
             raise PrerequisiteBranchUnsupported(self)
+        # Note that commit_message is ignored, since Gitlab doesn't support it.
         # TODO(jelmer): Support reviewers
         source_project = self.gl._get_project(self.source_project_name)
         target_project = self.gl._get_project(self.target_project_name)

=== modified file 'breezy/plugins/propose/launchpad.py'
--- breezy/plugins/propose/launchpad.py	2019-05-20 03:32:45 +0000
+++ breezy/plugins/propose/launchpad.py	2019-06-03 23:48:08 +0000
@@ -73,7 +73,7 @@
     if url.startswith('lp:'):
         return True
     regex = re.compile('([a-z]*\+)*(bzr\+ssh|http|ssh|git|https)'
-                       '://(bazaar|git).*.launchpad.net')
+                       '://(bazaar|git).*\.launchpad\.net')
     return bool(regex.match(url))
 
 
@@ -142,6 +142,13 @@
         self._mp.description = description
         self._mp.lp_save()
 
+    def get_commit_message(self):
+        return self._mp.commit_message
+
+    def set_commit_message(self, commit_message):
+        self._mp.commit_message = commit_message
+        self._mp.lp_save()
+
     def close(self):
         self._mp.setStatus(status='Rejected')
 
@@ -154,6 +161,8 @@
     # https://bugs.launchpad.net/launchpad/+bug/397676
     supports_merge_proposal_labels = False
 
+    supports_merge_proposal_commit_message = True
+
     def __init__(self, staging=False):
         self._staging = staging
         if staging:
@@ -394,13 +403,12 @@
 
 class LaunchpadBazaarMergeProposalBuilder(MergeProposalBuilder):
 
-    def __init__(self, lp_host, source_branch, target_branch, message=None,
+    def __init__(self, lp_host, source_branch, target_branch,
                  staging=None, approve=None, fixes=None):
         """Constructor.
 
         :param source_branch: The branch to propose for merging.
         :param target_branch: The branch to merge into.
-        :param message: The commit message to use.  (May be None.)
         :param staging: If True, propose the merge against staging instead of
             production.
         :param approve: If True, mark the new proposal as approved immediately.
@@ -421,14 +429,11 @@
             self.target_branch = target_branch
             self.target_branch_lp = self.launchpad.branches.getByUrl(
                 url=target_branch.user_url)
-        self.commit_message = message
         self.approve = approve
         self.fixes = fixes
 
     def get_infotext(self):
         """Determine the initial comment for the merge proposal."""
-        if self.commit_message is not None:
-            return self.commit_message.strip().encode('utf-8')
         info = ["Source: %s\n" % self.source_branch_lp.bzr_identity]
         info.append("Target: %s\n" % self.target_branch_lp.bzr_identity)
         return ''.join(info)
@@ -480,10 +485,10 @@
                              revid=self.source_branch.last_revision())
 
     def create_proposal(self, description, reviewers=None, labels=None,
-                        prerequisite_branch=None):
+                        prerequisite_branch=None, commit_message=None):
         """Perform the submission."""
         if labels:
-            raise LabelsUnsupported()
+            raise LabelsUnsupported(self)
         if prerequisite_branch is not None:
             prereq = self.launchpad.branches.getByUrl(
                 url=prerequisite_branch.user_url)
@@ -497,7 +502,7 @@
                 target_branch=self.target_branch_lp,
                 prerequisite_branch=prereq,
                 initial_comment=description.strip(),
-                commit_message=self.commit_message,
+                commit_message=commit_message,
                 reviewers=[self.launchpad.people[reviewer].self_link
                            for reviewer in reviewers],
                 review_types=[None for reviewer in reviewers])
@@ -521,13 +526,12 @@
 
 class LaunchpadGitMergeProposalBuilder(MergeProposalBuilder):
 
-    def __init__(self, lp_host, source_branch, target_branch, message=None,
+    def __init__(self, lp_host, source_branch, target_branch,
                  staging=None, approve=None, fixes=None):
         """Constructor.
 
         :param source_branch: The branch to propose for merging.
         :param target_branch: The branch to merge into.
-        :param message: The commit message to use.  (May be None.)
         :param staging: If True, propose the merge against staging instead of
             production.
         :param approve: If True, mark the new proposal as approved immediately.
@@ -549,14 +553,11 @@
             self.target_branch = target_branch
             (self.target_repo_lp, self.target_branch_lp) = (
                 self.lp_host._get_lp_git_ref_from_branch(target_branch))
-        self.commit_message = message
         self.approve = approve
         self.fixes = fixes
 
     def get_infotext(self):
         """Determine the initial comment for the merge proposal."""
-        if self.commit_message is not None:
-            return self.commit_message.strip().encode('utf-8')
         info = ["Source: %s\n" % self.source_branch.user_url]
         info.append("Target: %s\n" % self.target_branch.user_url)
         return ''.join(info)
@@ -609,10 +610,10 @@
                 revid=self.source_branch.last_revision())
 
     def create_proposal(self, description, reviewers=None, labels=None,
-                        prerequisite_branch=None):
+                        prerequisite_branch=None, commit_message=None):
         """Perform the submission."""
         if labels:
-            raise LabelsUnsupported()
+            raise LabelsUnsupported(self)
         if prerequisite_branch is not None:
             (prereq_repo_lp, prereq_branch_lp) = (
                 self.lp_host._get_lp_git_ref_from_branch(prerequisite_branch))
@@ -626,7 +627,7 @@
                 merge_target=self.target_branch_lp,
                 merge_prerequisite=prereq_branch_lp,
                 initial_comment=description.strip(),
-                commit_message=self.commit_message,
+                commit_message=commit_message,
                 needs_review=True,
                 reviewers=[self.launchpad.people[reviewer].self_link
                            for reviewer in reviewers],

=== modified file 'breezy/plugins/propose/propose.py'
--- breezy/plugins/propose/propose.py	2019-05-20 03:38:22 +0000
+++ breezy/plugins/propose/propose.py	2019-06-03 23:48:08 +0000
@@ -111,6 +111,14 @@
         """Set the description of the merge proposal."""
         raise NotImplementedError(self.set_description)
 
+    def get_commit_message(self):
+        """Get the proposed commit message."""
+        raise NotImplementedError(self.get_commit_message)
+
+    def set_commit_message(self, commit_message):
+        """Set the propose commit message."""
+        raise NotImplementedError(self.set_commit_message)
+
     def get_source_branch_url(self):
         """Return the source branch."""
         raise NotImplementedError(self.get_source_branch_url)
@@ -154,13 +162,14 @@
         raise NotImplementedError(self.get_infotext)
 
     def create_proposal(self, description, reviewers=None, labels=None,
-                        prerequisite_branch=None):
+                        prerequisite_branch=None, commit_message=None):
         """Create a proposal to merge a branch for merging.
 
         :param description: Description for the merge proposal
         :param reviewers: Optional list of people to ask reviews from
         :param labels: Labels to attach to the proposal
         :param prerequisite_branch: Optional prerequisite branch
+        :param commit_message: Optional commit message
         :return: A `MergeProposal` object
         """
         raise NotImplementedError(self.create_proposal)
@@ -174,6 +183,10 @@
     # proposals?
     supports_merge_proposal_labels = None
 
+    # Does this hoster support suggesting a commit message in the
+    # merge proposal?
+    supports_merge_proposal_commit_message = None
+
     # The base_url that would be visible to users. I.e. https://github.com/
     # rather than https://api.github.com/
     base_url = None

=== modified file 'breezy/plugins/repodebug/missing_keys_for_stacking_fixer.py'
--- breezy/plugins/repodebug/missing_keys_for_stacking_fixer.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/repodebug/missing_keys_for_stacking_fixer.py	2019-05-29 03:22:34 +0000
@@ -21,6 +21,7 @@
 from ... import errors
 from ...sixish import viewvalues
 from ...bzr.vf_search import PendingAncestryResult
+from ...repository import WriteGroup
 from ...revision import NULL_REVISION
 
 
@@ -77,14 +78,8 @@
             assert raw_r._format.network_name() == b.repository._format.network_name()
             stream = b.repository.inventories.get_record_stream(
                 needed, 'topological', True)
-            raw_r.start_write_group()
-            try:
+            with WriteGroup(raw_r):
                 raw_r.inventories.insert_record_stream(stream)
-            except:
-                raw_r.abort_write_group()
-                raise
-            else:
-                raw_r.commit_write_group()
         finally:
             raw_r.unlock()
         b.unlock()

=== modified file 'breezy/python-compat.h'
--- breezy/python-compat.h	2018-08-21 00:53:34 +0000
+++ breezy/python-compat.h	2019-03-05 07:56:11 +0000
@@ -25,6 +25,10 @@
 #ifndef _BZR_PYTHON_COMPAT_H
 #define _BZR_PYTHON_COMPAT_H
 
+#ifdef _MSC_VER
+#define inline __inline
+#endif
+
 #if PY_MAJOR_VERSION >= 3
 
 #define PyInt_FromSsize_t PyLong_FromSsize_t

=== modified file 'breezy/repository.py'
--- breezy/repository.py	2019-02-04 19:39:30 +0000
+++ breezy/repository.py	2019-06-02 05:13:10 +0000
@@ -236,6 +236,28 @@
                                                       self.unlock)
 
 
+class WriteGroup(object):
+    """Context manager that manages a write group.
+
+    Raising an exception will result in the write group being aborted.
+    """
+
+    def __init__(self, repository, suppress_errors=False):
+        self.repository = repository
+        self._suppress_errors = suppress_errors
+
+    def __enter__(self):
+        self.repository.start_write_group()
+        return self
+
+    def __exit__(self, exc_type, exc_val, exc_tb):
+        if exc_type:
+            self.repository.abort_write_group(self._suppress_errors)
+            return False
+        else:
+            self.repository.commit_write_group()
+
+
 ######################################################################
 # Repositories
 
@@ -923,16 +945,14 @@
         partial_history = [known_revid]
         distance_from_known = known_revno - revno
         if distance_from_known < 0:
-            raise ValueError(
-                'requested revno (%d) is later than given known revno (%d)'
-                % (revno, known_revno))
+            raise errors.RevnoOutOfBounds(revno, (0, known_revno))
         try:
             _iter_for_revno(
                 self, partial_history, stop_index=distance_from_known)
         except errors.RevisionNotPresent as err:
             if err.revision_id == known_revid:
                 # The start revision (known_revid) wasn't found.
-                raise
+                raise errors.NoSuchRevision(self, known_revid)
             # This is a stacked repository with no fallbacks, or a there's a
             # left-hand ghost.  Either way, even though the revision named in
             # the error isn't in this repo, we know it's the next step in this

=== modified file 'breezy/revisionspec.py'
--- breezy/revisionspec.py	2018-11-11 04:08:32 +0000
+++ breezy/revisionspec.py	2019-02-26 08:09:10 +0000
@@ -73,7 +73,7 @@
         if not self._has_revno and self.rev_id is not None:
             try:
                 self._revno = self.branch.revision_id_to_revno(self.rev_id)
-            except errors.NoSuchRevision:
+            except (errors.NoSuchRevision, errors.RevnoOutOfBounds):
                 self._revno = None
             self._has_revno = True
         return self._revno
@@ -405,7 +405,7 @@
             try:
                 revision_id = branch.dotted_revno_to_revision_id(match_revno,
                                                                  _cache_reverse=True)
-            except errors.NoSuchRevision:
+            except (errors.NoSuchRevision, errors.RevnoOutOfBounds):
                 raise errors.InvalidRevisionSpec(self.user_spec, branch)
             else:
                 # there is no traditional 'revno' for dotted-decimal revnos.
@@ -422,7 +422,7 @@
                     revno = last_revno + revno + 1
             try:
                 revision_id = branch.get_rev_id(revno)
-            except errors.NoSuchRevision:
+            except (errors.NoSuchRevision, errors.RevnoOutOfBounds):
                 raise errors.InvalidRevisionSpec(self.user_spec, branch)
         return branch, revno, revision_id
 
@@ -515,7 +515,7 @@
         revno = last_revno - offset + 1
         try:
             revision_id = context_branch.get_rev_id(revno)
-        except errors.NoSuchRevision:
+        except (errors.NoSuchRevision, errors.RevnoOutOfBounds):
             raise errors.InvalidRevisionSpec(self.user_spec, context_branch)
         return revno, revision_id
 
@@ -567,7 +567,7 @@
             revno = r.revno - 1
             try:
                 revision_id = branch.get_rev_id(revno, revs)
-            except errors.NoSuchRevision:
+            except (errors.NoSuchRevision, errors.RevnoOutOfBounds):
                 raise errors.InvalidRevisionSpec(self.user_spec,
                                                  branch)
         return RevisionInfo(branch, revno, revision_id)

=== modified file 'breezy/shelf_ui.py'
--- breezy/shelf_ui.py	2019-01-01 21:08:01 +0000
+++ breezy/shelf_ui.py	2019-03-02 21:46:18 +0000
@@ -16,6 +16,7 @@
 
 from __future__ import absolute_import
 
+import patiencediff
 import shutil
 import sys
 import tempfile
@@ -29,7 +30,6 @@
     errors,
     osutils,
     patches,
-    patiencediff,
     shelf,
     textfile,
     trace,

=== modified file 'breezy/tests/__init__.py'
--- breezy/tests/__init__.py	2019-02-03 23:43:20 +0000
+++ breezy/tests/__init__.py	2019-06-03 05:21:20 +0000
@@ -3990,6 +3990,7 @@
 test_prefix_alias_registry.register('bd', 'breezy.doc')
 test_prefix_alias_registry.register('bu', 'breezy.utils')
 test_prefix_alias_registry.register('bt', 'breezy.tests')
+test_prefix_alias_registry.register('bgt', 'breezy.git.tests')
 test_prefix_alias_registry.register('bb', 'breezy.tests.blackbox')
 test_prefix_alias_registry.register('bp', 'breezy.plugins')
 
@@ -4140,12 +4141,14 @@
         'breezy.tests.test_memorytree',
         'breezy.tests.test_merge',
         'breezy.tests.test_merge3',
+        'breezy.tests.test_mergeable',
         'breezy.tests.test_merge_core',
         'breezy.tests.test_merge_directive',
         'breezy.tests.test_mergetools',
         'breezy.tests.test_missing',
         'breezy.tests.test_msgeditor',
         'breezy.tests.test_multiparent',
+        'breezy.tests.test_multiwalker',
         'breezy.tests.test_mutabletree',
         'breezy.tests.test_nonascii',
         'breezy.tests.test_options',

=== modified file 'breezy/tests/blackbox/__init__.py'
--- breezy/tests/blackbox/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/__init__.py	2019-06-02 03:11:13 +0000
@@ -92,6 +92,7 @@
         'test_non_ascii',
         'test_outside_wt',
         'test_pack',
+        'test_patch',
         'test_ping',
         'test_plugins',
         'test_pull',
@@ -106,6 +107,7 @@
         'test_remove_tree',
         'test_repair_workingtree',
         'test_resolve',
+        'test_resolve_location',
         'test_revert',
         'test_revno',
         'test_revision_history',

=== modified file 'breezy/tests/blackbox/test_bisect.py'
--- breezy/tests/blackbox/test_bisect.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_bisect.py	2019-03-05 09:17:49 +0000
@@ -28,6 +28,7 @@
 from .. import (
     KnownFailure,
     TestCaseWithTransport,
+    TestSkipped,
     )
 from ...bzr.bzrdir import BzrDir
 

=== added file 'breezy/tests/blackbox/test_patch.py'
--- breezy/tests/blackbox/test_patch.py	1970-01-01 00:00:00 +0000
+++ breezy/tests/blackbox/test_patch.py	2019-04-06 12:46:37 +0000
@@ -0,0 +1,36 @@
+# Copyright (C) 2019 Breezy Developers
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+from breezy.tests import TestCaseWithTransport
+
+
+class TestPatch(TestCaseWithTransport):
+
+    def test_patch(self):
+        self.run_bzr('init')
+        with open('myfile', 'w') as f:
+            f.write('hello')
+        self.run_bzr('add')
+        self.run_bzr('commit -m hello')
+        with open('myfile', 'w') as f:
+            f.write('goodbye')
+        with open('mypatch', 'w') as f:
+            f.write(self.run_bzr('diff -p1', retcode=1)[0])
+        self.run_bzr('revert')
+        self.assertFileEqual('hello', 'myfile')
+        self.run_bzr('patch -p1 --silent mypatch')
+        self.assertFileEqual('goodbye', 'myfile')

=== modified file 'breezy/tests/blackbox/test_reconcile.py'
--- breezy/tests/blackbox/test_reconcile.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_reconcile.py	2019-05-29 03:22:34 +0000
@@ -21,6 +21,7 @@
     controldir,
     tests,
     )
+from breezy.repository import WriteGroup
 from breezy.bzr import (
     inventory,
     )
@@ -53,10 +54,8 @@
         inv = inventory.Inventory(revision_id=b'missing')
         inv.root.revision = b'missing'
         repo.lock_write()
-        repo.start_write_group()
-        repo.add_inventory(b'missing', inv, [])
-        repo.commit_write_group()
-        repo.unlock()
+        with repo.lock_write(), WriteGroup(repo):
+            repo.add_inventory(b'missing', inv, [])
         (out, err) = self.run_bzr('reconcile')
         if repo._reconcile_backsup_inventory:
             does_backup_text = (

=== modified file 'breezy/tests/blackbox/test_remove.py'
--- breezy/tests/blackbox/test_remove.py	2018-11-17 18:49:41 +0000
+++ breezy/tests/blackbox/test_remove.py	2019-03-05 09:17:49 +0000
@@ -23,6 +23,7 @@
     features,
     TestCaseWithTransport,
     TestSkipped,
+    TestNotApplicable,
     )
 from breezy.workingtree import WorkingTree
 from breezy import osutils
@@ -278,7 +279,7 @@
     def test_remove_backslash(self):
         # pad.lv/176263
         if os.path.sep == '\\':
-            raise tests.TestNotApplicable(
+            raise TestNotApplicable(
                 'unable to add filenames with backslashes where '
                 ' it is the path separator')
         tree = self.make_branch_and_tree('.')

=== added file 'breezy/tests/blackbox/test_resolve_location.py'
--- breezy/tests/blackbox/test_resolve_location.py	1970-01-01 00:00:00 +0000
+++ breezy/tests/blackbox/test_resolve_location.py	2019-06-02 05:14:37 +0000
@@ -0,0 +1,42 @@
+# Copyright (C) 2019 Breezy Developers
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+from breezy.tests import TestCaseWithTransport
+
+
+class TestCatRevision(TestCaseWithTransport):
+
+    def test_already_url(self):
+        wt = self.make_branch_and_tree('.')
+
+        out, err = self.run_bzr('resolve-location %s' % wt.branch.user_url)
+        self.assertEqual(out, '%s\n' % wt.branch.user_url.replace('file://', ''))
+
+    def test_parent_missing(self):
+        wt = self.make_branch_and_tree('.')
+
+        out, err = self.run_bzr('resolve-location :parent', retcode=3)
+        self.assertEqual(out, '')
+        self.assertEqual(err, 'brz: ERROR: No parent location assigned.\n')
+
+    def test_parent(self):
+        wt = self.make_branch_and_tree('.')
+        wt.branch.set_parent('http://example.com/foo')
+
+        out, err = self.run_bzr('resolve-location :parent')
+        self.assertEqual(out, 'http://example.com/foo\n')
+        self.assertEqual(err, '')

=== modified file 'breezy/tests/features.py'
--- breezy/tests/features.py	2019-02-27 03:13:15 +0000
+++ breezy/tests/features.py	2019-05-28 21:46:09 +0000
@@ -404,8 +404,6 @@
 testtools = ModuleAvailableFeature('testtools')
 flake8 = ModuleAvailableFeature('flake8.api.legacy')
 
-compiled_patiencediff_feature = ModuleAvailableFeature(
-    'breezy._patiencediff_c')
 lsprof_feature = ModuleAvailableFeature('breezy.lsprof')
 pkg_resources_feature = ModuleAvailableFeature('pkg_resources')
 

=== modified file 'breezy/tests/per_branch/__init__.py'
--- breezy/tests/per_branch/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_branch/__init__.py	2019-02-15 18:22:39 +0000
@@ -155,6 +155,7 @@
         'create_clone',
         'commit',
         'dotted_revno_to_revision_id',
+        'get_rev_id',
         'get_revision_id_to_revno_map',
         'hooks',
         'http',

=== modified file 'breezy/tests/per_branch/test_dotted_revno_to_revision_id.py'
--- breezy/tests/per_branch/test_dotted_revno_to_revision_id.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_branch/test_dotted_revno_to_revision_id.py	2019-03-13 23:24:13 +0000
@@ -17,6 +17,8 @@
 """Tests for Branch.dotted_revno_to_revision_id()"""
 
 from breezy import errors
+from breezy.bzr.fullhistory import FullHistoryBzrBranch
+from breezy.tests import TestNotApplicable
 
 from breezy.tests.per_branch import TestCaseWithBranch
 
@@ -52,3 +54,20 @@
         self.assertEqual(
             (1,),
             the_branch._partial_revision_id_to_revno_cache.get(revmap['1']))
+
+    def test_ghost_revision(self):
+        if not self.bzrdir_format.repository_format.supports_ghosts:
+            raise TestNotApplicable("repository format does not support ghosts")
+        builder = self.make_branch_builder('foo')
+        builder.start_series()
+        try:
+            revid1 = builder.build_snapshot(
+                [b'ghost'], [('add', ('', b'ROOT_ID', 'directory', ''))],
+                allow_leftmost_as_ghost=True, revision_id=b'tip')
+        finally:
+            builder.finish_series()
+        b = builder.get_branch()
+        if isinstance(b, FullHistoryBzrBranch):
+            raise TestNotApplicable("branch format stores full history")
+        b.set_last_revision_info(4, revid1)
+        self.assertRaises(errors.GhostRevisionsHaveNoRevno, b.dotted_revno_to_revision_id, (2,))

=== added file 'breezy/tests/per_branch/test_get_rev_id.py'
--- breezy/tests/per_branch/test_get_rev_id.py	1970-01-01 00:00:00 +0000
+++ breezy/tests/per_branch/test_get_rev_id.py	2019-02-26 09:25:20 +0000
@@ -0,0 +1,40 @@
+# Copyright (C) 2007, 2009-2012, 2016 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tests for Branch.get_rev_id."""
+
+from breezy.errors import RevnoOutOfBounds
+from breezy.revision import NULL_REVISION
+from breezy.tests import TestCaseWithTransport
+
+
+class TestGetRevid(TestCaseWithTransport):
+
+    def test_empty_branch(self):
+        # on an empty branch we want (0, NULL_REVISION)
+        branch = self.make_branch('branch')
+        self.assertEqual(NULL_REVISION, branch.get_rev_id(0))
+        self.assertRaises(RevnoOutOfBounds, branch.get_rev_id, 1)
+        self.assertRaises(RevnoOutOfBounds, branch.get_rev_id, -1)
+
+    def test_non_empty_branch(self):
+        # after the second commit we want (2, 'second-revid')
+        tree = self.make_branch_and_tree('branch')
+        revid1 = tree.commit('1st post')
+        revid2 = tree.commit('2st post', allow_pointless=True)
+        self.assertEqual(revid2, tree.branch.get_rev_id(2))
+        self.assertEqual(revid1, tree.branch.get_rev_id(1))
+        self.assertRaises(RevnoOutOfBounds, tree.branch.get_rev_id, 3)

=== modified file 'breezy/tests/per_controldir/test_controldir.py'
--- breezy/tests/per_controldir/test_controldir.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_controldir/test_controldir.py	2019-05-29 03:22:34 +0000
@@ -24,6 +24,7 @@
     errors,
     gpg,
     osutils,
+    repository as _mod_repository,
     revision as _mod_revision,
     transport,
     ui,
@@ -319,11 +320,8 @@
         tree_repo = tree.branch.repository
         if not tree_repo._format.supports_revision_signatures:
             self.skipTest('repository format does not support signing')
-        tree_repo.lock_write()
-        tree_repo.start_write_group()
-        tree_repo.sign_revision(rev1, gpg.LoopbackGPGStrategy(None))
-        tree_repo.commit_write_group()
-        tree_repo.unlock()
+        with tree_repo.lock_write(), _mod_repository.WriteGroup(tree_repo):
+            tree_repo.sign_revision(rev1, gpg.LoopbackGPGStrategy(None))
         target = self.make_branch('target')
         tree.branch.repository.copy_content_into(target.repository)
         tree.branch.copy_content_into(target)

=== modified file 'breezy/tests/per_interrepository/test_fetch.py'
--- breezy/tests/per_interrepository/test_fetch.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_interrepository/test_fetch.py	2019-05-29 03:22:34 +0000
@@ -32,6 +32,7 @@
 from breezy.bzr.vf_search import (
     SearchResult,
     )
+from breezy.repository import WriteGroup
 from breezy.revision import (
     NULL_REVISION,
     Revision,
@@ -110,8 +111,7 @@
         source = tree.branch.repository
         source.lock_write()
         self.addCleanup(source.unlock)
-        source.start_write_group()
-        try:
+        with WriteGroup(source):
             # We need two revisions: OLD and NEW. NEW will claim to need a file
             # 'FOO' changed in 'OLD'. OLD will not have that file at all.
             source.texts.insert_record_stream([
@@ -133,11 +133,6 @@
                            revision_id=b'new',
                            parent_ids=[revid])
             source.add_revision(rev.revision_id, rev)
-        except:
-            source.abort_write_group()
-            raise
-        else:
-            source.commit_write_group()
         to_repo.fetch(source, b'new')
         to_repo.lock_read()
         self.addCleanup(to_repo.unlock)
@@ -448,17 +443,12 @@
         # We build a broken revision so that we can test the fetch code dies
         # properly. So copy the inventory and revision, but not the text.
         with to_repo.lock_write():
-            to_repo.start_write_group()
-            try:
+            with WriteGroup(to_repo, suppress_errors=True):
                 inv = tree.branch.repository.get_inventory(rev1)
                 to_repo.add_inventory(rev1, inv, [])
                 rev = tree.branch.repository.get_revision(rev1)
                 to_repo.add_revision(rev1, rev, inv=inv)
                 self.disable_commit_write_group_paranoia(to_repo)
-                to_repo.commit_write_group()
-            except:
-                to_repo.abort_write_group(suppress_errors=True)
-                raise
 
         # Implementations can either ensure that the target of the delta is
         # reconstructable, or raise an exception (which stream based copies

=== modified file 'breezy/tests/per_interrepository/test_interrepository.py'
--- breezy/tests/per_interrepository/test_interrepository.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_interrepository/test_interrepository.py	2019-05-29 03:22:34 +0000
@@ -22,6 +22,7 @@
 import breezy.errors as errors
 import breezy.gpg
 from breezy.bzr.inventory import Inventory
+from breezy.repository import WriteGroup
 from breezy.revision import NULL_REVISION
 from breezy.tests import (
     TestNotApplicable,
@@ -65,13 +66,10 @@
         tree_a = self.make_branch_and_tree('a')
         self.controldir = tree_a.branch.controldir
         # add a corrupt inventory 'orphan'
-        tree_a.branch.repository.lock_write()
-        tree_a.branch.repository.start_write_group()
-        if tree_a.branch.repository._format.supports_ghosts:
-            inv_file = tree_a.branch.repository.inventories
-            inv_file.add_lines((b'orphan',), [], [])
-        tree_a.branch.repository.commit_write_group()
-        tree_a.branch.repository.unlock()
+        with tree_a.branch.repository.lock_write(), WriteGroup(tree_a.branch.repository):
+            if tree_a.branch.repository._format.supports_ghosts:
+                inv_file = tree_a.branch.repository.inventories
+                inv_file.add_lines((b'orphan',), [], [])
         # add a real revision 'rev1'
         self.rev1 = tree_a.commit('rev1', allow_pointless=True)
         # add a real revision 'rev2' based on rev1
@@ -149,12 +147,10 @@
                 'to repository does not support signatures')
         # and sign 'rev2'
         tree_a = WorkingTree.open('a')
-        tree_a.branch.repository.lock_write()
-        tree_a.branch.repository.start_write_group()
-        tree_a.branch.repository.sign_revision(self.rev2,
-                                               breezy.gpg.LoopbackGPGStrategy(None))
-        tree_a.branch.repository.commit_write_group()
-        tree_a.branch.repository.unlock()
+        with tree_a.branch.repository.lock_write(), \
+                WriteGroup(tree_a.branch.repository):
+            tree_a.branch.repository.sign_revision(
+                self.rev2, breezy.gpg.LoopbackGPGStrategy(None))
 
         from_repo = self.controldir.open_repository()
         from_signature = from_repo.get_signature_text(self.rev2)

=== modified file 'breezy/tests/per_pack_repository.py'
--- breezy/tests/per_pack_repository.py	2019-01-09 00:04:02 +0000
+++ breezy/tests/per_pack_repository.py	2019-05-29 03:22:34 +0000
@@ -473,26 +473,15 @@
         r1 = repository.Repository.open('.')
         r2 = repository.Repository.open('.')
         # add a pack to drop
-        r1.lock_write()
-        try:
-            r1.start_write_group()
-            try:
+        with r1.lock_write():
+            with repository.WriteGroup(r1):
                 self._add_text(r1, b'fileidr1')
-            except:
-                r1.abort_write_group()
-                raise
-            else:
-                r1.commit_write_group()
             r1._pack_collection.ensure_loaded()
             name_to_drop = r1._pack_collection.all_packs()[0].name
-        finally:
-            r1.unlock()
-        r1.lock_write()
-        try:
+        with r1.lock_write():
             # access enough data to load the names list
             list(r1.all_revision_ids())
-            r2.lock_write()
-            try:
+            with r2.lock_write():
                 # access enough data to load the names list
                 list(r2.all_revision_ids())
                 r1._pack_collection.ensure_loaded()
@@ -533,10 +522,6 @@
                                  r2._pack_collection.names())
                 self.assertEqual(1, len(r1._pack_collection.names()))
                 self.assertFalse(name_to_drop in r1._pack_collection.names())
-            finally:
-                r2.unlock()
-        finally:
-            r1.unlock()
 
     def test_concurrent_pack_triggers_reload(self):
         # create 2 packs, which we will then collapse

=== modified file 'breezy/tests/per_repository/__init__.py'
--- breezy/tests/per_repository/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_repository/__init__.py	2019-02-15 18:22:39 +0000
@@ -118,6 +118,7 @@
         'test_fetch',
         'test_file_graph',
         'test_get_parent_map',
+        'test_get_rev_id_for_revno',
         'test_has_same_location',
         'test_has_revisions',
         'test_locking',

=== added file 'breezy/tests/per_repository/test_get_rev_id_for_revno.py'
--- breezy/tests/per_repository/test_get_rev_id_for_revno.py	1970-01-01 00:00:00 +0000
+++ breezy/tests/per_repository/test_get_rev_id_for_revno.py	2019-02-26 09:25:20 +0000
@@ -0,0 +1,61 @@
+# Copyright (C) 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tests for get_rev_id_for_revno."""
+
+from breezy import errors
+from breezy.tests.per_repository_reference import (
+    TestCaseWithExternalReferenceRepository,
+    )
+
+
+class TestGetRevIdForRevno(TestCaseWithExternalReferenceRepository):
+
+    def setUp(self):
+        super(TestGetRevIdForRevno, self).setUp()
+        self.tree = self.make_branch_and_tree('base')
+        self.revid1 = self.tree.commit('one')
+        self.revid2 = self.tree.commit('two')
+        self.revid3 = self.tree.commit('three')
+
+    def test_success(self):
+        repo = self.tree.branch.repository
+        repo.lock_read()
+        self.addCleanup(repo.unlock)
+        self.assertEqual(
+            (True, self.revid1),
+            repo.get_rev_id_for_revno(1, (3, self.revid3)))
+        self.assertEqual(
+            (True, self.revid2),
+            repo.get_rev_id_for_revno(2, (3, self.revid3)))
+
+    def test_unknown_revision(self):
+        tree2 = self.make_branch_and_tree('other')
+        unknown_revid = tree2.commit('other')
+        repo = self.tree.branch.repository
+        repo.lock_read()
+        self.addCleanup(repo.unlock)
+        self.assertRaises(
+            errors.NoSuchRevision,
+            repo.get_rev_id_for_revno, 1, (3, unknown_revid))
+
+    def test_known_pair_is_after(self):
+        repo = self.tree.branch.repository
+        repo.lock_read()
+        self.addCleanup(repo.unlock)
+        self.assertRaises(
+            errors.RevnoOutOfBounds,
+            repo.get_rev_id_for_revno, 3, (2, self.revid2))

=== modified file 'breezy/tests/per_repository/test_signatures.py'
--- breezy/tests/per_repository/test_signatures.py	2018-11-29 23:42:41 +0000
+++ breezy/tests/per_repository/test_signatures.py	2019-05-29 03:22:34 +0000
@@ -22,7 +22,7 @@
     tests,
     urlutils,
     )
-
+from breezy.repository import WriteGroup
 from breezy.bzr.testament import Testament
 from breezy.tests import per_repository
 
@@ -58,24 +58,14 @@
     def test_store_signature(self):
         wt = self.make_branch_and_tree('.')
         branch = wt.branch
-        branch.lock_write()
-        try:
-            branch.repository.start_write_group()
+        with branch.lock_write(), WriteGroup(branch.repository):
             try:
                 branch.repository.store_revision_signature(
                     gpg.LoopbackGPGStrategy(None), b'FOO', b'A')
             except errors.NoSuchRevision:
-                branch.repository.abort_write_group()
                 raise tests.TestNotApplicable(
                     "repository does not support signing non-present"
                     "revisions")
-            except:
-                branch.repository.abort_write_group()
-                raise
-            else:
-                branch.repository.commit_write_group()
-        finally:
-            branch.unlock()
         # A signature without a revision should not be accessible.
         self.assertRaises(errors.NoSuchRevision,
                           branch.repository.has_signature_for_revision_id,

=== modified file 'breezy/tests/per_repository_chk/test_supported.py'
--- breezy/tests/per_repository_chk/test_supported.py	2018-11-16 11:37:47 +0000
+++ breezy/tests/per_repository_chk/test_supported.py	2019-05-29 03:22:34 +0000
@@ -38,24 +38,14 @@
 
     def test_add_bytes_to_chk_bytes_store(self):
         repo = self.make_repository('.')
-        repo.lock_write()
-        try:
-            repo.start_write_group()
-            try:
-                sha1, len, _ = repo.chk_bytes.add_lines((None,),
-                                                        None, [b"foo\n", b"bar\n"], random_id=True)
-                self.assertEqual(b'4e48e2c9a3d2ca8a708cb0cc545700544efb5021',
-                                 sha1)
-                self.assertEqual(
-                    {(b'sha1:4e48e2c9a3d2ca8a708cb0cc545700544efb5021',)},
-                    repo.chk_bytes.keys())
-            except:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
-        finally:
-            repo.unlock()
+        with repo.lock_write(), repository.WriteGroup(repo):
+            sha1, len, _ = repo.chk_bytes.add_lines(
+                (None,), None, [b"foo\n", b"bar\n"], random_id=True)
+            self.assertEqual(
+                b'4e48e2c9a3d2ca8a708cb0cc545700544efb5021', sha1)
+            self.assertEqual(
+                {(b'sha1:4e48e2c9a3d2ca8a708cb0cc545700544efb5021',)},
+                repo.chk_bytes.keys())
         # And after an unlock/lock pair
         with repo.lock_read():
             self.assertEqual(
@@ -76,46 +66,25 @@
         node_sha1 = osutils.sha_strings(node_lines)
         expected_set = {(b'sha1:' + leaf_sha1,), (b'sha1:' + node_sha1,)}
         repo = self.make_repository('.')
-        repo.lock_write()
-        try:
-            repo.start_write_group()
-            try:
+        with repo.lock_write():
+            with repository.WriteGroup(repo):
                 # Internal node pointing at a leaf.
-                repo.chk_bytes.add_lines(
-                    (None,), None, node_lines, random_id=True)
-            except:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
-            repo.start_write_group()
-            try:
+                repo.chk_bytes.add_lines((None,), None, node_lines, random_id=True)
+            with repository.WriteGroup(repo):
                 # Leaf in a separate pack.
-                repo.chk_bytes.add_lines(
-                    (None,), None, leaf_lines, random_id=True)
-            except:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
+                repo.chk_bytes.add_lines((None,), None, leaf_lines, random_id=True)
             repo.pack()
             self.assertEqual(expected_set, repo.chk_bytes.keys())
-        finally:
-            repo.unlock()
         # and reopening
         repo = repo.controldir.open_repository()
-        repo.lock_read()
-        try:
+        with repo.lock_read():
             self.assertEqual(expected_set, repo.chk_bytes.keys())
-        finally:
-            repo.unlock()
 
     def test_chk_bytes_are_fully_buffered(self):
         repo = self.make_repository('.')
         repo.lock_write()
         self.addCleanup(repo.unlock)
-        repo.start_write_group()
-        try:
+        with repository.WriteGroup(repo):
             sha1, len, _ = repo.chk_bytes.add_lines((None,),
                                                     None, [b"foo\n", b"bar\n"], random_id=True)
             self.assertEqual(b'4e48e2c9a3d2ca8a708cb0cc545700544efb5021',
@@ -123,11 +92,6 @@
             self.assertEqual(
                 {(b'sha1:4e48e2c9a3d2ca8a708cb0cc545700544efb5021',)},
                 repo.chk_bytes.keys())
-        except:
-            repo.abort_write_group()
-            raise
-        else:
-            repo.commit_write_group()
         # This may not always be correct if we change away from BTreeGraphIndex
         # in the future. But for now, lets check that chk_bytes are fully
         # buffered

=== modified file 'breezy/tests/per_repository_reference/test_add_inventory.py'
--- breezy/tests/per_repository_reference/test_add_inventory.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_repository_reference/test_add_inventory.py	2019-05-29 03:22:34 +0000
@@ -17,6 +17,7 @@
 """Tests for add_inventory on a repository with external references."""
 
 from breezy import errors
+from breezy.repository import WriteGroup
 from breezy.tests.per_repository_reference import (
     TestCaseWithExternalReferenceRepository,
     )
@@ -34,18 +35,8 @@
         self.addCleanup(tree.unlock)
         base = self.make_repository('base')
         repo = self.make_referring('referring', base)
-        repo.lock_write()
-        try:
-            repo.start_write_group()
-            try:
-                repo.add_inventory(revid, inv, [])
-            except:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
-        finally:
-            repo.unlock()
+        with repo.lock_write(), WriteGroup(repo):
+            repo.add_inventory(revid, inv, [])
         repo.lock_read()
         self.addCleanup(repo.unlock)
         inv2 = repo.get_inventory(revid)

=== modified file 'breezy/tests/per_repository_reference/test_add_revision.py'
--- breezy/tests/per_repository_reference/test_add_revision.py	2017-05-21 18:10:28 +0000
+++ breezy/tests/per_repository_reference/test_add_revision.py	2018-11-07 22:31:36 +0000
@@ -17,6 +17,7 @@
 """Tests for add_revision on a repository with external references."""
 
 from breezy import errors
+from breezy.repository import WriteGroup
 from breezy.tests.per_repository_reference import (
     TestCaseWithExternalReferenceRepository,
     )
@@ -35,20 +36,10 @@
         rev = tree.branch.repository.get_revision(revid)
         base = self.make_repository('base')
         repo = self.make_referring('referring', base)
-        repo.lock_write()
-        try:
-            repo.start_write_group()
-            try:
-                rev = tree.branch.repository.get_revision(revid)
-                repo.texts.add_lines((inv.root.file_id, revid), [], [])
-                repo.add_revision(revid, rev, inv=inv)
-            except:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
-        finally:
-            repo.unlock()
+        with repo.lock_write(), WriteGroup(repo):
+            rev = tree.branch.repository.get_revision(revid)
+            repo.texts.add_lines((inv.root.file_id, revid), [], [])
+            repo.add_revision(revid, rev, inv=inv)
         rev2 = repo.get_revision(revid)
         self.assertEqual(rev, rev2)
         self.assertRaises(errors.NoSuchRevision, base.get_revision, revid)

=== modified file 'breezy/tests/per_repository_reference/test_add_signature_text.py'
--- breezy/tests/per_repository_reference/test_add_signature_text.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_repository_reference/test_add_signature_text.py	2019-05-29 03:22:34 +0000
@@ -17,6 +17,7 @@
 """Tests for add_signature_text on a repository with external references."""
 
 from breezy import errors
+from breezy.repository import WriteGroup
 from breezy.tests.per_repository_reference import (
     TestCaseWithExternalReferenceRepository,
     )
@@ -34,20 +35,11 @@
         self.addCleanup(tree.unlock)
         base = self.make_repository('base')
         repo = self.make_referring('referring', base)
-        repo.lock_write()
-        try:
-            repo.start_write_group()
-            try:
-                rev = tree.branch.repository.get_revision(revid)
-                repo.texts.add_lines((inv.root.file_id, revid), [], [])
-                repo.add_revision(revid, rev, inv=inv)
-                repo.add_signature_text(revid, b"text")
-                repo.commit_write_group()
-            except:
-                repo.abort_write_group()
-                raise
-        finally:
-            repo.unlock()
+        with repo.lock_write(), WriteGroup(repo):
+            rev = tree.branch.repository.get_revision(revid)
+            repo.texts.add_lines((inv.root.file_id, revid), [], [])
+            repo.add_revision(revid, rev, inv=inv)
+            repo.add_signature_text(revid, b"text")
         repo.get_signature_text(revid)
         self.assertRaises(errors.NoSuchRevision, base.get_signature_text,
                           revid)

=== modified file 'breezy/tests/per_repository_vf/helpers.py'
--- breezy/tests/per_repository_vf/helpers.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_repository_vf/helpers.py	2019-05-29 03:44:42 +0000
@@ -20,6 +20,7 @@
     osutils,
     revision as _mod_revision,
     )
+from ...repository import WriteGroup
 from ...bzr import (
     inventory,
     )
@@ -50,9 +51,7 @@
                 "%s isn't a knit format" % self.repository_format)
 
         repo = self.make_repository('broken')
-        repo.lock_write()
-        repo.start_write_group()
-        try:
+        with repo.lock_write(), WriteGroup(repo):
             inv = inventory.Inventory(revision_id=b'revision-id')
             inv.root.revision = b'revision-id'
             inv_sha1 = repo.add_inventory(b'revision-id', inv, [])
@@ -66,16 +65,9 @@
             # Manually add the revision text using the RevisionStore API, with
             # bad parents.
             rev_text = repo._serializer.write_revision_to_string(revision)
-            repo.revisions.add_lines((revision.revision_id,),
-                                     [(b'incorrect-parent',)],
-                                     osutils.split_lines(rev_text))
-        except:
-            repo.abort_write_group()
-            repo.unlock()
-            raise
-        else:
-            repo.commit_write_group()
-            repo.unlock()
+            repo.revisions.add_lines(
+                (revision.revision_id,), [(b'incorrect-parent',)],
+                osutils.split_lines(rev_text))
 
         repo.lock_write()
         self.addCleanup(repo.unlock)

=== modified file 'breezy/tests/per_repository_vf/test_check_reconcile.py'
--- breezy/tests/per_repository_vf/test_check_reconcile.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_repository_vf/test_check_reconcile.py	2019-05-29 03:22:34 +0000
@@ -25,6 +25,7 @@
     Inventory,
     InventoryFile,
     )
+from breezy.repository import WriteGroup
 from breezy.revision import (
     NULL_REVISION,
     Revision,
@@ -793,15 +794,9 @@
     def make_populated_repository(self, factory):
         """Create a new repository populated by the given factory."""
         repo = self.make_repository('broken-repo')
-        with repo.lock_write():
-            repo.start_write_group()
-            try:
-                factory(repo)
-                repo.commit_write_group()
-                return repo
-            except:
-                repo.abort_write_group()
-                raise
+        with repo.lock_write(), WriteGroup(repo):
+            factory(repo)
+            return repo
 
     def add_revision(self, repo, revision_id, inv, parent_ids):
         """Add a revision with a given inventory and parents to a repository.

=== modified file 'breezy/tests/per_repository_vf/test_repository.py'
--- breezy/tests/per_repository_vf/test_repository.py	2019-01-01 21:08:01 +0000
+++ breezy/tests/per_repository_vf/test_repository.py	2019-05-29 03:22:34 +0000
@@ -327,19 +327,9 @@
         self.controldir = tree_a.branch.controldir
         # add a corrupt inventory 'orphan'
         # this may need some generalising for knits.
-        tree_a.lock_write()
-        try:
-            tree_a.branch.repository.start_write_group()
-            try:
-                inv_file = tree_a.branch.repository.inventories
-                inv_file.add_lines((b'orphan',), [], [])
-            except:
-                tree_a.branch.repository.commit_write_group()
-                raise
-            else:
-                tree_a.branch.repository.abort_write_group()
-        finally:
-            tree_a.unlock()
+        with tree_a.lock_write(), _mod_repository.WriteGroup(tree_a.branch.repository):
+            inv_file = tree_a.branch.repository.inventories
+            inv_file.add_lines((b'orphan',), [], [])
         # add a real revision 'rev1'
         tree_a.commit('rev1', rev_id=b'rev1', allow_pointless=True)
         # add a real revision 'rev2' based on rev1
@@ -385,18 +375,13 @@
 
     def test_reserved_id(self):
         repo = self.make_repository('repository')
-        repo.lock_write()
-        repo.start_write_group()
-        try:
+        with repo.lock_write(), _mod_repository.WriteGroup(repo):
             self.assertRaises(errors.ReservedId, repo.add_inventory,
                               b'reserved:', None, None)
             self.assertRaises(errors.ReservedId, repo.add_inventory_by_delta,
                               "foo", [], b'reserved:', None)
-            self.assertRaises(errors.ReservedId, repo.add_revision,
-                              b'reserved:', None)
-        finally:
-            repo.abort_write_group()
-            repo.unlock()
+            self.assertRaises(
+                errors.ReservedId, repo.add_revision, b'reserved:', None)
 
 
 class TestCaseWithCorruptRepository(TestCaseWithRepository):

=== modified file 'breezy/tests/test_bundle.py'
--- breezy/tests/test_bundle.py	2019-02-09 02:59:15 +0000
+++ breezy/tests/test_bundle.py	2019-05-29 03:28:14 +0000
@@ -17,10 +17,6 @@
 import bz2
 from io import BytesIO
 import os
-try:
-    import socketserver
-except ImportError:
-    import SocketServer as socketserver
 import sys
 
 from .. import (
@@ -36,10 +32,8 @@
     bzrdir,
     inventory,
     )
-from ..bundle import read_mergeable_from_url
 from ..bundle.apply_bundle import install_bundle, merge_bundle
 from ..bundle.bundle_data import BundleTree
-from ..directory_service import directories
 from ..bundle.serializer import write_bundle, read_bundle, v09, v4
 from ..bundle.serializer.v08 import BundleSerializerV08
 from ..bundle.serializer.v09 import BundleSerializerV09
@@ -48,8 +42,6 @@
 from . import (
     features,
     test_commit,
-    test_read_bundle,
-    test_server,
     )
 from ..transform import TreeTransform
 
@@ -1836,63 +1828,3 @@
         self.assertEqual((None, {b'foo': b'bar', b'storage_kind': b'header'},
                           'info', None, None), record)
         self.assertRaises(errors.BadBundle, next, record_iter)
-
-
-class TestReadMergeableFromUrl(tests.TestCaseWithTransport):
-
-    def test_read_mergeable_skips_local(self):
-        """A local bundle named like the URL should not be read.
-        """
-        out, wt = test_read_bundle.create_bundle_file(self)
-
-        class FooService(object):
-            """A directory service that always returns source"""
-
-            def look_up(self, name, url, purpose=None):
-                return 'source'
-        directories.register('foo:', FooService, 'Testing directory service')
-        self.addCleanup(directories.remove, 'foo:')
-        self.build_tree_contents([('./foo:bar', out.getvalue())])
-        self.assertRaises(errors.NotABundle, read_mergeable_from_url,
-                          'foo:bar')
-
-    def test_infinite_redirects_are_not_a_bundle(self):
-        """If a URL causes TooManyRedirections then NotABundle is raised.
-        """
-        from .blackbox.test_push import RedirectingMemoryServer
-        server = RedirectingMemoryServer()
-        self.start_server(server)
-        url = server.get_url() + 'infinite-loop'
-        self.assertRaises(errors.NotABundle, read_mergeable_from_url, url)
-
-    def test_smart_server_connection_reset(self):
-        """If a smart server connection fails during the attempt to read a
-        bundle, then the ConnectionReset error should be propagated.
-        """
-        # Instantiate a server that will provoke a ConnectionReset
-        sock_server = DisconnectingServer()
-        self.start_server(sock_server)
-        # We don't really care what the url is since the server will close the
-        # connection without interpreting it
-        url = sock_server.get_url()
-        self.assertRaises(errors.ConnectionReset, read_mergeable_from_url, url)
-
-
-class DisconnectingHandler(socketserver.BaseRequestHandler):
-    """A request handler that immediately closes any connection made to it."""
-
-    def handle(self):
-        self.request.close()
-
-
-class DisconnectingServer(test_server.TestingTCPServerInAThread):
-
-    def __init__(self):
-        super(DisconnectingServer, self).__init__(
-            ('127.0.0.1', 0),
-            test_server.TestingTCPServer,
-            DisconnectingHandler)
-
-    def get_url(self):
-        """Return the url of the server"""
-        return "bzr://%s:%d/" % self.server.server_address

=== modified file 'breezy/tests/test_controldir.py'
--- breezy/tests/test_controldir.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_controldir.py	2019-06-03 21:45:21 +0000
@@ -241,7 +241,7 @@
 
     def test_is_bzrdir(self):
         self.assertTrue(controldir.is_control_filename('.bzr'))
+        self.assertTrue(controldir.is_control_filename('.git'))
 
     def test_is_not_bzrdir(self):
-        self.assertFalse(controldir.is_control_filename('.git'))
         self.assertFalse(controldir.is_control_filename('bla'))

=== modified file 'breezy/tests/test_diff.py'
--- breezy/tests/test_diff.py	2018-11-25 21:48:55 +0000
+++ breezy/tests/test_diff.py	2019-03-02 21:46:18 +0000
@@ -24,8 +24,6 @@
     diff,
     errors,
     osutils,
-    patiencediff,
-    _patiencediff_py,
     revision as _mod_revision,
     revisionspec,
     revisiontree,
@@ -867,531 +865,6 @@
                               b'.*a-file(.|\n)*b-file')
 
 
-class TestPatienceDiffLib(tests.TestCase):
-
-    def setUp(self):
-        super(TestPatienceDiffLib, self).setUp()
-        self._unique_lcs = _patiencediff_py.unique_lcs_py
-        self._recurse_matches = _patiencediff_py.recurse_matches_py
-        self._PatienceSequenceMatcher = \
-            _patiencediff_py.PatienceSequenceMatcher_py
-
-    def test_diff_unicode_string(self):
-        a = ''.join([unichr(i) for i in range(4000, 4500, 3)])
-        b = ''.join([unichr(i) for i in range(4300, 4800, 2)])
-        sm = self._PatienceSequenceMatcher(None, a, b)
-        mb = sm.get_matching_blocks()
-        self.assertEqual(35, len(mb))
-
-    def test_unique_lcs(self):
-        unique_lcs = self._unique_lcs
-        self.assertEqual(unique_lcs('', ''), [])
-        self.assertEqual(unique_lcs('', 'a'), [])
-        self.assertEqual(unique_lcs('a', ''), [])
-        self.assertEqual(unique_lcs('a', 'a'), [(0, 0)])
-        self.assertEqual(unique_lcs('a', 'b'), [])
-        self.assertEqual(unique_lcs('ab', 'ab'), [(0, 0), (1, 1)])
-        self.assertEqual(unique_lcs('abcde', 'cdeab'),
-                         [(2, 0), (3, 1), (4, 2)])
-        self.assertEqual(unique_lcs('cdeab', 'abcde'),
-                         [(0, 2), (1, 3), (2, 4)])
-        self.assertEqual(unique_lcs('abXde', 'abYde'), [(0, 0), (1, 1),
-                                                        (3, 3), (4, 4)])
-        self.assertEqual(unique_lcs('acbac', 'abc'), [(2, 1)])
-
-    def test_recurse_matches(self):
-        def test_one(a, b, matches):
-            test_matches = []
-            self._recurse_matches(
-                a, b, 0, 0, len(a), len(b), test_matches, 10)
-            self.assertEqual(test_matches, matches)
-
-        test_one(['a', '', 'b', '', 'c'], ['a', 'a', 'b', 'c', 'c'],
-                 [(0, 0), (2, 2), (4, 4)])
-        test_one(['a', 'c', 'b', 'a', 'c'], ['a', 'b', 'c'],
-                 [(0, 0), (2, 1), (4, 2)])
-        # Even though 'bc' is not unique globally, and is surrounded by
-        # non-matching lines, we should still match, because they are locally
-        # unique
-        test_one('abcdbce', 'afbcgdbce', [(0, 0), (1, 2), (2, 3), (3, 5),
-                                          (4, 6), (5, 7), (6, 8)])
-
-        # recurse_matches doesn't match non-unique
-        # lines surrounded by bogus text.
-        # The update has been done in patiencediff.SequenceMatcher instead
-
-        # This is what it could be
-        #test_one('aBccDe', 'abccde', [(0,0), (2,2), (3,3), (5,5)])
-
-        # This is what it currently gives:
-        test_one('aBccDe', 'abccde', [(0, 0), (5, 5)])
-
-    def assertDiffBlocks(self, a, b, expected_blocks):
-        """Check that the sequence matcher returns the correct blocks.
-
-        :param a: A sequence to match
-        :param b: Another sequence to match
-        :param expected_blocks: The expected output, not including the final
-            matching block (len(a), len(b), 0)
-        """
-        matcher = self._PatienceSequenceMatcher(None, a, b)
-        blocks = matcher.get_matching_blocks()
-        last = blocks.pop()
-        self.assertEqual((len(a), len(b), 0), last)
-        self.assertEqual(expected_blocks, blocks)
-
-    def test_matching_blocks(self):
-        # Some basic matching tests
-        self.assertDiffBlocks('', '', [])
-        self.assertDiffBlocks([], [], [])
-        self.assertDiffBlocks('abc', '', [])
-        self.assertDiffBlocks('', 'abc', [])
-        self.assertDiffBlocks('abcd', 'abcd', [(0, 0, 4)])
-        self.assertDiffBlocks('abcd', 'abce', [(0, 0, 3)])
-        self.assertDiffBlocks('eabc', 'abce', [(1, 0, 3)])
-        self.assertDiffBlocks('eabce', 'abce', [(1, 0, 4)])
-        self.assertDiffBlocks('abcde', 'abXde', [(0, 0, 2), (3, 3, 2)])
-        self.assertDiffBlocks('abcde', 'abXYZde', [(0, 0, 2), (3, 5, 2)])
-        self.assertDiffBlocks('abde', 'abXYZde', [(0, 0, 2), (2, 5, 2)])
-        # This may check too much, but it checks to see that
-        # a copied block stays attached to the previous section,
-        # not the later one.
-        # difflib would tend to grab the trailing longest match
-        # which would make the diff not look right
-        self.assertDiffBlocks('abcdefghijklmnop', 'abcdefxydefghijklmnop',
-                              [(0, 0, 6), (6, 11, 10)])
-
-        # make sure it supports passing in lists
-        self.assertDiffBlocks(
-            ['hello there\n',
-             'world\n',
-             'how are you today?\n'],
-            ['hello there\n',
-             'how are you today?\n'],
-            [(0, 0, 1), (2, 1, 1)])
-
-        # non unique lines surrounded by non-matching lines
-        # won't be found
-        self.assertDiffBlocks('aBccDe', 'abccde', [(0, 0, 1), (5, 5, 1)])
-
-        # But they only need to be locally unique
-        self.assertDiffBlocks('aBcDec', 'abcdec', [
-                              (0, 0, 1), (2, 2, 1), (4, 4, 2)])
-
-        # non unique blocks won't be matched
-        self.assertDiffBlocks('aBcdEcdFg', 'abcdecdfg', [(0, 0, 1), (8, 8, 1)])
-
-        # but locally unique ones will
-        self.assertDiffBlocks('aBcdEeXcdFg', 'abcdecdfg', [(0, 0, 1), (2, 2, 2),
-                                                           (5, 4, 1), (7, 5, 2), (10, 8, 1)])
-
-        self.assertDiffBlocks('abbabbXd', 'cabbabxd', [(7, 7, 1)])
-        self.assertDiffBlocks('abbabbbb', 'cabbabbc', [])
-        self.assertDiffBlocks('bbbbbbbb', 'cbbbbbbc', [])
-
-    def test_matching_blocks_tuples(self):
-        # Some basic matching tests
-        self.assertDiffBlocks([], [], [])
-        self.assertDiffBlocks([('a',), ('b',), ('c,')], [], [])
-        self.assertDiffBlocks([], [('a',), ('b',), ('c,')], [])
-        self.assertDiffBlocks([('a',), ('b',), ('c,')],
-                              [('a',), ('b',), ('c,')],
-                              [(0, 0, 3)])
-        self.assertDiffBlocks([('a',), ('b',), ('c,')],
-                              [('a',), ('b',), ('d,')],
-                              [(0, 0, 2)])
-        self.assertDiffBlocks([('d',), ('b',), ('c,')],
-                              [('a',), ('b',), ('c,')],
-                              [(1, 1, 2)])
-        self.assertDiffBlocks([('d',), ('a',), ('b',), ('c,')],
-                              [('a',), ('b',), ('c,')],
-                              [(1, 0, 3)])
-        self.assertDiffBlocks([('a', 'b'), ('c', 'd'), ('e', 'f')],
-                              [('a', 'b'), ('c', 'X'), ('e', 'f')],
-                              [(0, 0, 1), (2, 2, 1)])
-        self.assertDiffBlocks([('a', 'b'), ('c', 'd'), ('e', 'f')],
-                              [('a', 'b'), ('c', 'dX'), ('e', 'f')],
-                              [(0, 0, 1), (2, 2, 1)])
-
-    def test_opcodes(self):
-        def chk_ops(a, b, expected_codes):
-            s = self._PatienceSequenceMatcher(None, a, b)
-            self.assertEqual(expected_codes, s.get_opcodes())
-
-        chk_ops('', '', [])
-        chk_ops([], [], [])
-        chk_ops('abc', '', [('delete', 0, 3, 0, 0)])
-        chk_ops('', 'abc', [('insert', 0, 0, 0, 3)])
-        chk_ops('abcd', 'abcd', [('equal', 0, 4, 0, 4)])
-        chk_ops('abcd', 'abce', [('equal', 0, 3, 0, 3),
-                                 ('replace', 3, 4, 3, 4)
-                                 ])
-        chk_ops('eabc', 'abce', [('delete', 0, 1, 0, 0),
-                                 ('equal', 1, 4, 0, 3),
-                                 ('insert', 4, 4, 3, 4)
-                                 ])
-        chk_ops('eabce', 'abce', [('delete', 0, 1, 0, 0),
-                                  ('equal', 1, 5, 0, 4)
-                                  ])
-        chk_ops('abcde', 'abXde', [('equal', 0, 2, 0, 2),
-                                   ('replace', 2, 3, 2, 3),
-                                   ('equal', 3, 5, 3, 5)
-                                   ])
-        chk_ops('abcde', 'abXYZde', [('equal', 0, 2, 0, 2),
-                                     ('replace', 2, 3, 2, 5),
-                                     ('equal', 3, 5, 5, 7)
-                                     ])
-        chk_ops('abde', 'abXYZde', [('equal', 0, 2, 0, 2),
-                                    ('insert', 2, 2, 2, 5),
-                                    ('equal', 2, 4, 5, 7)
-                                    ])
-        chk_ops('abcdefghijklmnop', 'abcdefxydefghijklmnop',
-                [('equal', 0, 6, 0, 6),
-                 ('insert', 6, 6, 6, 11),
-                 ('equal', 6, 16, 11, 21)
-                 ])
-        chk_ops(
-            ['hello there\n', 'world\n', 'how are you today?\n'],
-            ['hello there\n', 'how are you today?\n'],
-            [('equal', 0, 1, 0, 1),
-             ('delete', 1, 2, 1, 1),
-             ('equal', 2, 3, 1, 2),
-             ])
-        chk_ops('aBccDe', 'abccde',
-                [('equal', 0, 1, 0, 1),
-                 ('replace', 1, 5, 1, 5),
-                 ('equal', 5, 6, 5, 6),
-                 ])
-        chk_ops('aBcDec', 'abcdec',
-                [('equal', 0, 1, 0, 1),
-                 ('replace', 1, 2, 1, 2),
-                 ('equal', 2, 3, 2, 3),
-                 ('replace', 3, 4, 3, 4),
-                 ('equal', 4, 6, 4, 6),
-                 ])
-        chk_ops('aBcdEcdFg', 'abcdecdfg',
-                [('equal', 0, 1, 0, 1),
-                 ('replace', 1, 8, 1, 8),
-                 ('equal', 8, 9, 8, 9)
-                 ])
-        chk_ops('aBcdEeXcdFg', 'abcdecdfg',
-                [('equal', 0, 1, 0, 1),
-                 ('replace', 1, 2, 1, 2),
-                 ('equal', 2, 4, 2, 4),
-                 ('delete', 4, 5, 4, 4),
-                 ('equal', 5, 6, 4, 5),
-                 ('delete', 6, 7, 5, 5),
-                 ('equal', 7, 9, 5, 7),
-                 ('replace', 9, 10, 7, 8),
-                 ('equal', 10, 11, 8, 9)
-                 ])
-
-    def test_grouped_opcodes(self):
-        def chk_ops(a, b, expected_codes, n=3):
-            s = self._PatienceSequenceMatcher(None, a, b)
-            self.assertEqual(expected_codes, list(s.get_grouped_opcodes(n)))
-
-        chk_ops('', '', [])
-        chk_ops([], [], [])
-        chk_ops('abc', '', [[('delete', 0, 3, 0, 0)]])
-        chk_ops('', 'abc', [[('insert', 0, 0, 0, 3)]])
-        chk_ops('abcd', 'abcd', [])
-        chk_ops('abcd', 'abce', [[('equal', 0, 3, 0, 3),
-                                  ('replace', 3, 4, 3, 4)
-                                  ]])
-        chk_ops('eabc', 'abce', [[('delete', 0, 1, 0, 0),
-                                  ('equal', 1, 4, 0, 3),
-                                  ('insert', 4, 4, 3, 4)
-                                  ]])
-        chk_ops('abcdefghijklmnop', 'abcdefxydefghijklmnop',
-                [[('equal', 3, 6, 3, 6),
-                  ('insert', 6, 6, 6, 11),
-                  ('equal', 6, 9, 11, 14)
-                  ]])
-        chk_ops('abcdefghijklmnop', 'abcdefxydefghijklmnop',
-                [[('equal', 2, 6, 2, 6),
-                  ('insert', 6, 6, 6, 11),
-                  ('equal', 6, 10, 11, 15)
-                  ]], 4)
-        chk_ops('Xabcdef', 'abcdef',
-                [[('delete', 0, 1, 0, 0),
-                  ('equal', 1, 4, 0, 3)
-                  ]])
-        chk_ops('abcdef', 'abcdefX',
-                [[('equal', 3, 6, 3, 6),
-                  ('insert', 6, 6, 6, 7)
-                  ]])
-
-    def test_multiple_ranges(self):
-        # There was an earlier bug where we used a bad set of ranges,
-        # this triggers that specific bug, to make sure it doesn't regress
-        self.assertDiffBlocks('abcdefghijklmnop',
-                              'abcXghiYZQRSTUVWXYZijklmnop',
-                              [(0, 0, 3), (6, 4, 3), (9, 20, 7)])
-
-        self.assertDiffBlocks('ABCd efghIjk  L',
-                              'AxyzBCn mo pqrstuvwI1 2  L',
-                              [(0, 0, 1), (1, 4, 2), (9, 19, 1), (12, 23, 3)])
-
-        # These are rot13 code snippets.
-        self.assertDiffBlocks('''\
-    trg nqqrq jura lbh nqq n svyr va gur qverpgbel.
-    """
-    gnxrf_netf = ['svyr*']
-    gnxrf_bcgvbaf = ['ab-erphefr']
-
-    qrs eha(frys, svyr_yvfg, ab_erphefr=Snyfr):
-        sebz omeyvo.nqq vzcbeg fzneg_nqq, nqq_ercbegre_cevag, nqq_ercbegre_ahyy
-        vs vf_dhvrg():
-            ercbegre = nqq_ercbegre_ahyy
-        ryfr:
-            ercbegre = nqq_ercbegre_cevag
-        fzneg_nqq(svyr_yvfg, abg ab_erphefr, ercbegre)
-
-
-pynff pzq_zxqve(Pbzznaq):
-'''.splitlines(True), '''\
-    trg nqqrq jura lbh nqq n svyr va gur qverpgbel.
-
-    --qel-eha jvyy fubj juvpu svyrf jbhyq or nqqrq, ohg abg npghnyyl
-    nqq gurz.
-    """
-    gnxrf_netf = ['svyr*']
-    gnxrf_bcgvbaf = ['ab-erphefr', 'qel-eha']
-
-    qrs eha(frys, svyr_yvfg, ab_erphefr=Snyfr, qel_eha=Snyfr):
-        vzcbeg omeyvo.nqq
-
-        vs qel_eha:
-            vs vf_dhvrg():
-                # Guvf vf cbvagyrff, ohg V'q engure abg envfr na reebe
-                npgvba = omeyvo.nqq.nqq_npgvba_ahyy
-            ryfr:
-  npgvba = omeyvo.nqq.nqq_npgvba_cevag
-        ryvs vf_dhvrg():
-            npgvba = omeyvo.nqq.nqq_npgvba_nqq
-        ryfr:
-       npgvba = omeyvo.nqq.nqq_npgvba_nqq_naq_cevag
-
-        omeyvo.nqq.fzneg_nqq(svyr_yvfg, abg ab_erphefr, npgvba)
-
-
-pynff pzq_zxqve(Pbzznaq):
-'''.splitlines(True), [(0, 0, 1), (1, 4, 2), (9, 19, 1), (12, 23, 3)])
-
-    def test_patience_unified_diff(self):
-        txt_a = ['hello there\n',
-                 'world\n',
-                 'how are you today?\n']
-        txt_b = ['hello there\n',
-                 'how are you today?\n']
-        unified_diff = patiencediff.unified_diff
-        psm = self._PatienceSequenceMatcher
-        self.assertEqual(['--- \n',
-                          '+++ \n',
-                          '@@ -1,3 +1,2 @@\n',
-                          ' hello there\n',
-                          '-world\n',
-                          ' how are you today?\n'
-                          ], list(unified_diff(txt_a, txt_b,
-                                               sequencematcher=psm)))
-        txt_a = [x + '\n' for x in 'abcdefghijklmnop']
-        txt_b = [x + '\n' for x in 'abcdefxydefghijklmnop']
-        # This is the result with LongestCommonSubstring matching
-        self.assertEqual(['--- \n',
-                          '+++ \n',
-                          '@@ -1,6 +1,11 @@\n',
-                          ' a\n',
-                          ' b\n',
-                          ' c\n',
-                          '+d\n',
-                          '+e\n',
-                          '+f\n',
-                          '+x\n',
-                          '+y\n',
-                          ' d\n',
-                          ' e\n',
-                          ' f\n'], list(unified_diff(txt_a, txt_b)))
-        # And the patience diff
-        self.assertEqual(['--- \n',
-                          '+++ \n',
-                          '@@ -4,6 +4,11 @@\n',
-                          ' d\n',
-                          ' e\n',
-                          ' f\n',
-                          '+x\n',
-                          '+y\n',
-                          '+d\n',
-                          '+e\n',
-                          '+f\n',
-                          ' g\n',
-                          ' h\n',
-                          ' i\n',
-                          ], list(unified_diff(txt_a, txt_b,
-                                               sequencematcher=psm)))
-
-    def test_patience_unified_diff_with_dates(self):
-        txt_a = ['hello there\n',
-                 'world\n',
-                 'how are you today?\n']
-        txt_b = ['hello there\n',
-                 'how are you today?\n']
-        unified_diff = patiencediff.unified_diff
-        psm = self._PatienceSequenceMatcher
-        self.assertEqual(['--- a\t2008-08-08\n',
-                          '+++ b\t2008-09-09\n',
-                          '@@ -1,3 +1,2 @@\n',
-                          ' hello there\n',
-                          '-world\n',
-                          ' how are you today?\n'
-                          ], list(unified_diff(txt_a, txt_b,
-                                               fromfile='a', tofile='b',
-                                               fromfiledate='2008-08-08',
-                                               tofiledate='2008-09-09',
-                                               sequencematcher=psm)))
-
-
-class TestPatienceDiffLib_c(TestPatienceDiffLib):
-
-    _test_needs_features = [features.compiled_patiencediff_feature]
-
-    def setUp(self):
-        super(TestPatienceDiffLib_c, self).setUp()
-        from breezy import _patiencediff_c
-        self._unique_lcs = _patiencediff_c.unique_lcs_c
-        self._recurse_matches = _patiencediff_c.recurse_matches_c
-        self._PatienceSequenceMatcher = \
-            _patiencediff_c.PatienceSequenceMatcher_c
-
-    def test_unhashable(self):
-        """We should get a proper exception here."""
-        # We need to be able to hash items in the sequence, lists are
-        # unhashable, and thus cannot be diffed
-        e = self.assertRaises(TypeError, self._PatienceSequenceMatcher,
-                              None, [[]], [])
-        e = self.assertRaises(TypeError, self._PatienceSequenceMatcher,
-                              None, ['valid', []], [])
-        e = self.assertRaises(TypeError, self._PatienceSequenceMatcher,
-                              None, ['valid'], [[]])
-        e = self.assertRaises(TypeError, self._PatienceSequenceMatcher,
-                              None, ['valid'], ['valid', []])
-
-
-class TestPatienceDiffLibFiles(tests.TestCaseInTempDir):
-
-    def setUp(self):
-        super(TestPatienceDiffLibFiles, self).setUp()
-        self._PatienceSequenceMatcher = \
-            _patiencediff_py.PatienceSequenceMatcher_py
-
-    def test_patience_unified_diff_files(self):
-        txt_a = [b'hello there\n',
-                 b'world\n',
-                 b'how are you today?\n']
-        txt_b = [b'hello there\n',
-                 b'how are you today?\n']
-        with open('a1', 'wb') as f:
-            f.writelines(txt_a)
-        with open('b1', 'wb') as f:
-            f.writelines(txt_b)
-
-        unified_diff_files = patiencediff.unified_diff_files
-        psm = self._PatienceSequenceMatcher
-        self.assertEqual([b'--- a1\n',
-                          b'+++ b1\n',
-                          b'@@ -1,3 +1,2 @@\n',
-                          b' hello there\n',
-                          b'-world\n',
-                          b' how are you today?\n',
-                          ], list(unified_diff_files(b'a1', b'b1',
-                                                     sequencematcher=psm)))
-
-        txt_a = [x + '\n' for x in 'abcdefghijklmnop']
-        txt_b = [x + '\n' for x in 'abcdefxydefghijklmnop']
-        with open('a2', 'wt') as f:
-            f.writelines(txt_a)
-        with open('b2', 'wt') as f:
-            f.writelines(txt_b)
-
-        # This is the result with LongestCommonSubstring matching
-        self.assertEqual([b'--- a2\n',
-                          b'+++ b2\n',
-                          b'@@ -1,6 +1,11 @@\n',
-                          b' a\n',
-                          b' b\n',
-                          b' c\n',
-                          b'+d\n',
-                          b'+e\n',
-                          b'+f\n',
-                          b'+x\n',
-                          b'+y\n',
-                          b' d\n',
-                          b' e\n',
-                          b' f\n'], list(unified_diff_files(b'a2', b'b2')))
-
-        # And the patience diff
-        self.assertEqual([b'--- a2\n',
-                          b'+++ b2\n',
-                          b'@@ -4,6 +4,11 @@\n',
-                          b' d\n',
-                          b' e\n',
-                          b' f\n',
-                          b'+x\n',
-                          b'+y\n',
-                          b'+d\n',
-                          b'+e\n',
-                          b'+f\n',
-                          b' g\n',
-                          b' h\n',
-                          b' i\n'],
-                         list(unified_diff_files(b'a2', b'b2',
-                                                 sequencematcher=psm)))
-
-
-class TestPatienceDiffLibFiles_c(TestPatienceDiffLibFiles):
-
-    _test_needs_features = [features.compiled_patiencediff_feature]
-
-    def setUp(self):
-        super(TestPatienceDiffLibFiles_c, self).setUp()
-        from breezy import _patiencediff_c
-        self._PatienceSequenceMatcher = \
-            _patiencediff_c.PatienceSequenceMatcher_c
-
-
-class TestUsingCompiledIfAvailable(tests.TestCase):
-
-    def test_PatienceSequenceMatcher(self):
-        if features.compiled_patiencediff_feature.available():
-            from breezy._patiencediff_c import PatienceSequenceMatcher_c
-            self.assertIs(PatienceSequenceMatcher_c,
-                          patiencediff.PatienceSequenceMatcher)
-        else:
-            from breezy._patiencediff_py import PatienceSequenceMatcher_py
-            self.assertIs(PatienceSequenceMatcher_py,
-                          patiencediff.PatienceSequenceMatcher)
-
-    def test_unique_lcs(self):
-        if features.compiled_patiencediff_feature.available():
-            from breezy._patiencediff_c import unique_lcs_c
-            self.assertIs(unique_lcs_c,
-                          patiencediff.unique_lcs)
-        else:
-            from breezy._patiencediff_py import unique_lcs_py
-            self.assertIs(unique_lcs_py,
-                          patiencediff.unique_lcs)
-
-    def test_recurse_matches(self):
-        if features.compiled_patiencediff_feature.available():
-            from breezy._patiencediff_c import recurse_matches_c
-            self.assertIs(recurse_matches_c,
-                          patiencediff.recurse_matches)
-        else:
-            from breezy._patiencediff_py import recurse_matches_py
-            self.assertIs(recurse_matches_py,
-                          patiencediff.recurse_matches)
-
-
 class TestDiffFromTool(tests.TestCaseWithTransport):
 
     def test_from_string(self):

=== modified file 'breezy/tests/test_http_response.py'
--- breezy/tests/test_http_response.py	2019-05-19 23:13:46 +0000
+++ breezy/tests/test_http_response.py	2019-05-28 23:08:46 +0000
@@ -53,6 +53,7 @@
     )
 from ..sixish import (
     BytesIO,
+    PY3,
     )
 from ..transport.http import (
     response,
@@ -725,7 +726,10 @@
         # Get rid of the status line
         status_and_headers.readline()
         msg = parse_headers(status_and_headers)
-        return msg.getheader
+        if PY3:
+            return msg.get
+        else:
+            return msg.getheader
 
     def get_response(self, a_response):
         """Process a supplied response, and return the result."""

=== modified file 'breezy/tests/test_import_tariff.py'
--- breezy/tests/test_import_tariff.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_import_tariff.py	2019-03-02 21:46:18 +0000
@@ -176,7 +176,6 @@
             'breezy.merge3',
             'breezy.merge_directive',
             'breezy.msgeditor',
-            'breezy.patiencediff',
             'breezy.bzr.remote',
             'breezy.rules',
             'breezy.sign_my_commits',
@@ -252,7 +251,6 @@
                                       'breezy.merge3',
                                       'breezy.merge_directive',
                                       'breezy.msgeditor',
-                                      'breezy.patiencediff',
                                       'breezy.bzr.remote',
                                       'breezy.rules',
                                       'breezy.sign_my_commits',

=== modified file 'breezy/tests/test_inv.py'
--- breezy/tests/test_inv.py	2018-11-16 11:37:47 +0000
+++ breezy/tests/test_inv.py	2019-05-29 03:22:34 +0000
@@ -141,8 +141,7 @@
 
 
 def _create_repo_revisions(repo, basis, delta, invalid_delta):
-    repo.start_write_group()
-    try:
+    with repository.WriteGroup(repo):
         rev = revision.Revision(b'basis', timestamp=0, timezone=None,
                                 message="", committer="foo@example.com")
         basis.revision_id = b'basis'
@@ -161,19 +160,13 @@
         rev = revision.Revision(b'result', timestamp=0, timezone=None,
                                 message="", committer="foo@example.com")
         repo.add_revision(b'result', rev, result_inv)
-        repo.commit_write_group()
-    except:
-        repo.abort_write_group()
-        raise
     return target_entries
 
 
 def _get_basis_entries(tree):
     basis_tree = tree.basis_tree()
-    basis_tree.lock_read()
-    basis_tree_entries = list(basis_tree.inventory.iter_entries_by_dir())
-    basis_tree.unlock()
-    return basis_tree_entries
+    with basis_tree.lock_read():
+        return list(basis_tree.inventory.iter_entries_by_dir())
 
 
 def _populate_different_tree(tree, basis, delta):
@@ -253,28 +246,16 @@
     format = self.format()
     control = self.make_controldir('tree', format=format._matchingcontroldir)
     repo = format.initialize(control)
-    with repo.lock_write():
-        repo.start_write_group()
-        try:
-            rev = revision.Revision(b'basis', timestamp=0, timezone=None,
-                                    message="", committer="foo@example.com")
-            basis.revision_id = b'basis'
-            create_texts_for_inv(repo, basis)
-            repo.add_revision(b'basis', rev, basis)
-            repo.commit_write_group()
-        except:
-            repo.abort_write_group()
-            raise
-    with repo.lock_write():
-        repo.start_write_group()
-        try:
-            inv_sha1 = repo.add_inventory_by_delta(b'basis', delta,
-                                                   b'result', [b'basis'])
-        except:
-            repo.abort_write_group()
-            raise
-        else:
-            repo.commit_write_group()
+    with repo.lock_write(), repository.WriteGroup(repo):
+        rev = revision.Revision(
+            b'basis', timestamp=0, timezone=None, message="",
+            committer="foo@example.com")
+        basis.revision_id = b'basis'
+        create_texts_for_inv(repo, basis)
+        repo.add_revision(b'basis', rev, basis)
+    with repo.lock_write(), repository.WriteGroup(repo):
+        inv_sha1 = repo.add_inventory_by_delta(
+            b'basis', delta, b'result', [b'basis'])
     # Fresh lock, reads disk again.
     repo = repo.controldir.open_repository()
     repo.lock_read()

=== modified file 'breezy/tests/test_knit.py'
--- breezy/tests/test_knit.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_knit.py	2019-03-02 21:46:18 +0000
@@ -18,6 +18,7 @@
 
 import gzip
 from io import BytesIO
+from patiencediff import PatienceSequenceMatcher
 import sys
 
 from .. import (
@@ -48,7 +49,6 @@
     _KnitKeyAccess,
     make_file_factory,
     )
-from ..patiencediff import PatienceSequenceMatcher
 from ..bzr import (
     knitpack_repo,
     pack_repo,

=== added file 'breezy/tests/test_mergeable.py'
--- breezy/tests/test_mergeable.py	1970-01-01 00:00:00 +0000
+++ breezy/tests/test_mergeable.py	2018-11-13 01:08:02 +0000
@@ -0,0 +1,91 @@
+# Copyright (C) 2005-2013, 2016 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+try:
+    import socketserver
+except ImportError:
+    import SocketServer as socketserver
+
+from ..mergeable import read_mergeable_from_url
+from ..directory_service import directories
+from .. import (
+    errors,
+    tests,
+    )
+from . import (
+    test_read_bundle,
+    test_server,
+    )
+
+
+class TestReadMergeableFromUrl(tests.TestCaseWithTransport):
+
+    def test_read_mergeable_skips_local(self):
+        """A local bundle named like the URL should not be read.
+        """
+        out, wt = test_read_bundle.create_bundle_file(self)
+
+        class FooService(object):
+            """A directory service that always returns source"""
+
+            def look_up(self, name, url):
+                return 'source'
+        directories.register('foo:', FooService, 'Testing directory service')
+        self.addCleanup(directories.remove, 'foo:')
+        self.build_tree_contents([('./foo:bar', out.getvalue())])
+        self.assertRaises(errors.NotABundle, read_mergeable_from_url,
+                          'foo:bar')
+
+    def test_infinite_redirects_are_not_a_bundle(self):
+        """If a URL causes TooManyRedirections then NotABundle is raised.
+        """
+        from .blackbox.test_push import RedirectingMemoryServer
+        server = RedirectingMemoryServer()
+        self.start_server(server)
+        url = server.get_url() + 'infinite-loop'
+        self.assertRaises(errors.NotABundle, read_mergeable_from_url, url)
+
+    def test_smart_server_connection_reset(self):
+        """If a smart server connection fails during the attempt to read a
+        bundle, then the ConnectionReset error should be propagated.
+        """
+        # Instantiate a server that will provoke a ConnectionReset
+        sock_server = DisconnectingServer()
+        self.start_server(sock_server)
+        # We don't really care what the url is since the server will close the
+        # connection without interpreting it
+        url = sock_server.get_url()
+        self.assertRaises(errors.ConnectionReset, read_mergeable_from_url, url)
+
+
+class DisconnectingHandler(socketserver.BaseRequestHandler):
+    """A request handler that immediately closes any connection made to it."""
+
+    def handle(self):
+        self.request.close()
+
+
+class DisconnectingServer(test_server.TestingTCPServerInAThread):
+
+    def __init__(self):
+        super(DisconnectingServer, self).__init__(
+            ('127.0.0.1', 0),
+            test_server.TestingTCPServer,
+            DisconnectingHandler)
+
+    def get_url(self):
+        """Return the url of the server"""
+        return "bzr://%s:%d/" % self.server.server_address

=== modified file 'breezy/tests/test_multiparent.py'
--- breezy/tests/test_multiparent.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_multiparent.py	2019-03-02 21:46:18 +0000
@@ -14,11 +14,11 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+import patiencediff
 from unittest import TestCase
 
 from .. import (
     multiparent,
-    patiencediff,
     tests,
     )
 from ..sixish import int2byte

=== added file 'breezy/tests/test_multiwalker.py'
--- breezy/tests/test_multiwalker.py	1970-01-01 00:00:00 +0000
+++ breezy/tests/test_multiwalker.py	2019-06-02 18:43:25 +0000
@@ -0,0 +1,305 @@
+# Copyright (C) 2006-2009, 2011 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tests for MultiWalker."""
+
+from breezy import (
+    revision,
+    multiwalker,
+    tree as _mod_tree,
+    )
+from breezy.tests import (
+    TestCaseWithTransport,
+    )
+
+
+class TestMultiWalker(TestCaseWithTransport):
+
+    def assertStepOne(self, has_more, path, file_id, iterator):
+        retval = multiwalker.MultiWalker._step_one(iterator)
+        if not has_more:
+            self.assertIs(None, path)
+            self.assertIs(None, file_id)
+            self.assertEqual((False, None, None), retval)
+        else:
+            self.assertEqual((has_more, path, file_id),
+                             (retval[0], retval[1], retval[2].file_id))
+
+    def test__step_one_empty(self):
+        tree = self.make_branch_and_tree('empty')
+        repo = tree.branch.repository
+        empty_tree = repo.revision_tree(revision.NULL_REVISION)
+
+        iterator = empty_tree.iter_entries_by_dir()
+        self.assertStepOne(False, None, None, iterator)
+        self.assertStepOne(False, None, None, iterator)
+
+    def test__step_one(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])
+        tree.add(['a', 'b', 'b/c'], [b'a-id', b'b-id', b'c-id'])
+
+        iterator = tree.iter_entries_by_dir()
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+
+        root_id = tree.path2id('')
+        self.assertStepOne(True, '', root_id, iterator)
+        self.assertStepOne(True, 'a', b'a-id', iterator)
+        self.assertStepOne(True, 'b', b'b-id', iterator)
+        self.assertStepOne(True, 'b/c', b'c-id', iterator)
+        self.assertStepOne(False, None, None, iterator)
+        self.assertStepOne(False, None, None, iterator)
+
+    def assertWalkerNext(self, exp_path, exp_file_id, master_has_node,
+                         exp_other_paths, iterator):
+        """Check what happens when we step the iterator.
+
+        :param path: The path for this entry
+        :param file_id: The file_id for this entry
+        :param master_has_node: Does the master tree have this entry?
+        :param exp_other_paths: A list of other_path values.
+        :param iterator: The iterator to step
+        """
+        path, file_id, master_ie, other_values = next(iterator)
+        self.assertEqual((exp_path, exp_file_id), (path, file_id),
+                         'Master entry did not match')
+        if master_has_node:
+            self.assertIsNot(None, master_ie, 'master should have an entry')
+        else:
+            self.assertIs(None, master_ie, 'master should not have an entry')
+        self.assertEqual(len(exp_other_paths), len(other_values),
+                         'Wrong number of other entries')
+        other_paths = []
+        other_file_ids = []
+        for path, ie in other_values:
+            other_paths.append(path)
+            if ie is None:
+                other_file_ids.append(None)
+            else:
+                other_file_ids.append(ie.file_id)
+
+        exp_file_ids = []
+        for path in exp_other_paths:
+            if path is None:
+                exp_file_ids.append(None)
+            else:
+                exp_file_ids.append(file_id)
+        self.assertEqual(exp_other_paths, other_paths, "Other paths incorrect")
+        self.assertEqual(exp_file_ids, other_file_ids,
+                         "Other file_ids incorrect")
+
+    def lock_and_get_basis_and_root_id(self, tree):
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+        basis_tree = tree.basis_tree()
+        basis_tree.lock_read()
+        self.addCleanup(basis_tree.unlock)
+        root_id = tree.path2id('')
+        return basis_tree, root_id
+
+    def test_simple_stepping(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])
+        tree.add(['a', 'b', 'b/c'], [b'a-id', b'b-id', b'c-id'])
+
+        tree.commit('first', rev_id=b'first-rev-id')
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+
+        walker = multiwalker.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'b', b'b-id', True, [u'b'], iterator)
+        self.assertWalkerNext(u'b/c', b'c-id', True, [u'b/c'], iterator)
+        self.assertRaises(StopIteration, next, iterator)
+
+    def test_master_has_extra(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b/', 'tree/c', 'tree/d'])
+        tree.add(['a', 'b', 'd'], [b'a-id', b'b-id', b'd-id'])
+
+        tree.commit('first', rev_id=b'first-rev-id')
+
+        tree.add(['c'], [b'c-id'])
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+
+        walker = multiwalker.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'b', b'b-id', True, [u'b'], iterator)
+        self.assertWalkerNext(u'c', b'c-id', True, [None], iterator)
+        self.assertWalkerNext(u'd', b'd-id', True, [u'd'], iterator)
+        self.assertRaises(StopIteration, next, iterator)
+
+    def test_master_renamed_to_earlier(self):
+        """The record is still present, it just shows up early."""
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/c', 'tree/d'])
+        tree.add(['a', 'c', 'd'], [b'a-id', b'c-id', b'd-id'])
+        tree.commit('first', rev_id=b'first-rev-id')
+        tree.rename_one('d', 'b')
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+
+        walker = multiwalker.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'b', b'd-id', True, [u'd'], iterator)
+        self.assertWalkerNext(u'c', b'c-id', True, [u'c'], iterator)
+        self.assertRaises(StopIteration, next, iterator)
+
+    def test_master_renamed_to_later(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
+        tree.add(['a', 'b', 'd'], [b'a-id', b'b-id', b'd-id'])
+        tree.commit('first', rev_id=b'first-rev-id')
+        tree.rename_one('b', 'e')
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+
+        walker = multiwalker.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'd', b'd-id', True, [u'd'], iterator)
+        self.assertWalkerNext(u'e', b'b-id', True, [u'b'], iterator)
+        self.assertRaises(StopIteration, next, iterator)
+
+    def test_other_extra_in_middle(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
+        tree.add(['a', 'b', 'd'], [b'a-id', b'b-id', b'd-id'])
+        tree.commit('first', rev_id=b'first-rev-id')
+        tree.remove(['b'])
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+        walker = multiwalker.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'd', b'd-id', True, [u'd'], iterator)
+        self.assertWalkerNext(u'b', b'b-id', False, [u'b'], iterator)
+        self.assertRaises(StopIteration, next, iterator)
+
+    def test_other_extra_at_end(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
+        tree.add(['a', 'b', 'd'], [b'a-id', b'b-id', b'd-id'])
+        tree.commit('first', rev_id=b'first-rev-id')
+        tree.remove(['d'])
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+        walker = multiwalker.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'b', b'b-id', True, [u'b'], iterator)
+        self.assertWalkerNext(u'd', b'd-id', False, [u'd'], iterator)
+        self.assertRaises(StopIteration, next, iterator)
+
+    def test_others_extra_at_end(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/c', 'tree/d', 'tree/e'])
+        tree.add(['a', 'b', 'c', 'd', 'e'],
+                 [b'a-id', b'b-id', b'c-id', b'd-id', b'e-id'])
+        tree.commit('first', rev_id=b'first-rev-id')
+        tree.remove(['e'])
+        tree.commit('second', rev_id=b'second-rev-id')
+        tree.remove(['d'])
+        tree.commit('third', rev_id=b'third-rev-id')
+        tree.remove(['c'])
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+        first_tree = tree.branch.repository.revision_tree(b'first-rev-id')
+        second_tree = tree.branch.repository.revision_tree(b'second-rev-id')
+        walker = multiwalker.MultiWalker(
+            tree, [basis_tree, first_tree, second_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u'', u'', u''], iterator)
+        self.assertWalkerNext(u'a', b'a-id', True,
+                              [u'a', u'a', u'a'], iterator)
+        self.assertWalkerNext(u'b', b'b-id', True,
+                              [u'b', u'b', u'b'], iterator)
+        self.assertWalkerNext(u'c', b'c-id', False,
+                              [u'c', u'c', u'c'], iterator)
+        self.assertWalkerNext(u'd', b'd-id', False,
+                              [None, u'd', u'd'], iterator)
+        self.assertWalkerNext(u'e', b'e-id', False,
+                              [None, u'e', None], iterator)
+        self.assertRaises(StopIteration, next, iterator)
+
+    def test_different_file_id_in_others(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/c/'])
+        tree.add(['a', 'b', 'c'], [b'a-id', b'b-id', b'c-id'])
+        tree.commit('first', rev_id=b'first-rev-id')
+
+        tree.rename_one('b', 'c/d')
+        self.build_tree(['tree/b'])
+        tree.add(['b'], [b'b2-id'])
+        tree.commit('second', rev_id=b'second-rev-id')
+
+        tree.rename_one('a', 'c/e')
+        self.build_tree(['tree/a'])
+        tree.add(['a'], [b'a2-id'])
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+        first_tree = tree.branch.repository.revision_tree(b'first-rev-id')
+        walker = multiwalker.MultiWalker(tree, [basis_tree, first_tree])
+
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u'', u''], iterator)
+        self.assertWalkerNext(u'a', b'a2-id', True, [None, None], iterator)
+        self.assertWalkerNext(u'b', b'b2-id', True, [u'b', None], iterator)
+        self.assertWalkerNext(u'c', b'c-id', True, [u'c', u'c'], iterator)
+        self.assertWalkerNext(u'c/d', b'b-id', True, [u'c/d', u'b'], iterator)
+        self.assertWalkerNext(u'c/e', b'a-id', True, [u'a', u'a'], iterator)
+        self.assertRaises(StopIteration, next, iterator)
+
+    def assertLtByDirblock(self, lt_val, path1, path2):
+        self.assertEqual(
+            lt_val, multiwalker.MultiWalker._lt_path_by_dirblock(path1, path2))
+
+    def test__lt_path_by_dirblock(self):
+        # We only support Unicode strings at this point
+        self.assertRaises(
+            TypeError, multiwalker.MultiWalker._lt_path_by_dirblock, b'', b'b')
+        self.assertLtByDirblock(False, u'', u'')
+        self.assertLtByDirblock(False, u'a', u'a')
+        self.assertLtByDirblock(False, u'a/b', u'a/b')
+        self.assertLtByDirblock(False, u'a/b/c', u'a/b/c')
+        self.assertLtByDirblock(False, u'a-a', u'a')
+        self.assertLtByDirblock(True, u'a-a', u'a/a')
+        self.assertLtByDirblock(True, u'a=a', u'a/a')
+        self.assertLtByDirblock(False, u'a-a/a', u'a/a')
+        self.assertLtByDirblock(False, u'a=a/a', u'a/a')
+        self.assertLtByDirblock(False, u'a-a/a', u'a/a/a')
+        self.assertLtByDirblock(False, u'a=a/a', u'a/a/a')
+        self.assertLtByDirblock(False, u'a-a/a/a', u'a/a/a')
+        self.assertLtByDirblock(False, u'a=a/a/a', u'a/a/a')
+
+    def assertPathToKey(self, expected, path):
+        self.assertEqual(expected, multiwalker.MultiWalker._path_to_key(path))
+
+    def test__path_to_key(self):
+        self.assertPathToKey(([u''], u''), u'')
+        self.assertPathToKey(([u''], u'a'), u'a')
+        self.assertPathToKey(([u'a'], u'b'), u'a/b')
+        self.assertPathToKey(([u'a', u'b'], u'c'), u'a/b/c')

=== modified file 'breezy/tests/test_patch.py'
--- breezy/tests/test_patch.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_patch.py	2019-04-06 12:28:50 +0000
@@ -1,4 +1,5 @@
 # Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2008 Aaron Bentley <aaron@aaronbentley.com>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 from breezy.errors import BinaryFile
-from breezy.patch import diff3
+from breezy.patch import diff3, PatchInvokeError, run_patch
 from breezy.tests import TestCaseInTempDir
 
 
@@ -29,3 +30,10 @@
         with open('base', 'wb') as f:
             f.write(b'\x00')
         self.assertRaises(BinaryFile, diff3, 'unused', 'this', 'other', 'base')
+
+
+class TestPatch(TestCaseInTempDir):
+
+    def test_missing_patch(self):
+        self.assertRaises(PatchInvokeError, run_patch, '.', [],
+                          _patch_cmd='/unlikely/to/exist')

=== modified file 'breezy/tests/test_read_bundle.py'
--- breezy/tests/test_read_bundle.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_read_bundle.py	2018-11-17 00:47:52 +0000
@@ -16,7 +16,7 @@
 
 """Test read_bundle works properly across various transports."""
 
-import breezy.bundle
+import breezy.mergeable
 from ..bundle.serializer import write_bundle
 import breezy.bzr.bzrdir
 from .. import errors
@@ -71,7 +71,7 @@
         self.create_test_bundle()
 
     def read_mergeable_from_url(self, url):
-        return breezy.bundle.read_mergeable_from_url(
+        return breezy.mergeable.read_mergeable_from_url(
             url, possible_transports=self.possible_transports)
 
     def get_url(self, relpath=''):

=== modified file 'breezy/tests/test_remote.py'
--- breezy/tests/test_remote.py	2019-02-15 14:00:31 +0000
+++ breezy/tests/test_remote.py	2019-06-01 02:04:54 +0000
@@ -2214,6 +2214,31 @@
                           branch.revision_id_to_dotted_revno, b'unknown')
         self.assertFinished(client)
 
+    def test_ghost_revid(self):
+        transport = MemoryTransport()
+        client = FakeClient(transport.base)
+        client.add_expected_call(
+            b'Branch.get_stacked_on_url', (b'quack/',),
+            b'error', (b'NotStacked',),)
+        # Some older versions of bzr/brz didn't explicitly return
+        # GhostRevisionsHaveNoRevno
+        client.add_expected_call(
+            b'Branch.revision_id_to_revno', (b'quack/', b'revid'),
+            b'error', (b'error', b'GhostRevisionsHaveNoRevno',
+                       b'The reivison {revid} was not found because there was '
+                       b'a ghost at {ghost-revid}'))
+        client.add_expected_call(
+            b'Branch.revision_id_to_revno', (b'quack/', b'revid'),
+            b'error', (b'GhostRevisionsHaveNoRevno', b'revid', b'ghost-revid',))
+        transport.mkdir('quack')
+        transport = transport.clone('quack')
+        branch = self.make_remote_branch(transport, client)
+        self.assertRaises(errors.GhostRevisionsHaveNoRevno,
+                          branch.revision_id_to_dotted_revno, b'revid')
+        self.assertRaises(errors.GhostRevisionsHaveNoRevno,
+                          branch.revision_id_to_dotted_revno, b'revid')
+        self.assertFinished(client)
+
     def test_dotted_no_smart_verb(self):
         self.setup_smart_server_with_call_log()
         branch = self.make_branch('.')
@@ -2991,6 +3016,31 @@
             repo.get_rev_id_for_revno, 5, (42, b'rev-foo'))
         self.assertFinished(client)
 
+    def test_outofbounds(self):
+        repo, client = self.setup_fake_client_and_repository('quack')
+        client.add_expected_call(
+            b'Repository.get_rev_id_for_revno', (b'quack/',
+                                                 43, (42, b'rev-foo')),
+            b'error', (b'revno-outofbounds', 43, 0, 42))
+        self.assertRaises(
+            errors.RevnoOutOfBounds,
+            repo.get_rev_id_for_revno, 43, (42, b'rev-foo'))
+        self.assertFinished(client)
+
+    def test_outofbounds_old(self):
+        # Older versions of bzr didn't support RevnoOutOfBounds
+        repo, client = self.setup_fake_client_and_repository('quack')
+        client.add_expected_call(
+            b'Repository.get_rev_id_for_revno', (b'quack/',
+                                                 43, (42, b'rev-foo')),
+            b'error', (
+                b'error', b'ValueError',
+                b'requested revno (43) is later than given known revno (42)'))
+        self.assertRaises(
+            errors.RevnoOutOfBounds,
+            repo.get_rev_id_for_revno, 43, (42, b'rev-foo'))
+        self.assertFinished(client)
+
     def test_branch_fallback_locking(self):
         """RemoteBranch.get_rev_id takes a read lock, and tries to call the
         get_rev_id_for_revno verb.  If the verb is unknown the VFS fallback
@@ -3918,6 +3968,12 @@
         expected_error = errors.UnknownErrorFromSmartServer(err)
         self.assertEqual(expected_error, translated_error)
 
+    def test_RevnoOutOfBounds(self):
+        translated_error = self.translateTuple(
+            ((b'revno-outofbounds', 5, 0, 3)), path=b'path')
+        expected_error = errors.RevnoOutOfBounds(5, (0, 3))
+        self.assertEqual(expected_error, translated_error)
+
 
 class TestErrorTranslationRobustness(TestErrorTranslationBase):
     """Unit tests for breezy.bzr.remote._translate_error's robustness.

=== modified file 'breezy/tests/test_script.py'
--- breezy/tests/test_script.py	2018-11-20 21:24:08 +0000
+++ breezy/tests/test_script.py	2019-03-05 09:17:49 +0000
@@ -322,12 +322,12 @@
     def test_cat_input_to_file(self):
         retcode, out, err = self.run_command(['cat', '>file'],
                                              'content\n', None, None)
-        self.assertFileEqual(b'content\n', 'file')
+        self.assertFileEqual('content\n', 'file')
         self.assertEqual(None, out)
         self.assertEqual(None, err)
         retcode, out, err = self.run_command(['cat', '>>file'],
                                              'more\n', None, None)
-        self.assertFileEqual(b'content\nmore\n', 'file')
+        self.assertFileEqual('content\nmore\n', 'file')
         self.assertEqual(None, out)
         self.assertEqual(None, err)
 

=== modified file 'breezy/tests/test_smart.py'
--- breezy/tests/test_smart.py	2018-11-29 23:42:41 +0000
+++ breezy/tests/test_smart.py	2019-03-06 21:27:22 +0000
@@ -905,6 +905,19 @@
         self.assertEqual(smart_req.SmartServerResponse((b'ok', b'0')),
                          request.execute(b'', b'null:'))
 
+    def test_ghost_revision(self):
+        backing = self.get_transport()
+        request = smart_branch.SmartServerBranchRequestRevisionIdToRevno(
+            backing)
+        branch = self.make_branch('.')
+        def revision_id_to_dotted_revno(revid):
+            raise errors.GhostRevisionsHaveNoRevno(revid, b'ghost-revid')
+        self.overrideAttr(branch, 'revision_id_to_dotted_revno', revision_id_to_dotted_revno)
+        self.assertEqual(
+            smart_req.FailedSmartServerResponse(
+                (b'GhostRevisionsHaveNoRevno', b'revid', b'ghost-revid')),
+            request.do_with_branch(branch, b'revid'))
+
     def test_simple(self):
         backing = self.get_transport()
         request = smart_branch.SmartServerBranchRequestRevisionIdToRevno(

=== modified file 'breezy/tests/test_source.py'
--- breezy/tests/test_source.py	2018-11-16 19:10:17 +0000
+++ breezy/tests/test_source.py	2019-06-02 05:13:10 +0000
@@ -332,10 +332,31 @@
         new_path.insert(
             0, os.path.join(os.path.dirname(__file__), '..', '..', 'tools'))
         self.overrideAttr(sys, 'path', new_path)
-        from flake8.api import legacy as flake8
-        style_guide = flake8.get_style_guide(config=u'setup.cfg', jobs="1")
-        report = style_guide.check_files(list(self.get_source_files()))
-        self.assertEqual([], report.get_statistics(''))
+        from flake8.main.application import Application
+        from flake8.formatting.base import BaseFormatter
+        app = Application()
+        app.config = u'setup.cfg'
+        app.jobs = 1
+
+        class Formatter(BaseFormatter):
+
+            def __init__(self):
+                self.errors = []
+
+            def start(self):
+                pass
+
+            def stop(self):
+                app.file_checker_manager.report()
+
+            def handle(self, error):
+                self.errors.append(error)
+
+        app.formatter = Formatter()
+        app.initialize([])
+        app.run_checks()
+        app.report()
+        self.assertEqual(app.formatter.errors, [])
 
     def test_no_asserts(self):
         """bzr shouldn't use the 'assert' statement."""

=== modified file 'breezy/tests/test_tree.py'
--- breezy/tests/test_tree.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_tree.py	2019-05-12 09:30:18 +0000
@@ -163,285 +163,6 @@
         self.assertEqual(len(delta.added), 1)
 
 
-class TestMultiWalker(TestCaseWithTransport):
-
-    def assertStepOne(self, has_more, path, file_id, iterator):
-        retval = _mod_tree.MultiWalker._step_one(iterator)
-        if not has_more:
-            self.assertIs(None, path)
-            self.assertIs(None, file_id)
-            self.assertEqual((False, None, None), retval)
-        else:
-            self.assertEqual((has_more, path, file_id),
-                             (retval[0], retval[1], retval[2].file_id))
-
-    def test__step_one_empty(self):
-        tree = self.make_branch_and_tree('empty')
-        repo = tree.branch.repository
-        empty_tree = repo.revision_tree(revision.NULL_REVISION)
-
-        iterator = empty_tree.iter_entries_by_dir()
-        self.assertStepOne(False, None, None, iterator)
-        self.assertStepOne(False, None, None, iterator)
-
-    def test__step_one(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])
-        tree.add(['a', 'b', 'b/c'], [b'a-id', b'b-id', b'c-id'])
-
-        iterator = tree.iter_entries_by_dir()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-
-        root_id = tree.path2id('')
-        self.assertStepOne(True, '', root_id, iterator)
-        self.assertStepOne(True, 'a', b'a-id', iterator)
-        self.assertStepOne(True, 'b', b'b-id', iterator)
-        self.assertStepOne(True, 'b/c', b'c-id', iterator)
-        self.assertStepOne(False, None, None, iterator)
-        self.assertStepOne(False, None, None, iterator)
-
-    def assertWalkerNext(self, exp_path, exp_file_id, master_has_node,
-                         exp_other_paths, iterator):
-        """Check what happens when we step the iterator.
-
-        :param path: The path for this entry
-        :param file_id: The file_id for this entry
-        :param master_has_node: Does the master tree have this entry?
-        :param exp_other_paths: A list of other_path values.
-        :param iterator: The iterator to step
-        """
-        path, file_id, master_ie, other_values = next(iterator)
-        self.assertEqual((exp_path, exp_file_id), (path, file_id),
-                         'Master entry did not match')
-        if master_has_node:
-            self.assertIsNot(None, master_ie, 'master should have an entry')
-        else:
-            self.assertIs(None, master_ie, 'master should not have an entry')
-        self.assertEqual(len(exp_other_paths), len(other_values),
-                         'Wrong number of other entries')
-        other_paths = []
-        other_file_ids = []
-        for path, ie in other_values:
-            other_paths.append(path)
-            if ie is None:
-                other_file_ids.append(None)
-            else:
-                other_file_ids.append(ie.file_id)
-
-        exp_file_ids = []
-        for path in exp_other_paths:
-            if path is None:
-                exp_file_ids.append(None)
-            else:
-                exp_file_ids.append(file_id)
-        self.assertEqual(exp_other_paths, other_paths, "Other paths incorrect")
-        self.assertEqual(exp_file_ids, other_file_ids,
-                         "Other file_ids incorrect")
-
-    def lock_and_get_basis_and_root_id(self, tree):
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        basis_tree = tree.basis_tree()
-        basis_tree.lock_read()
-        self.addCleanup(basis_tree.unlock)
-        root_id = tree.path2id('')
-        return basis_tree, root_id
-
-    def test_simple_stepping(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])
-        tree.add(['a', 'b', 'b/c'], [b'a-id', b'b-id', b'c-id'])
-
-        tree.commit('first', rev_id=b'first-rev-id')
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'b', b'b-id', True, [u'b'], iterator)
-        self.assertWalkerNext(u'b/c', b'c-id', True, [u'b/c'], iterator)
-        self.assertRaises(StopIteration, next, iterator)
-
-    def test_master_has_extra(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b/', 'tree/c', 'tree/d'])
-        tree.add(['a', 'b', 'd'], [b'a-id', b'b-id', b'd-id'])
-
-        tree.commit('first', rev_id=b'first-rev-id')
-
-        tree.add(['c'], [b'c-id'])
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'b', b'b-id', True, [u'b'], iterator)
-        self.assertWalkerNext(u'c', b'c-id', True, [None], iterator)
-        self.assertWalkerNext(u'd', b'd-id', True, [u'd'], iterator)
-        self.assertRaises(StopIteration, next, iterator)
-
-    def test_master_renamed_to_earlier(self):
-        """The record is still present, it just shows up early."""
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/c', 'tree/d'])
-        tree.add(['a', 'c', 'd'], [b'a-id', b'c-id', b'd-id'])
-        tree.commit('first', rev_id=b'first-rev-id')
-        tree.rename_one('d', 'b')
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'b', b'd-id', True, [u'd'], iterator)
-        self.assertWalkerNext(u'c', b'c-id', True, [u'c'], iterator)
-        self.assertRaises(StopIteration, next, iterator)
-
-    def test_master_renamed_to_later(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
-        tree.add(['a', 'b', 'd'], [b'a-id', b'b-id', b'd-id'])
-        tree.commit('first', rev_id=b'first-rev-id')
-        tree.rename_one('b', 'e')
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'd', b'd-id', True, [u'd'], iterator)
-        self.assertWalkerNext(u'e', b'b-id', True, [u'b'], iterator)
-        self.assertRaises(StopIteration, next, iterator)
-
-    def test_other_extra_in_middle(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
-        tree.add(['a', 'b', 'd'], [b'a-id', b'b-id', b'd-id'])
-        tree.commit('first', rev_id=b'first-rev-id')
-        tree.remove(['b'])
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'd', b'd-id', True, [u'd'], iterator)
-        self.assertWalkerNext(u'b', b'b-id', False, [u'b'], iterator)
-        self.assertRaises(StopIteration, next, iterator)
-
-    def test_other_extra_at_end(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
-        tree.add(['a', 'b', 'd'], [b'a-id', b'b-id', b'd-id'])
-        tree.commit('first', rev_id=b'first-rev-id')
-        tree.remove(['d'])
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', b'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'b', b'b-id', True, [u'b'], iterator)
-        self.assertWalkerNext(u'd', b'd-id', False, [u'd'], iterator)
-        self.assertRaises(StopIteration, next, iterator)
-
-    def test_others_extra_at_end(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/c', 'tree/d', 'tree/e'])
-        tree.add(['a', 'b', 'c', 'd', 'e'],
-                 [b'a-id', b'b-id', b'c-id', b'd-id', b'e-id'])
-        tree.commit('first', rev_id=b'first-rev-id')
-        tree.remove(['e'])
-        tree.commit('second', rev_id=b'second-rev-id')
-        tree.remove(['d'])
-        tree.commit('third', rev_id=b'third-rev-id')
-        tree.remove(['c'])
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-        first_tree = tree.branch.repository.revision_tree(b'first-rev-id')
-        second_tree = tree.branch.repository.revision_tree(b'second-rev-id')
-        walker = _mod_tree.MultiWalker(tree, [basis_tree, first_tree,
-                                              second_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u'', u'', u''], iterator)
-        self.assertWalkerNext(u'a', b'a-id', True,
-                              [u'a', u'a', u'a'], iterator)
-        self.assertWalkerNext(u'b', b'b-id', True,
-                              [u'b', u'b', u'b'], iterator)
-        self.assertWalkerNext(u'c', b'c-id', False,
-                              [u'c', u'c', u'c'], iterator)
-        self.assertWalkerNext(u'd', b'd-id', False,
-                              [None, u'd', u'd'], iterator)
-        self.assertWalkerNext(u'e', b'e-id', False,
-                              [None, u'e', None], iterator)
-        self.assertRaises(StopIteration, next, iterator)
-
-    def test_different_file_id_in_others(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/c/'])
-        tree.add(['a', 'b', 'c'], [b'a-id', b'b-id', b'c-id'])
-        tree.commit('first', rev_id=b'first-rev-id')
-
-        tree.rename_one('b', 'c/d')
-        self.build_tree(['tree/b'])
-        tree.add(['b'], [b'b2-id'])
-        tree.commit('second', rev_id=b'second-rev-id')
-
-        tree.rename_one('a', 'c/e')
-        self.build_tree(['tree/a'])
-        tree.add(['a'], [b'a2-id'])
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-        first_tree = tree.branch.repository.revision_tree(b'first-rev-id')
-        walker = _mod_tree.MultiWalker(tree, [basis_tree, first_tree])
-
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u'', u''], iterator)
-        self.assertWalkerNext(u'a', b'a2-id', True, [None, None], iterator)
-        self.assertWalkerNext(u'b', b'b2-id', True, [u'b', None], iterator)
-        self.assertWalkerNext(u'c', b'c-id', True, [u'c', u'c'], iterator)
-        self.assertWalkerNext(u'c/d', b'b-id', True, [u'c/d', u'b'], iterator)
-        self.assertWalkerNext(u'c/e', b'a-id', True, [u'a', u'a'], iterator)
-        self.assertRaises(StopIteration, next, iterator)
-
-    def assertLtByDirblock(self, lt_val, path1, path2):
-        self.assertEqual(
-            lt_val, _mod_tree.MultiWalker._lt_path_by_dirblock(path1, path2))
-
-    def test__lt_path_by_dirblock(self):
-        # We only support Unicode strings at this point
-        self.assertRaises(
-            TypeError, _mod_tree.MultiWalker._lt_path_by_dirblock, b'', b'b')
-        self.assertLtByDirblock(False, u'', u'')
-        self.assertLtByDirblock(False, u'a', u'a')
-        self.assertLtByDirblock(False, u'a/b', u'a/b')
-        self.assertLtByDirblock(False, u'a/b/c', u'a/b/c')
-        self.assertLtByDirblock(False, u'a-a', u'a')
-        self.assertLtByDirblock(True, u'a-a', u'a/a')
-        self.assertLtByDirblock(True, u'a=a', u'a/a')
-        self.assertLtByDirblock(False, u'a-a/a', u'a/a')
-        self.assertLtByDirblock(False, u'a=a/a', u'a/a')
-        self.assertLtByDirblock(False, u'a-a/a', u'a/a/a')
-        self.assertLtByDirblock(False, u'a=a/a', u'a/a/a')
-        self.assertLtByDirblock(False, u'a-a/a/a', u'a/a/a')
-        self.assertLtByDirblock(False, u'a=a/a/a', u'a/a/a')
-
-    def assertPathToKey(self, expected, path):
-        self.assertEqual(expected, _mod_tree.MultiWalker._path_to_key(path))
-
-    def test__path_to_key(self):
-        self.assertPathToKey(([u''], u''), u'')
-        self.assertPathToKey(([u''], u'a'), u'a')
-        self.assertPathToKey(([u'a'], u'b'), u'a/b')
-        self.assertPathToKey(([u'a', u'b'], u'c'), u'a/b/c')
-
-
 class FindPreviousPathsTests(TestCaseWithTransport):
 
     def test_new(self):

=== modified file 'breezy/tests/test_workingtree.py'
--- breezy/tests/test_workingtree.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_workingtree.py	2019-06-02 21:21:39 +0000
@@ -452,18 +452,6 @@
         tree.auto_resolve()
 
 
-class TestFindTrees(TestCaseWithTransport):
-
-    def test_find_trees(self):
-        self.make_branch_and_tree('foo')
-        self.make_branch_and_tree('foo/bar')
-        # Sticking a tree inside a control dir is heinous, so let's skip it
-        self.make_branch_and_tree('foo/.bzr/baz')
-        self.make_branch('qux')
-        trees = workingtree.WorkingTree.find_trees('.')
-        self.assertEqual(2, len(list(trees)))
-
-
 class TestStoredUncommitted(TestCaseWithTransport):
 
     def store_uncommitted(self):

=== modified file 'breezy/textmerge.py'
--- breezy/textmerge.py	2018-11-11 04:08:32 +0000
+++ breezy/textmerge.py	2019-03-02 21:46:18 +0000
@@ -21,7 +21,7 @@
 
 from .lazy_import import lazy_import
 lazy_import(globals(), """
-from breezy import patiencediff
+import patiencediff
 """)
 
 

=== modified file 'breezy/transport/http/__init__.py'
--- breezy/transport/http/__init__.py	2019-05-20 03:52:25 +0000
+++ breezy/transport/http/__init__.py	2019-06-03 23:48:08 +0000
@@ -1996,7 +1996,10 @@
             def getheader(self, name, default=None):
                 if self._actual.headers is None:
                     raise http_client.ResponseNotReady()
-                return self._actual.headers.getheader(name, default)
+                if PY3:
+                    return self._actual.headers.get(name, default)
+                else:
+                    return self._actual.headers.getheader(name, default)
 
             def getheaders(self):
                 if self._actual.headers is None:

=== modified file 'breezy/tree.py'
--- breezy/tree.py	2019-02-02 15:13:30 +0000
+++ breezy/tree.py	2019-05-12 09:46:22 +0000
@@ -945,7 +945,8 @@
                                                    changed_file_ids):
                 yield result
 
-    def _get_entry(self, tree, path):
+    @staticmethod
+    def _get_entry(tree, path):
         """Get an inventory entry from a tree, with missing entries as None.
 
         If the tree raises NotImplementedError on accessing .inventory, then
@@ -1091,239 +1092,6 @@
 InterTree.register_optimiser(InterTree)
 
 
-class MultiWalker(object):
-    """Walk multiple trees simultaneously, getting combined results."""
-
-    # Note: This could be written to not assume you can do out-of-order
-    #       lookups. Instead any nodes that don't match in all trees could be
-    #       marked as 'deferred', and then returned in the final cleanup loop.
-    #       For now, I think it is "nicer" to return things as close to the
-    #       "master_tree" order as we can.
-
-    def __init__(self, master_tree, other_trees):
-        """Create a new MultiWalker.
-
-        All trees being walked must implement "iter_entries_by_dir()", such
-        that they yield (path, object) tuples, where that object will have a
-        '.file_id' member, that can be used to check equality.
-
-        :param master_tree: All trees will be 'slaved' to the master_tree such
-            that nodes in master_tree will be used as 'first-pass' sync points.
-            Any nodes that aren't in master_tree will be merged in a second
-            pass.
-        :param other_trees: A list of other trees to walk simultaneously.
-        """
-        self._master_tree = master_tree
-        self._other_trees = other_trees
-
-        # Keep track of any nodes that were properly processed just out of
-        # order, that way we don't return them at the end, we don't have to
-        # track *all* processed file_ids, just the out-of-order ones
-        self._out_of_order_processed = set()
-
-    @staticmethod
-    def _step_one(iterator):
-        """Step an iter_entries_by_dir iterator.
-
-        :return: (has_more, path, ie)
-            If has_more is False, path and ie will be None.
-        """
-        try:
-            path, ie = next(iterator)
-        except StopIteration:
-            return False, None, None
-        else:
-            return True, path, ie
-
-    @staticmethod
-    def _lt_path_by_dirblock(path1, path2):
-        """Compare two paths based on what directory they are in.
-
-        This generates a sort order, such that all children of a directory are
-        sorted together, and grandchildren are in the same order as the
-        children appear. But all grandchildren come after all children.
-
-        :param path1: first path
-        :param path2: the second path
-        :return: negative number if ``path1`` comes first,
-            0 if paths are equal
-            and a positive number if ``path2`` sorts first
-        """
-        # Shortcut this special case
-        if path1 == path2:
-            return False
-        # This is stolen from _dirstate_helpers_py.py, only switching it to
-        # Unicode objects. Consider using encode_utf8() and then using the
-        # optimized versions, or maybe writing optimized unicode versions.
-        if not isinstance(path1, text_type):
-            raise TypeError("'path1' must be a unicode string, not %s: %r"
-                            % (type(path1), path1))
-        if not isinstance(path2, text_type):
-            raise TypeError("'path2' must be a unicode string, not %s: %r"
-                            % (type(path2), path2))
-        return (MultiWalker._path_to_key(path1) <
-                MultiWalker._path_to_key(path2))
-
-    @staticmethod
-    def _path_to_key(path):
-        dirname, basename = osutils.split(path)
-        return (dirname.split(u'/'), basename)
-
-    def _lookup_by_file_id(self, extra_entries, other_tree, file_id):
-        """Lookup an inventory entry by file_id.
-
-        This is called when an entry is missing in the normal order.
-        Generally this is because a file was either renamed, or it was
-        deleted/added. If the entry was found in the inventory and not in
-        extra_entries, it will be added to self._out_of_order_processed
-
-        :param extra_entries: A dictionary of {file_id: (path, ie)}.  This
-            should be filled with entries that were found before they were
-            used. If file_id is present, it will be removed from the
-            dictionary.
-        :param other_tree: The Tree to search, in case we didn't find the entry
-            yet.
-        :param file_id: The file_id to look for
-        :return: (path, ie) if found or (None, None) if not present.
-        """
-        if file_id in extra_entries:
-            return extra_entries.pop(file_id)
-        # TODO: Is id2path better as the first call, or is
-        #       inventory[file_id] better as a first check?
-        try:
-            cur_path = other_tree.id2path(file_id)
-        except errors.NoSuchId:
-            cur_path = None
-        if cur_path is None:
-            return (None, None)
-        else:
-            self._out_of_order_processed.add(file_id)
-            cur_ie = other_tree.root_inventory.get_entry(file_id)
-            return (cur_path, cur_ie)
-
-    def iter_all(self):
-        """Match up the values in the different trees."""
-        for result in self._walk_master_tree():
-            yield result
-        self._finish_others()
-        for result in self._walk_others():
-            yield result
-
-    def _walk_master_tree(self):
-        """First pass, walk all trees in lock-step.
-
-        When we are done, all nodes in the master_tree will have been
-        processed. _other_walkers, _other_entries, and _others_extra will be
-        set on 'self' for future processing.
-        """
-        # This iterator has the most "inlining" done, because it tends to touch
-        # every file in the tree, while the others only hit nodes that don't
-        # match.
-        master_iterator = self._master_tree.iter_entries_by_dir()
-
-        other_walkers = [other.iter_entries_by_dir()
-                         for other in self._other_trees]
-        other_entries = [self._step_one(walker) for walker in other_walkers]
-        # Track extra nodes in the other trees
-        others_extra = [{} for _ in range(len(self._other_trees))]
-
-        master_has_more = True
-        step_one = self._step_one
-        lookup_by_file_id = self._lookup_by_file_id
-        out_of_order_processed = self._out_of_order_processed
-
-        while master_has_more:
-            (master_has_more, path, master_ie) = step_one(master_iterator)
-            if not master_has_more:
-                break
-
-            file_id = master_ie.file_id
-            other_values = []
-            other_values_append = other_values.append
-            next_other_entries = []
-            next_other_entries_append = next_other_entries.append
-            for idx, (other_has_more, other_path, other_ie) in enumerate(other_entries):
-                if not other_has_more:
-                    other_values_append(lookup_by_file_id(
-                        others_extra[idx], self._other_trees[idx], file_id))
-                    next_other_entries_append((False, None, None))
-                elif file_id == other_ie.file_id:
-                    # This is the critical code path, as most of the entries
-                    # should match between most trees.
-                    other_values_append((other_path, other_ie))
-                    next_other_entries_append(step_one(other_walkers[idx]))
-                else:
-                    # This walker did not match, step it until it either
-                    # matches, or we know we are past the current walker.
-                    other_walker = other_walkers[idx]
-                    other_extra = others_extra[idx]
-                    while (other_has_more and
-                           self._lt_path_by_dirblock(other_path, path)):
-                        other_file_id = other_ie.file_id
-                        if other_file_id not in out_of_order_processed:
-                            other_extra[other_file_id] = (other_path, other_ie)
-                        other_has_more, other_path, other_ie = \
-                            step_one(other_walker)
-                    if other_has_more and other_ie.file_id == file_id:
-                        # We ended up walking to this point, match and step
-                        # again
-                        other_values_append((other_path, other_ie))
-                        other_has_more, other_path, other_ie = \
-                            step_one(other_walker)
-                    else:
-                        # This record isn't in the normal order, see if it
-                        # exists at all.
-                        other_values_append(lookup_by_file_id(
-                            other_extra, self._other_trees[idx], file_id))
-                    next_other_entries_append((other_has_more, other_path,
-                                               other_ie))
-            other_entries = next_other_entries
-
-            # We've matched all the walkers, yield this datapoint
-            yield path, file_id, master_ie, other_values
-        self._other_walkers = other_walkers
-        self._other_entries = other_entries
-        self._others_extra = others_extra
-
-    def _finish_others(self):
-        """Finish walking the other iterators, so we get all entries."""
-        for idx, info in enumerate(self._other_entries):
-            other_extra = self._others_extra[idx]
-            (other_has_more, other_path, other_ie) = info
-            while other_has_more:
-                other_file_id = other_ie.file_id
-                if other_file_id not in self._out_of_order_processed:
-                    other_extra[other_file_id] = (other_path, other_ie)
-                other_has_more, other_path, other_ie = \
-                    self._step_one(self._other_walkers[idx])
-        del self._other_entries
-
-    def _walk_others(self):
-        """Finish up by walking all the 'deferred' nodes."""
-        # TODO: One alternative would be to grab all possible unprocessed
-        #       file_ids, and then sort by path, and then yield them. That
-        #       might ensure better ordering, in case a caller strictly
-        #       requires parents before children.
-        for idx, other_extra in enumerate(self._others_extra):
-            others = sorted(viewvalues(other_extra),
-                            key=lambda x: self._path_to_key(x[0]))
-            for other_path, other_ie in others:
-                file_id = other_ie.file_id
-                # We don't need to check out_of_order_processed here, because
-                # the lookup_by_file_id will be removing anything processed
-                # from the extras cache
-                other_extra.pop(file_id)
-                other_values = [(None, None)] * idx
-                other_values.append((other_path, other_ie))
-                for alt_idx, alt_extra in enumerate(self._others_extra[idx + 1:]):
-                    alt_idx = alt_idx + idx + 1
-                    alt_extra = self._others_extra[alt_idx]
-                    alt_tree = self._other_trees[alt_idx]
-                    other_values.append(self._lookup_by_file_id(
-                        alt_extra, alt_tree, file_id))
-                yield other_path, file_id, None, other_values
-
-
 def find_previous_paths(from_tree, to_tree, paths):
     """Find previous tree paths.
 

=== modified file 'breezy/workingtree.py'
--- breezy/workingtree.py	2019-02-14 22:18:59 +0000
+++ breezy/workingtree.py	2019-06-02 21:29:09 +0000
@@ -43,7 +43,6 @@
 
 from breezy import (
     conflicts as _mod_conflicts,
-    controldir,
     errors,
     filters as _mod_filters,
     merge,
@@ -57,6 +56,13 @@
     )
 """)
 
+from .controldir import (
+    ControlComponent,
+    ControlComponentFormatRegistry,
+    ControlComponentFormat,
+    ControlDir,
+    ControlDirFormat,
+    )
 from . import (
     osutils,
     )
@@ -78,7 +84,7 @@
     _fmt = "This format does not support shelving changes."
 
 
-class WorkingTree(mutabletree.MutableTree, controldir.ControlComponent):
+class WorkingTree(mutabletree.MutableTree, ControlComponent):
     """Working copy tree.
 
     :ivar basedir: The root of the tree on disk. This is a unicode path object
@@ -198,7 +204,7 @@
         """
         if path is None:
             path = osutils.getcwd()
-        control = controldir.ControlDir.open(path, _unsupported=_unsupported)
+        control = ControlDir.open(path, _unsupported=_unsupported)
         return control.open_workingtree(unsupported=_unsupported)
 
     @staticmethod
@@ -216,7 +222,7 @@
         """
         if path is None:
             path = osutils.getcwd()
-        control, relpath = controldir.ControlDir.open_containing(path)
+        control, relpath = ControlDir.open_containing(path)
         return control.open_workingtree(), relpath
 
     @staticmethod
@@ -294,24 +300,6 @@
         """
         return WorkingTree.open(path, _unsupported=True)
 
-    @staticmethod
-    def find_trees(location):
-        def list_current(transport):
-            return [d for d in transport.list_dir('')
-                    if not controldir.is_control_filename(d)]
-
-        def evaluate(controldir):
-            try:
-                tree = controldir.open_workingtree()
-            except errors.NoWorkingTree:
-                return True, None
-            else:
-                return True, tree
-        t = transport.get_transport(location)
-        iterator = controldir.ControlDir.find_controldirs(t, evaluate=evaluate,
-                                                          list_current=list_current)
-        return [tr for tr in iterator if tr is not None]
-
     def __repr__(self):
         return "<%s of %s>" % (self.__class__.__name__,
                                getattr(self, 'basedir', None))
@@ -729,31 +717,8 @@
     def subsume(self, other_tree):
         raise NotImplementedError(self.subsume)
 
-    def _setup_directory_is_tree_reference(self):
-        if self._branch.repository._format.supports_tree_reference:
-            self._directory_is_tree_reference = \
-                self._directory_may_be_tree_reference
-        else:
-            self._directory_is_tree_reference = \
-                self._directory_is_never_tree_reference
-
-    def _directory_is_never_tree_reference(self, relpath):
-        return False
-
-    def _directory_may_be_tree_reference(self, relpath):
-        # as a special case, if a directory contains control files then
-        # it's a tree reference, except that the root of the tree is not
-        return relpath and osutils.isdir(self.abspath(relpath) + u"/.bzr")
-        # TODO: We could ask all the control formats whether they
-        # recognize this directory, but at the moment there's no cheap api
-        # to do that.  Since we probably can only nest bzr checkouts and
-        # they always use this name it's ok for now.  -- mbp 20060306
-        #
-        # FIXME: There is an unhandled case here of a subdirectory
-        # containing .bzr but not a branch; that will probably blow up
-        # when you try to commit it.  It might happen if there is a
-        # checkout in a subdirectory.  This can be avoided by not adding
-        # it.  mbp 20070306
+    def _directory_is_tree_reference(self, relpath):
+        raise NotImplementedError(self._directory_is_tree_reference)
 
     def extract(self, path, format=None):
         """Extract a subtree from this tree.
@@ -1373,7 +1338,7 @@
             return next(self.get_canonical_paths([path]))
 
 
-class WorkingTreeFormatRegistry(controldir.ControlComponentFormatRegistry):
+class WorkingTreeFormatRegistry(ControlComponentFormatRegistry):
     """Registry for working tree formats."""
 
     def __init__(self, other_registry=None):
@@ -1402,7 +1367,7 @@
 format_registry = WorkingTreeFormatRegistry()
 
 
-class WorkingTreeFormat(controldir.ControlComponentFormat):
+class WorkingTreeFormat(ControlComponentFormat):
     """An encapsulation of the initialization and open routines for a format.
 
     Formats provide three things:

=== added file 'build.cmd'
--- build.cmd	1970-01-01 00:00:00 +0000
+++ build.cmd	2019-03-05 07:32:38 +0000
@@ -0,0 +1,21 @@
+@echo off
+:: To build extensions for 64 bit Python 3, we need to configure environment
+:: variables to use the MSVC 2010 C++ compilers from GRMSDKX_EN_DVD.iso of:
+:: MS Windows SDK for Windows 7 and .NET Framework 4
+::
+:: More details at:
+:: https://github.com/cython/cython/wiki/CythonExtensionsOnWindows
+
+IF "%DISTUTILS_USE_SDK%"=="1" (
+    ECHO Configuring environment to build with MSVC on a 64bit architecture
+    ECHO Using Windows SDK 7.1
+    "C:\Program Files\Microsoft SDKs\Windows\v7.1\Setup\WindowsSdkVer.exe" -q -version:v7.1
+    CALL "C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\SetEnv.cmd" /x64 /release
+    SET MSSdk=1
+    REM Need the following to allow tox to see the SDK compiler
+    SET TOX_TESTENV_PASSENV=DISTUTILS_USE_SDK MSSdk INCLUDE LIB
+) ELSE (
+    ECHO Using default MSVC build environment
+)
+
+CALL %*

=== modified file 'byov.conf'
--- byov.conf	2019-03-04 10:18:17 +0000
+++ byov.conf	2019-06-02 05:13:10 +0000
@@ -13,6 +13,8 @@
 sphinx_epytext.install3 = (pip3 install sphinx_epytext)
 flake8.install = (pip install flake8)
 flake8.install3 = (pip3 install flake8)
+patiencediff.install = (pip install patiencediff)
+patiencediff.install3 = (pip3 install patiencediff)
 cython.install = (pip install cython)
 cython.install3 = (pip3 install cython)
 
@@ -32,9 +34,9 @@
 vm.packages = {brz.build_deps}, {subunit.build_deps}, bzr, git, python-junitxml
 [brz-xenial]
 vm.release = xenial
-byoci.setup.command = ({dulwich.clone} && {dulwich.install} && {dulwich.install3} && {fastimport.clone} && {fastimport.install} && {fastimport.install3} && {subunit.clone} && {flake8.install} && {flake8.install3} && {sphinx_epytext.install} && {sphinx_epytext.install3} && {cython.install} && {cython.install3})
+byoci.setup.command = ({dulwich.clone} && {dulwich.install} && {dulwich.install3} && {fastimport.clone} && {fastimport.install} && {fastimport.install3} && {subunit.clone} && {flake8.install} && {flake8.install3} && {patiencediff.install} && {patiencediff.install3} && {sphinx_epytext.install} && {sphinx_epytext.install3} && {cython.install} && {cython.install3})
 # FIXME: bzr log -l2 should be by default -- vila 2018-03-09
-byoci.tests.command = bash -o pipefail -c "bzr log -l2 && PYTHONPATH=../subunit/python:$PYTHONPATH PATH=../subunit/filters:$PATH make check-ci | subunit2junitxml -o ../results.xml -f | subunit2pyunit"
+byoci.tests.command = bash -o pipefail -c "bzr log -l2 && PYTHONPATH=../subunit/python:$PYTHONPATH PATH=../subunit/filters:$HOME/.local/bin:$PATH make check-ci | subunit2junitxml -o ../results.xml -f | subunit2pyunit"
 [brz-bionic]
 vm.release = bionic
 [brz-cosmic]
@@ -45,7 +47,7 @@
 vm.release = buster
 vm.packages = {brz.build_deps}, {subunit.build_deps}, bzr, git, python-dulwich, python3-dulwich, python-junitxml
 byoci.setup.command = ({subunit.clone})
-byoci.tests.command = bash -o pipefail -c "bzr log -l2 && (PYTHONPATH=../subunit/python:$PYTHONPATH PATH=../subunit/filters:$PATH make check-ci | subunit2junitxml -o ../results.xml -f | subunit2pyunit)"
+byoci.tests.command = bash -o pipefail -c "bzr log -l2 && (PYTHONPATH=../subunit/python:$PYTHONPATH PATH=../subunit/filters:$HOME/.local/bin:$PATH make check-ci | subunit2junitxml -o ../results.xml -f | subunit2pyunit)"
 [brz-sid]
 vm.distribution = debian
 vm.release = sid

=== modified file 'doc/en/release-notes/brz-3.0.txt'
--- doc/en/release-notes/brz-3.0.txt	2019-03-06 14:03:19 +0000
+++ doc/en/release-notes/brz-3.0.txt	2019-06-02 05:13:10 +0000
@@ -5,6 +5,68 @@
 .. toctree::
    :maxdepth: 1
 
+bzr 3.0.1
+#########
+
+:3.0.1: NOT RELEASED YET
+
+
+External Compatibility Breaks
+*****************************
+
+None.
+
+New Features
+************
+
+None.
+
+Improvements
+************
+
+None.
+
+
+Bug Fixes
+*********
+
+* Fix compatibility with newer versions of Dulwich (>= 0.19.12).
+  (Jelmer Vernooĳ)
+
+* Fix a nasty corner case merging changes into a tree with changed
+  symlinks when pushing from bzr into git.
+
+* Fix installation on Windows. (Raoul Snyman, #1818947)
+
+* Return consist errors from ``Branch.get_revid`` and
+  ``Repository.get_revid_for_revno`` when the revision
+  number is invalid. (Jelmer Vernooĳ, #701953)
+
+Documentation
+*************
+
+None.
+
+API Changes
+***********
+
+None.
+
+Internals
+*********
+
+None.
+
+Changed Behaviour
+*****************
+
+None.
+
+Testing
+*******
+
+None.
+
 brz 3.0.0
 #########
 

=== modified file 'doc/en/release-notes/brz-3.1.txt'
--- doc/en/release-notes/brz-3.1.txt	2019-03-06 14:23:50 +0000
+++ doc/en/release-notes/brz-3.1.txt	2019-06-03 22:38:47 +0000
@@ -21,12 +21,19 @@
 
 .. New commands, options, etc that users may wish to try out.
 
+ * The 'patch' command is now bundled with brz.
+   Imported from bzrtools by Aaron Bentley. (Jelmer Vernooĳ)
+
 Improvements
 ************
 
 .. Improvements to existing commands, especially improved performance 
    or memory usage, or better results.
 
+* A new ``--commit-message`` option has been added to
+  ``brz propose``, for hosting sites that support it.
+  (Jelmer Vernooĳ)
+
 Bug Fixes
 *********
 

=== modified file 'setup.py'
--- setup.py	2019-03-04 10:39:09 +0000
+++ setup.py	2019-06-02 05:13:10 +0000
@@ -65,6 +65,7 @@
     'install_requires': [
         'configobj',
         'six>=1.9.0',
+        'patiencediff',
         # Technically, Breezy works without these two dependencies too. But there's
         # no way to enable them by default and let users opt out.
         'fastimport>=0.9.8',
@@ -149,8 +150,7 @@
                 script_path = self._quoted_path(os.path.join(scripts_dir,
                                                              "brz"))
                 python_exe = self._quoted_path(sys.executable)
-                args = self._win_batch_args()
-                batch_str = "@%s %s %s" % (python_exe, script_path, args)
+                batch_str = "@%s %s %%*" % (python_exe, script_path)
                 batch_path = os.path.join(self.install_dir, "brz.bat")
                 with open(batch_path, "w") as f:
                     f.write(batch_str)
@@ -164,13 +164,6 @@
             return '"' + path + '"'
         else:
             return path
-
-    def _win_batch_args(self):
-        from breezy.win32utils import winver
-        if winver == 'Windows NT':
-            return '%*'
-        else:
-            return '%1 %2 %3 %4 %5 %6 %7 %8 %9'
 #/class my_install_scripts
 
 
@@ -334,8 +327,6 @@
     add_cython_extension('breezy.bzr._dirstate_helpers_pyx')
     add_cython_extension('breezy._readdir_pyx')
 add_cython_extension('breezy.bzr._chk_map_pyx')
-ext_modules.append(Extension('breezy._patiencediff_c',
-                             ['breezy/_patiencediff_c.c']))
 add_cython_extension('breezy.bzr._btree_serializer_pyx')
 
 

